2008-10-18  Eli Zaretskii  <eliz@gnu.org>

	* fileio.c (Fset_file_modes): Doc fix.

2008-10-18  Martin Rudalics  <rudalics@gmx.at>

	* window.c (Fwindow_width, Fset_window_start)
	(Fwindow_parameters, Fwindow_parameter, Fset_window_parameter)
	(Fdelete_windows_on, Freplace_buffer_in_windows): Make
	doc-strings follow code and Elisp manual more closely.
	(Fwindow_dedicated_p): Make window argument optional.
	(Fset_window_dedicated_p): Rename argument "arg" to "flag".
	(Fset_window_buffer): Respect any non-nil dedicated value for
	window.  Rename "buffer" argument to "buffer_or_name".

2008-10-18  Ulrich Mueller  <ulm@gentoo.org>

	* m/sh3.h: New file, machine description for SuperH.

2008-10-17  Martin Rudalics  <rudalics@gmx.at>

	* window.c (Fsplit_window): Rename arg horflag to horizontal.

2008-10-17  Kenichi Handa  <handa@m17n.org>

	* ftfont.c (ftfont_otf_features): Fix indexing
	gsub_gpos->FeatureList.Feature.  Check the validity of indices.

2008-10-16  Magnus Henoch  <mange@freemail.hu>

	* dbusbind.c (Fdbus_call_method): Unbreak usage line.
	(Fdbus_call_method_asynchronously): Ditto.
	This change makes C-h f display the argument list.

2008-10-16  Chong Yidong  <cyd@stupidchicken.com>

	* fileio.c (Fexpand_file_name): Doc fix.

	* xfaces.c (Finternal_set_lisp_face_attribute): Make null values
	of :foreground and :background equivalent to unspecified (20.x
	compatibility).

2008-10-15  Eli Zaretskii  <eliz@gnu.org>

	* buffer.c (syms_of_buffer): Doc fix.

2008-10-14  Kenichi Handa  <handa@m17n.org>

	* font.c (font_clear_prop): When clearing font width, clear the
	average width field too.

2008-10-12  Andreas Schwab  <schwab@suse.de>

	* ftfont.c (ftfont_shape_by_flt): Make static.
	* ftfont.h (ftfont_shape_by_flt): Don't declare.

	* font.c: Don't include <m17n-flt.h>.

2008-10-10  Eli Zaretskii  <eliz@gnu.org>

	* s/msdos.h (SYSTEM_PURESIZE_EXTRA): Decrease to 10000.

2008-10-09  Eli Zaretskii  <eliz@gnu.org>

	* frame.c (make_terminal_frame) [MSDOS]: Remove unused #ifdef'ed
	away code.

2008-10-09  Chong Yidong  <cyd@stupidchicken.com>

	* dispnew.c (update_text_area): Avoid looping due to large glyph
	overhangs (bug#1070).

2008-10-09  Kenichi Handa  <handa@m17n.org>

	* fontset.c (face_for_char): If face->fontset is negative, just
	return ascii_face.

	* font.c (font_delete_unmatched): Fix previous change.  Don't
	reject an entity if DPI and AVGWIDTH of an entity are 0.

2008-10-09  Martin Rudalics  <rudalics@gmx.at>

	* frame.c (Fraise_frame): On text-only terminals select frame in
	order to make it visible.  (Bug#1061)

2008-10-08  Chong Yidong  <cyd@stupidchicken.com>

	* fontset.c (fontset_find_font): Check frame validity.

2008-10-07  Chong Yidong  <cyd@stupidchicken.com>

	* gtkutil.c (xg_display_open): Reset default display if none
	exists.
	(xg_display_close): Allow Emacs to close all displays (bug#985).

2008-10-06  Andreas Schwab  <schwab@suse.de>

	* sysdep.c (sys_signal): Always set SA_RESTART when
	noninteractively.

2008-10-06  Chong Yidong  <cyd@stupidchicken.com>

	* emacs.c (Vbefore_init_time, Vafter_init_time): Moved from
	startup.el.

	* lisp.h: (Vbefore_init_time, Vafter_init_time): Declare.

	* gtkutil.c (x_wm_set_size_hint): Return immediately if called
	during initialization.

2008-10-04  Eli Zaretskii  <eliz@gnu.org>

	* xdisp.c (redisplay_internal): If frame switched, redisplay the
	whole thing on MSDOS frames as well as on a TTY.

	* dispnew.c (update_frame): Flush termscript for MSDOS frames as
	well as for TTY.
	(Fopen_termscript): Allow opening a termscript on MSDOS frames as
	well as on a TTY.

	* sysdep.c (init_sys_modes): Set FRAME_GARBAGED_P for MSDOS frames
	as well as for TTY.

	* systime.h (EMACS_TIME_CMP): Cast EMACS_SECS values to `long'.

	* dispnew.c (change_frame_size_1): Set FrameRows and FrameCols for
	MSDOS frames as well.

2008-10-02  Adrian Robert  <Adrian.B.Robert@gmail.com>

	* image.c (x_clear_image_1): Under NS, call ns_free_indexed_color with
	correct arguments.
	* menu.c (find_and_return_menu_selection) Add cast.

2008-10-03  Glenn Morris  <rgm@gnu.org>

	* emacs.c (USAGE1): Add --daemon.

2008-10-02  Eli Zaretskii  <eliz@gnu.org>

	* process.c (procfs_system_process_attributes): Multiply `pcpu' by
	100, so it's in percents as advertised.

2008-10-02  Adrian Robert  <Adrian.B.Robert@gmail.com>

	* nsterm.h (ns_cursor_types, ns_output.desired_cursor_color)
	(ns_output.current_cursor, ns_output.desired_cursor)
	(ns_output.last_inactive, FRAME_CURSOR, FRAME_NEW_CURSOR)
	(FRAME_NEW_CURSOR_COLOR): Remove.

	* nsfns.m (ns_set_cursor_color): Use FRAME_CURSOR_COLOR.
	(ns_lisp_to_cursor_type, ns_cursor_type_to_lisp): Use core emacs
	enumeration (HOLLOW_BOX_CURSOR, etc.).

	* nsterm.m (ns_frame_rehighlight): Remove commented code.
	(draw_window_cursor): Simplify code.
	(EmacsView-windowDidBecomeKey:,-windowDidResignKey:): Don't
	change cursor type. In latter, call rehighlight instead of doing
	updates manually.
	(EmacsPrefsController-setPanelFromValues,-setValuesFromPanel): Use
	core emacs cursor types.

	* xdisp.c (draw_glyphs): Don't call notice_overwritten_cursor() under
	NS.

2008-10-02  Martin Rudalics  <rudalics@gmx.at>

	* process.c (Faccept_process_output): Fix doc-string.

2008-10-02  Dan Nicolaescu  <dann@ics.uci.edu>

	* gmalloc.c (__sbrk): Also define for uClibc.

	* s/gnu-linux.h (GNU_LIBRARY_PENDING_OUTPUT_COUNT): Add definition
	for uClibc.

2008-10-01  Adrian Robert  <Adrian.B.Robert@gmail.com>

	* nsfont.m (nsfont_spec_to_traits): Use UnXX masks only for non-normal
	styles.
	(nsfont_open): Reenable the cache.

2008-10-01  Adrian Robert  <Adrian.B.Robert@gmail.com>

	* font.c (font_matching_entity): Reflect ATTRS in font selection.
	(font_find_for_lface) [HAVE_NS]: Don't ignore case.

2008-09-30  Stefan Monnier  <monnier@iro.umontreal.ca>

	* dispnew.c (Fsend_string_to_terminal): Don't try to send a string to
	a suspended terminal.

2008-09-30  Michael Albinus  <michael.albinus@gmx.de>

	* dbusbind.c (xd_signature): Use strcat instead of sprintf.

2008-09-30  Eli Zaretskii  <eliz@gnu.org>

	* Makefile.in (MSDOS_SUPPORT): Remove ccl.elc and codepage.elc.

2008-09-30  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c (move_it_to): Don't advance the iterator if the last tab
	in a continued line coincides with a line beginning.

2008-09-29  Adrian Robert  <Adrian.B.Robert@gmail.com>

	* nsfont.m (nsfont_trait_distance): Fix bug.
	(nsfont_list): Return a list rather than a vector (syncs with Handa
	changes of 2008-05-14).
	(nsfont_open): Improve logging.

2008-09-29  Andreas Schwab  <schwab@suse.de>

	* keyboard.c (syms_of_keyboard) <input-decode-map>: Doc fix.

2008-09-28  Martin Rudalics  <rudalics@gmx.at>

	* character.c (Fchar_resolve_modifiers): Rewrite Elisp function
	name as char-resolve-modifiers.
	Reported by: Markus Triska <markus.triska@gmx.at>

2008-09-28  Dan Nicolaescu  <dann@ics.uci.edu>

	* dispnew.c (init_display): Return earlier when running as a daemon.

2008-09-27  Adrian Robert  <Adrian.B.Robert@gmail.com>

	* nsfont.m (nsfont_draw): Fix up composition rendering (cmp_from, ...).

2008-09-27  Eli Zaretskii  <eliz@gnu.org>

	* composite.c (Fcomposition_get_gstring)
	(Fcompose_region_internal, Fcompose_string_internal)
	(Ffind_composition_internal): Doc fix.
	(syms_of_composite) <compose-chars-after-function>: Doc fix.
	(syms_of_composite) <auto-composition-function>: Doc fix.
	(syms_of_composite) <composition-function-table>: Doc fix.

2008-09-25  Chong Yidong  <cyd@stupidchicken.com>

	* search.c (wordify): New argument for lax word-ends.
	(Fword_search_forward_lax, Fword_search_backward_lax): New funs.

2008-09-24  Dan Nicolaescu  <dann@ics.uci.edu>

	* lisp.h (is_daemon): Declare.
	* dispnew.c (init_display): Do not try to initialize the terminal
	when running as a daemon.

2008-09-22  Chong Yidong  <cyd@stupidchicken.com>

	* nsfns.m (compute_tip_xy): Use x_display_pixel_width and
	x_display_pixel_height.

2008-09-22  Martin Rudalics  <rudalics@gmx.at>

	* undo.c (record_point): Don't call Fundo_boundary for first
	change.  (Bug#731)

2008-09-22  Juanma Barranquero  <lekktu@gmail.com>

	* emacs.c (Fdaemonp): Doc fix.

2008-09-22  Dan Nicolaescu  <dann@ics.uci.edu>

	* emacs.c (main): Place #ifdef in the proper place.

2008-09-21  Dan Nicolaescu  <dann@ics.uci.edu>

	* emacs.c (standard_args): Add --daemon.
	(main): Disconnect from the terminal when --daemon is passed.
	(is_daemon): New variable.
	(Fdaemonp): New function.
	(syms_of_emacs): Defsubr it.

2008-09-20  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c (get_next_display_element): Handle string display
	correctly when checking for the end of a box run.

2008-09-20  Glenn Morris  <rgm@gnu.org>

	* fileio.c (Qdelete_by_moving_to_trash): New Lisp_Object.
	(syms_of_fileio): Add Qdelete_by_moving_to_trash.
	(Frename_file): Avoid copying to trash if a rename involves
	a delete.  (Bug#964).

2008-09-20  Eli Zaretskii  <eliz@gnu.org>

	* keyboard.c (Fset_quit_char, Fset_input_meta_mode)
	(Fset_output_flow_control, Fcurrent_input_mode): Support MSDOS
	frames as well as termcap frames.
	(handle_interrupt): Remove "#ifndef MSDOS" around the call to
	get_named_tty.

2008-09-19  Eli Zaretskii  <eliz@gnu.org>

	* process.c (procfs_system_process_attributes): Fix cmdline in
	case /proc/PID/cmdline is empty.

	* xterm.c (x_wm_set_size_hint): Use x_display_pixel_width and
	x_display_pixel_height.

2008-09-19  Juanma Barranquero  <lekktu@gmail.com>

	* frame.c (x_fullscreen_adjust): Declare var as Display_Info.

	* w32fns.c (Fx_display_pixel_width, Fx_display_pixel_height)
	(compute_tip_xy): Use x_display_pixel_width, x_display_pixel_height.

2008-09-19  Dan Nicolaescu  <dann@ics.uci.edu>

	* dispextern.h (struct it): Move line_wrap away from the middle of
	bitfields.  Move voffset in struct iterator_stack_entry after the
	bitfields.  Move tab_width near after another short.

2008-09-18  Dan Nicolaescu  <dann@ics.uci.edu>

	* frame.h (struct frame): Move alpha from the middle of bitfields.

	* window.h (struct window): Move frozen_window_start_p after the
	rest of the bitfields to reduce padding.

2008-09-18  Chong Yidong  <cyd@stupidchicken.com>

	* xterm.h (x_display_info): Remove `height' and `width' members.

	* nsterm.h (ns_display_info): Remove `height' and `width' members.

	* w32term.h (w32_display_info): Remove `height', `width',
	`height_in', and `width_in' members.

	* xterm.c (x_display_pixel_height, x_display_pixel_width): New
	functions.
	(x_calc_absolute_position): Use them.
	(x_term_init): Omit removed `height' and `width' members.

	* w32term.c (x_display_pixel_height, x_display_pixel_width): New
	functions.
	(w32_read_socket, x_calc_absolute_position): Use them.
	(w32_initialize_display_info, w32_term_init): Omit removed members
	of w32_display_info.

	* nsterm.m (x_display_pixel_height, x_display_pixel_width): New
	functions.
	(ns_initialize_display_info): Omit removed members of
	ns_display_info.

	* xterm.c (x_display_pixel_height, x_display_pixel_width): New
	functions.
	(x_calc_absolute_position): Use them.
	(x_term_init): Omit removed `height' and `width' members.

	* xfns.c (Fx_display_pixel_width, Fx_display_pixel_height)
	(compute_tip_xy): Use x_display_pixel_height and
	x_display_pixel_width.

	* frame.c (x_fullscreen_adjust): Use x_display_pixel_height and
	x_display_pixel_width.

	* xmenu.c (menu_position_func): Use x_display_pixel_height and
	x_display_pixel_width.

2008-09-18  Kenichi Handa  <handa@m17n.org>

	* composite.c (fill_gstring_header): Don't check FROM and TO here.
	(composition_compute_stop_pos): Fix handling of static composition.
	(Fcomposition_get_gstring): Check FROM and TO at first.

2008-09-17  Stefan Monnier  <monnier@iro.umontreal.ca>

	* composite.c (Fcomposition_get_gstring): Yet another int/Lisp_Oject
	mixup (YAILOM).

2008-09-17  Chong Yidong  <cyd@stupidchicken.com>

	* indent.c (Fvertical_motion): Use position reported by iterator
	instead of PT for determining screen motion (bug#943).

2008-09-17  Romain Francoise  <romain@orebokech.com>

	* composite.c (composition_adjust_point): Fix int/EMACS_INT mixup.

2008-09-17  Kenichi Handa  <handa@m17n.org>

	* ftfont.c (ftfont_shape_by_flt): Downcase family name.

	* composite.c (Fcomposition_get_gstring): Make bigger gstring_work
	if necessary.

2008-09-16  Kenichi Handa  <handa@m17n.org>

	* coding.c (make_conversion_work_buffer): Avoid calling
	Fget_buffer_create if it is not necessary.

2008-09-15  Martin Rudalics  <rudalics@gmx.at>

	* window.c (Fselect_window): Don't update window_select_count and
	use_time when norecord is not nil.

2008-09-14  Kenichi Handa  <handa@m17n.org>

	* fileio.c (Finsert_file_contents): Delete incorrect decrement of
	specpdl_ptr.

2008-09-12  Kenichi Handa  <handa@m17n.org>

	* indent.c (scan_for_column): Don't handle automatic composition
	if the current buffer is not associated with a window.

	* composite.c (composition_reseat_it): If the current buffer is
	not associated with a window, ignore the automatic composition.
	(find_automatic_composition): Likewise.

2008-09-12  Stefan Monnier  <monnier@iro.umontreal.ca>

	* term.c (close_gpm): New fun extracted from Fgpm_mouse_stop.
	(Fgpm_mouse_stop): Use it.
	* termhooks.h (close_gpm): Declare.
	* keyboard.c (tty_read_avail_input): Forcefully close the gpm
	connection if Gpm_GetEvent fails.

	* window.c (set_window_buffer): Always preserve current-buffer.

2008-09-12  Glenn Morris  <rgm@gnu.org>

	* charset.c (init_charset): Warn if etc/charsets not found.  (Bug#909)

2008-09-11  Glenn Morris  <rgm@gnu.org>

	* charset.c (charset-map-path): Doc fix.

2008-09-10  Kenichi Handa  <handa@m17n.org>

	* xdisp.c (handle_composition_prop): Set it->cmp_it.ch to -1.

	* font.c (Ffont_shape_gstring): Make glyphs of non-nil adjustment
	compose a grapheme cluster with the preceding base glyph.

	* composite.c (composition_compute_stop_pos): Fix previous change.
	Reset cmp_it->id to -1 at first.

2008-09-10  Glenn Morris  <rgm@gnu.org>

	* Makefile.in (character.o, chartab.o): Fix config.h typo.

2008-09-09  Chong Yidong  <cyd@stupidchicken.com>

	* keyboard.c (read_key_sequence): Reapply translation maps when
	switching keyboards.

2008-09-09  Kenichi Handa  <handa@m17n.org>

	* ftfont.c (ftfont_shape_by_flt): Use "combining" FLT for ASCII
	characters.

	* composite.c (FORWARD_CHAR): Fix calculation
	of (POSITION).pos_byte.
	(composition_compute_stop_pos): Limit the search of composition to
	at most 500 characters ahead.  If we reach the limit or find a
	newline, set cmp_it->ch to -2 and return 0.
	(composition_reseat_it): Handle the case that cmp_it->ch is -2.

2008-09-08  Kenichi Handa  <handa@m17n.org>

	* indent.c (Fvertical_motion): Be sure to set
	it_overshoot_expected if it.cmp_it.id is non-negative.

2008-09-07  Andreas Schwab  <schwab@suse.de>

	* callproc.c (Fcall_process): Don't hold references to string data
	across garbage collection.  Move initialisation of new_argv down
	to avoid compiler bug.

2008-09-07  Roland Winkler  <Roland.Winkler@physik.uni-erlangen.de>

	* process.c (Fsystem_process_attributes): Doc fix.

2008-09-07  Chong Yidong  <cyd@stupidchicken.com>

	* callproc.c (Fcall_process): Canonicalize current directory name.

	* xdisp.c (move_it_to): When moving by vpos, ensure that the
	iterator advances to the next line if the current line ends in a
	continued tab.

2008-09-07  Teodor Zlatanov  <tzz@lifelogs.com>

	* nsfont.m (nsfont_draw): Fix the references to missing gidx data
	member to point to cmp_from.

	* xdisp.c: Doc fix for references to gidx data member.

2008-09-07  Stefan Monnier  <monnier@iro.umontreal.ca>

	* buffer.c (Fbuffer_swap_text): Reset window->point markers.

2008-09-07  Kenichi Handa  <handa@m17n.org>

	* composite.c (FORWARD_CHAR): Check STOP after
	incrementing (POSITION).pos.

2008-09-06  Roland Winkler  <Roland.Winkler@physik.uni-erlangen.de>

	* process.c (Fsystem_process_attributes): Doc fix.

2008-09-06  Chong Yidong  <cyd@stupidchicken.com>

	* keyboard.c (Ftop_level): Doc fix.

2008-09-06  Eli Zaretskii  <eliz@gnu.org>

	* xmenu.c (xmenu_show) [!HAVE_X_WINDOWS]: If frame has a
	minibuffer, don't let lower part of menu invade the echo area.

	* msdos.c (IT_menu_display): Use STRING_CHAR_ADVANCE instead of a
	"char *q" to access menu text and advance through it.  Revert the
	change that displayed ">" instead of ASCII character 0x10.

2008-09-05  Eli Zaretskii  <eliz@gnu.org>

	* menu.c (single_menu_item) [!HAVE_BOXES]: Enable emulation of
	toggle boxes and radio buttons on MS-DOS as well.

2008-09-05  Kenichi Handa  <handa@m17n.org>

	* composite.c (autocmp_chars): Check lookback count.
	(composition_compute_stop_pos): Set cmp_it->lookback.
	(composition_reseat_it): Check lookback count.
	(struct position_record): New struct.
	(FORWARD_CHAR, BACKWARD_CHAR, CHAR_COMPOSABLE_P): New macros.
	(find_automatic_composition): New function.
	(composition_adjust_point): Use find_automatic_composition.

	* dispextern.h (struct composition_it): New member lookback.

2008-09-02  Chong Yidong  <cyd@stupidchicken.com>

	* indent.c (Fvertical_motion): Don't call move_it_by_lines again
	if moving by a single line.

2008-09-02  Andreas Schwab  <schwab@suse.de>

	* xterm.c (x_delete_display): Fix merge error.

	* fileio.c (Fexpand_file_name): Remove unused variables.

2008-09-02  Eli Zaretskii  <eliz@gnu.org>

	* fileio.c (Fexpand_file_name): Copy argument `name' into local
	storage on all platforms, not just on DOS_NT.

2008-09-02  Jason Rumney  <jasonr@gnu.org>

	* w32menu.c (Fx_popup_menu, Fx_popup_dialog, w32_menu_show): Ensure
	mouse is not grabbed after menu is finished.

2008-09-01  Chong Yidong  <cyd@stupidchicken.com>

	* xfaces.c (Finternal_set_alternative_font_family_alist)
	(Finternal_set_alternative_font_registry_alist): Properly copy
	entire alist structure.

2008-09-01  Kenichi Handa  <handa@m17n.org>

	* ftfont.c (ftfont_spec_pattern): Don't create a charset of the
	representative chars of the script is a vector.
	(ftfont_list): Handle the case the representative chars of the
	script is a vector.

	* character.c (syms_of_character): Docstring of
	script-representative-chars fixed.

2008-08-31  Eli Zaretskii  <eliz@gnu.org>

	* msdos.c (BUILD_CHAR_GLYPH): New macro.
	(IT_menu_display): Use it instead of SET_CHAR_GLYPH to construct
	the menu.  Allocate larger buffer for `text', to account for
	possible ^C characters.

2008-08-31  Martin Rudalics  <rudalics@gmx.at>

	* xdisp.c (prepare_menu_bars): Don't call
	Vwindow_size_change_functions with arg Qt.

2008-08-31  Stefan Monnier  <monnier@iro.umontreal.ca>

	* font.h (font_range):
	* fileio.c (report_file_error):
	* composite.c (composition_update_it): Yet another int/Lisp_Oject mixup.

2008-08-30  Glenn Morris  <rgm@gnu.org>

	* data.c (Fmake_variable_frame_local): Doc fix.

	* frame.c (Fmodify_frame_parameters): Doc fix.

2008-08-30  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (init_user_info): Allocate buf[] with xmalloc using the size
	needed by GetTokenInformation.
	(w32_system_process_attributes): Check return values of all system
	APIs.

	* msdos.c (IT_display_cursor): Write "CURSOR ON/OFF" to termscript
	only when the state changes.
	(IT_update_begin, IT_update_end): Add termscript trace.

	* w16select.c (Fw16_set_clipboard_data): Don't encode text if
	clipboard is unavailable.  Set dst to NULL if it doesn't point to
	malloc'ed data.
	(Fw16_get_clipboard_data): Initialize htext to NULL, to avoid
	passing random values to xfree.

	* dispnew.c (init_display): Set `tty's association in frame's
	parameters alist to the name of the terminal device, if that is
	known.

2008-08-29  Jason Rumney  <jasonr@gnu.org>

	* w32uniscribe.c (uniscribe_check_otf): Don't fallback on DFLT script.

2008-08-29  Eli Zaretskii  <eliz@gnu.org>

	* composite.c (fill_gstring_body): Avoid compiler warnings.

	* font.c (font_fill_lglyph_metrics): Use EMACS_INT in
	LGLYPH_SET_CODE to avoid compiler warnings.

	* makefile.w32-in ($(BLD)/w32uniscribe.$(O)): Depend on composite.h

	* composite.h (LGLYPH_SET_CODE): Cast `val' to EMACS_INT.

	* w32uniscribe.c (uniscribe_shape): Shut up compiler warning in
	LGLYPH_SET_CODE.

2008-08-29  Kenichi Handa  <handa@m17n.org>

	* fileio.c (report_file_error): Don't downcase the first character
	of errstring if it is still unibyte.

2008-08-29  Kenichi Handa  <handa@m17n.org>

	These changes are to re-implement the automatic composition so
	that it doesn't use text properties.

	* Makefile.in (ftfont.o): Depend on composite.h.
	(composite.o): Depend dispextern.h, font.h, frame, and window.h.

	* character.h (Vunicode_category_table): Extern it.

	* character.c (Vunicode_category_table): New variable.
	(syms_of_character): DEFVAR_LISP Vunicode_category_table.

	* chartab.c (optimize_sub_char_table): Perform more greedy
	optimization.

	* composite.h (enum composition_method): Delete
	COMPOSITION_WITH_GLYPH_STRING.
	(COMPOSITION_METHOD): Don't check COMPOSITION_WITH_GLYPH_STRING.
	(Vcomposition_function_table): Extern it.
	(LGSTRING_XXX, LGLYPH_XXX): Macros moved from font.h.
	(composition_gstring_put_cache, composition_gstring_from_id)
	(composition_gstring_p, composition_gstring_width)
	(composition_compute_stop_pos, composition_reseat_it)
	(composition_update_it, composition_adjust_point): Extern them.
	(Fcomposition_get_gstring): EXFUN it.

	* composite.c: Include window.h, frame.h, dispextern.h font.h.
	(Vcomposition_function_table)
	(get_composition_id): Don't handle COMPOSITION_WITH_GLYPH_STRING.
	(gstring_hash_table, gstring_work, gstring_work_headers): New
	variables.
	(gstring_lookup_cache, composition_gstring_put_cache)
	(composition_gstring_from_id, composition_gstring_p)
	(composition_gstring_width, fill_gstring_header)
	(fill_gstring_body, autocmp_chars, composition_compute_stop_pos)
	(composition_reseat_it, composition_update_it)
	(composition_adjust_point, Fcomposition_get_gstring): New
	functions.
	(syms_of_composite): Initialize gstring_hash_table, gstrint_work,
	and gstring_work_headers.  DEFVAR_LISP composition-function-table.
	Defsubr compostion_get_gstring.

	* dispextern.h (struct glyph): New union u.cmp.  Delete the member
	cmp_id.
	(struct glyph_string): Delete the member gidx.  New members
	cmp_id, cmp_from, and cmp_to.
	(enum it_method): Delete GET_FROM_COMPOSITION.
	(struct composition_it): New struct.
	(struct it): New member cmp_it, and iterator_stack_entry.cmp_it.
	Delete c, len, cmp_id, cmp_len in u.comp.

	* font.h (enum lgstring_indices): Delete it.
	(LGSTRING_XXX, LGLYPH_XXX): These macros moved to composite.h.
	(enum lglyph_indices): Likewise.
	(font_range): Extern adjusted.
	(font_fill_lglyph_metrics): Extern it.

	* font.c (QCf): New variable.
	(check_gstring): Use LGSTRING_GLYPH_LEN, not LGSTRING_LENGTH.
	(font_prepare_composition): Delete this function.
	(font_range): Type and arguments changed.
	(Ffont_make_gstring, Ffont_fill_gstring): Delete them.
	(font_fill_lglyph_metrics): New function.
	(Ffont_shape_text): Renamed to Ffont_shape_gstring and arguments
	changed.
	(syms_of_font): DEFSYM QCf.  Delete defsubr for
	Sfont_make_gstring, Sfont_fill_gstring, Sfont_shape_text.  Defsubr
	Sfont_shape_gstring.

	* fontset.h (font_for_char): Extern it.

	* fontset.c (font_for_char): New function.

	* ftfont.c: Include composite.h.
	(ftfont_resolve_generic_family): Add langset "en" to pattern.
	(ftfont_shape_by_flt): Use LGSTRING_GLYPH_LEN, not
	LGSTRING_LENGTH.

	* indent.c: Include composite.h and dispextern.h.
	(check_composition): Delete this function.
	(scan_for_column): Handle composition by
	composition_compute_stop_pos, composition_reseat_it, and
	composition_update_it.
	(compute_motion): Likewise.
	(Fvertical_motion): Fix checking of composition.

	* keyboard.c (adjust_point_for_property): Check composition by
	composition_adjust_point.

	* nsterm.m (ns_draw_glyph_string): Adjusted for the change of
	struct glyph_string.

	* term.c (encode_terminal_code): Adjusted for the change of struct
	glyph.
	(append_composite_glyph): Adjusted for the change of struct it and
	struct glyph.
	(produce_composite_glyph): Likewise.

	* w32term.c (x_draw_composite_glyph_string_foreground): Adjusted
	for the change of struct glyph_string.
	(x_draw_glyph_string): Likewise.

	* w32uniscribe.c (struct uniscribe_font_info): Include composite.h.
	(uniscribe_shape): Use LGSTRING_GLYPH_LEN, not LGSTRING_LENGTH.

	* xdisp.c: Include font.h.
	(it_props): Delete the entry for Qauto_composed.
	(init_iterator): Initialize it->cmp_it.id to -1.
	(compute_stop_pos): Call composition_compute_stop_pos.
	(face_before_or_after_it_pos): Adjusted for the change of struct
	it.
	(handle_auto_composed_prop): Delete it.
	(handle_composition_prop): Handle only static composition.
	(next_overlay_string): Remove it->method == GET_FROM_COMPOSITION
	from xassert.  Initialize it->cmp_it.stop_pos.
	(push_it): Adjusted for the change of struct it.
	(pop_it): Likewise.
	(get_next_element): Delete next_element_from_composition.
	(CHAR_COMPOSED_P): New macro.
	(get_next_display_element): For automatic composition, get a face
	from the font in the glyph-string.
	(set_iterator_to_next): For GET_FROM_BUFFER and GET_FROM_STRING,
	check composition by it->cmp_it.id.  Delete GET_FROM_COMPOSITION
	case.
	(next_element_from_string): Check if the character at the current
	position is composed by CHAR_COMPOSED_P.
	(next_element_from_buffer): Likewise.
	(next_element_from_composition): Adjusted for the change of struct
	it.  Update it->cmp_it.
	(dump_glyph): Adjusted for the change of struct glyph.
	(fill_composite_glyph_string): Adjusted for the change of struct
	it and struct glyph.  Don't handle automatic composition here.
	(fill_gstring_glyph_string): New function.
	(x_get_glyph_overhangs): Handle automatic composition.
	(BUILD_COMPOSITE_GLYPH_STRING): Adjusted for the change of struct
	glyph.
	(BUILD_GSTRING_GLYPH_STRING): New macro.
	(BUILD_GLYPH_STRINGS): Call BUILD_GSTRING_GLYPH_STRING for
	automatic composition.
	(append_composite_glyph): Adjusted for the change of struct it and
	struct glyph.
	(x_produce_glyphs): Adjusted for the change of struct it.

	* xterm.c (x_draw_composite_glyph_string_foreground): Adjusted for
	the change of struct glyph_string.
	(x_draw_glyph_string): Likewise.

2008-08-29  Glenn Morris  <rgm@gnu.org>

	* buffer.c (word-wrap): Doc fix.
	* xdisp.c (truncate-partial-width-windows): Doc fix.
	Increase default to 50.

2008-08-29  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c (update_tool_bar_unwind): New function.
	(update_tool_bar): Temporarily set selected frame before building
	tool-bar items.

2008-08-28  Michael Albinus  <michael.albinus@gmx.de>

	* dbusbind.c (XD_ERROR, XD_DEBUG_MESSAGE): Use strncpy and
	snprintf, respectively.
	(xd_append_arg): Convert strings with Fstring_make_unibyte.

2008-08-28  Chong Yidong  <cyd@stupidchicken.com>

	* Makefile.in: Revert (undocumented) 2008-08-20 change adding
	LDFLAGS to GNUstep CC invocation.

2008-08-27  Chong Yidong  <cyd@stupidchicken.com>

	* indent.c (Fvertical_motion): Revert last change.  Handle the
	general case where we are moving forward, and PT spans multiple
	screen lines.

	* eval.c (find_handler_clause): Temporarily increase
	max-lisp-eval-depth while printing the backtrace buffer, to
	guarantee that help-mode code can run.

2008-08-27  Eli Zaretskii  <eliz@gnu.org>

	* msdos.c (Fmsdos_remember_default_colors): Don't reverse frame
	colors under -rv.
	(IT_set_frame_parameters): Don't swap foreground and background
	colors if `(reverse . t)' is present in the frame properties.
	(internal_terminal_init): Call init_frame_faces only for the
	initial frame.

2008-08-27  Andreas Schwab  <schwab@suse.de>

	* dired.c (Ffile_attributes): Avoid compiler warning in bitshift.

2008-08-27  Andreas Schwab  <schwab@suse.de>

	* search.c (search_buffer): Set char_base to zero only at the end.

2008-08-27  Kenichi Handa  <handa@m17n.org>

	* fileio.c (report_file_error): Fix handling of multibyte error
	string.

2008-08-27  Andreas Seltenreich  <seltenreich@gmx.de>

	* xterm.c (x_term_init): Temporarily hide the partially
	initialized terminal while calling vendor-specific-keysyms.

2008-08-26  Eli Zaretskii  <eliz@gnu.org>

	* msdos.c (internal_terminal_init): Most initializations done only
	once, especially initial_screen_colors[] and termscript open.

2008-08-26  Chong Yidong  <cyd@stupidchicken.com>

	* eval.c (Fcondition_case): Doc fix.

	* widgetprv.h (EmacsFramePart): Change font member to the new font
	struct.

	* widget.c: Include character.h and font.h for XSETFONT.
	(setup_frame_gcs): Compute X font id from font struct, just once.

2008-08-26  Eli Zaretskii  <eliz@gnu.org>

	* term.c (get_named_tty): Fix last change.

2008-08-26  Chong Yidong  <cyd@stupidchicken.com>

	* indent.c (Fvertical_motion): If moving forward starting from a
	multi-line string, move the iterator to the last line of that
	string.

2008-08-25  Eli Zaretskii  <eliz@gnu.org>

	* frame.c (do_switch_frame): Mark previously displayed frame as
	obscured for FRAME_MSDOS_P frames as well.

2008-08-24  Eli Zaretskii  <eliz@gnu.org>

	* frame.c (make_terminal_frame): Initialize f->terminal,
	f->terminal->reference_count, and scroll bars on MS-DOS as well.
	Set the top frame to newly created frame.
	(Fmake_terminal_frame): Reuse the_only_display_info.

	* vm-limit.c (get_lim_data) [MSDOS]: Use alternative methods of
	estimating available memory.

2008-08-23  David Reitter <david.reitter@gmail.com>

	* nsterm.m (ns_draw_window_cursor): Don't call
	NSDisableScreenUpdates and NSEnableScreenUpdates on
	non-NS_IMPL_COCOA systems.

2008-08-23  Andreas Schwab  <schwab@suse.de>

	* process.c (procfs_system_process_attributes): Fix use of
	uninitialized variables.

2008-08-23  Eli Zaretskii  <eliz@gnu.org>

	* emacs.c (main) [MSDOS]: Call syms_of_xmenu.

	* dispnew.c (init_display): Remove MS-DOS specific conditions for
	calling tty-set-up-initial-frame-faces.

	* xmenu.c (Fx_popup_dialog, Fx_popup_menu, xmenu_show): Allow
	MSDOS frames along with X frames.

	* termhooks.h (TERMINAL_ACTIVE_P): Handle output_msdos_raw in
	addition to output_termcap.

	* xdisp.c (redisplay_internal) [MSDOS]: Don't call set_tty_color_mode.

	* termchar.h (FRAME_TTY): Support output_msdos_raw.
	(struct tty_display_info) [MSDOS]: Add fields related to mouse
	highlight.

	* process.c [!subprocesses]: Define QCname.
	(syms_of_process): Intern and staticpro it.

	* w16select.c (Fw16_set_clipboard_data, Fw16_get_clipboard_data):
	Adjust for changes in encoding/decoding routines.  Use
	encode_coding_object and decode_coding_object instead of
	encode_coding and decode_coding.

	* sysdep.c (init_sys_modes): Call dos_ttraw with tty_out as
	argument.

	* dosfns.c: Include frame.h before termhooks.h.
	(dos_cleanup): Use CURTTY ()->termscript instead of a global
	variable termscript.

	* s/msdos.h (USER_FULL_NAME): Define.
	(SYSTEM_PURESIZE_EXTRA): Bump up to 100K.

	* editfns.c (USER_FULL_NAME): Define to pw->pw_gecos if undefined.
	(Fuser_full_name): Use USER_FULL_NAME instead of a literal
	pw->pw_gecos.

	* keyboard.c (handle_interrupt) [MSDOS]: Call cursor_to with
	SELECTED_FRAME as additional (1st) argument.
	(tty_read_avail_input): Handle output_msdos_raw in
	addition to output_termcap.

	* msdos.c: Include frame.h before termhooks.h.
	(mouse_on, mouse_off, mouse_moveto, mouse_init)
	(msdos_set_cursor_shape, IT_set_face, IT_write_glyphs)
	(show_mouse_face, IT_clear_end_of_line, IT_clear_screen)
	(IT_clear_to_end, IT_cursor_to, IT_display_cursor, IT_cmgoto)
	(IT_set_terminal_modes, IT_reset_terminal_modes)
	(IT_set_frame_parameters): Use tty->termscript instead of a global
	variable termscript.
	(IT_write_glyphs): Use tty->terminal->terminal_coding instead of a
	global variable terminal_coding.  Don't refer to
	Vnonascii_translation_table.
	(internal_terminal_init): Set Vwindow_system in current_kboard.
	Don't use TTY_CHAR_INS_DEL_OK.  Set Vinitial_window_system.
	Announce date and time of session start, if termscript is open.
	Don't zero out the_only_display_info (it is done in
	term.c:init_tty).  Open termscript only of not already open.  Log
	"SCREEN SAVED" here, instead of IT_set_terminal_modes.  Init mouse
	here instead of dos_ttraw.  Don't initialize display if this is an
	initial tty.  Don't set FRAME_FONT.
	(Vwindow_system_version): Bump to 23.
	(dos_ttraw): Accept a TTY argument; all callers fixed.  If mouse
	is available, set up mouse_position_hook.
	(dos_ttraw, IT_set_terminal_modes): If called with initial
	terminal, do nothing.
	(IT_set_frame_parameters): Handle the Qtty_type frame
	parameter by calling internal_terminal_init.
	(dos_set_window_size, show_mouse_face)
	(clear_mouse_face, IT_note_mode_line_highlight)
	(IT_note_mouse_highlight, IT_update_begin, IT_frame_up_to_date)
	(dos_rawgetc): Use tty_display_info instead of x_display_info.
	(initialize_msdos_display): New function.
	(IT_cursor_to, IT_clear_to_end, IT_clear_screen)
	(IT_clear_end_of_line, IT_insert_glyphs, IT_write_glyphs)
	(IT_delete_glyphs, IT_ring_bell, IT_reset_terminal_modes)
	(IT_set_terminal_modes, IT_set_terminal_window, IT_update_begin):
	Accept additional argument: a pointer to a frame.  All callers
	changed.
	(request_sigio, unrequest_sigio): Don't define, now defined on
	sysdep.c.
	(IT_write_glyphs): Rewrite to use encode_terminal_code.

	* term.c [MSDOS]: Include msdos.h.
	(init_tty) [MSDOS]: Reuse most of WINDOWSNT branch.  Change cpp
	conditional to DOS_NT.  Allow only one call to this function in a
	session.  Don't allocate a new struct tty_display_info; instead,
	reuse the_only_display_info.  Call get_tty_size to get screen
	dimensions.  Call init_baud_rate to set bad_rate.
	(dissociate_if_controlling_tty) [MSDOS]: Ifdef away function body.
	(Fsuspend_tty) [MSDOS]: Don't close input and output.
	(Fresume_tty) [MSDOS]: Don't reopen the TTY; instead, use
	stdin/stdout.
	(get_tty_terminal, get_named_tty, Ftty_type)
	(Fcontrolling_tty_p): Handle output_msdos_raw in addition to
	output_termcap.
	(Fresume_tty, Fsuspend_tty, init_tty, delete_tty): Call
	add_keyboard_wait_descriptor and delete_keyboard_wait_descriptor
	only when subprocesses are supported

	* frame.c (make_terminal_frame) [MSDOS]: Adjust initialization of
	f->output_data.x.
	(Fmake_terminal_frame) [MSDOS]: Don't allow creation of new
	terminal devices.

	* msdos.h Remove definition of struct x_display_info and struct
	x_output.
	(FRAME_FONT): Use output_data.tty.
	(FRAME_FOREGROUND_PIXEL, FRAME_BACKGROUND_PIXEL): Don't define.
	(struct x_display_info): Renamed from display_info.  All users in
	msdos.c changed.
	(struct x_output): Remove background_pixel and foreground_pixel.
	(the_only_display_info): Renamed from the_only_x_display.
	(dos_ttraw): Update prototype.

	* Makefile.in (MSDOS_OBJ): Add xmenu.o.
	(SOME_MACHINE_LISP): Add ../lisp/term/pc-win.elc.

2008-08-23  Jason Rumney  <jasonr@gnu.org>

	* image.c (enum tiff_keyword_index, tiff_format): Add :index keyword.
	(fn_TIFFSetDirectory): New library function used.
	(init_tiff_functions) [HAVE_NTGUI]: Initialize it.
	(tiff_load): Use :index to select among multiple images.  Set count
	property when multiple images exist.
	(gif_format): Use :index, not :image.

2008-08-23  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c (try_scrolling): Check INT_MAX instead of
	MOST_POSITIVE_FIXNUM for maximum integer value.  Include limits.h
	to obtain INT_MAX.

2008-08-21  İsmail Dönmez  <ismail@namtrac.org>  (tiny change)

	* xterm.c (x_delete_display): Don't call XrmDestroyDatabase on GTK+.

2008-08-21  Christian Faulhammer  <opfer@gentoo.org>  (tiny change)

	* Makefile.in (temacs${EXEEXT}): On GNUstep, link to appropriate
	GNUstep library location.

2008-08-21  Chong Yidong  <cyd@stupidchicken.com>

	* xfaces.c (x_update_menu_appearance): Check validity of menu font
	before using it.

	* puresize.h (BASE_PURESIZE): Increase to 1250000.

2008-08-20  Adrian Robert  <Adrian.B.Robert@gmail.com>

	* nsfns.m (ns-read-file-name): Add casts to avoid warning.
	(ns-convert-utf8-nfd-to-nfc): Warn if cannot execute correctly.
	* nsfont.m (nsfont_draw): Compare indexed colors to 0, not nil.
	* nsterm.h (EmacsView-unlockFocusNeedsFlush:): Add declaration.
	(EmacsApp-cursor_blink_handler): Remove declaration.
	* nsterm.m (ns_draw_glyph_string): Update first conditional body to
	match 01 Feb 2008 changes in xterm.c.
	(ns_read_socket): Add cast to avoid warning.
	(EmacsApp-application:openFiles:): Don't call replyToOpenOrPrint: on
	GNUstep.

2008-08-20  Chong Yidong  <cyd@stupidchicken.com>

	* xselect.c (x_get_foreign_selection): Return nil if desired
	selection could not be obtained, instead of signalling an error.

2008-08-20  David Reitter  <david.reitter@gmail.com>

	* nsfns.m (ns_lisp_to_cursor_type): Replace with generic xfns.c.
	* nsterm.m: Remove ns-specific code for cursor blinking.
	(ns_draw_window_cursor): Clear cursor properly rather than
	redrawing the area.  Respect width of bar cursors.
	These changes enable the use of generic blink-cursor-mode and
	generic cursor types in NS and support smooth cursor movements (do
	not blink off after command).
	* xdisp.c (get_phys_cursor_geometry): Redraw wider rectangle on
	Nextstep, too.

2008-08-19  Kenichi Handa  <handa@m17n.org>

	* font.c (Vfont_log_deferred): New variable.
	(font_add_log): Check Vfont_log_deferred.
	(font_deferred_log): New function.

	* font.h (font_deferred_log): Extern it.

	* fontset.c (reorder_font_vector): Use encoding charset of fonts
	for sorting.
	(face_for_char): Use deferred log.

2008-08-18  Kenichi Handa  <handa@m17n.org>

	* fontset.c (face_for_char): Add font log.

	* font.c (font_add_log): Add the font properties :script, :lang,
	and :otf in the log.

2008-08-17  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c: Remove dead code.
	(handle_invisible_prop, next_overlay_string): Defer call to
	setup_for_ellipsis.
	(handle_stop, set_iterator_to_next): Call setup_for_ellipsis.

2008-08-15  Chong Yidong  <cyd@stupidchicken.com>

	* xfaces.c (lookup_derived_face): Properly handle possible zero
	return value of get_lface_attributes.
	(merge_faces): Don't tell lookup_derived_face to signal an error
	if face is not found.

	* dired.c (Fdirectory_files): Doc fix.

	* process.c (make_process): Initialize kill_without_query struct
	member.

2008-08-15  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (w32_system_process_attributes) [_MSC_VER < 1300]:
	Alternative calculation of totphys for Visual Studio 6.

	* w32fns.c [_MSC_VER && _MSC_VER < 1300]: Declare HMONITOR.

	* w32.c (_MEMORY_STATUS_EX, MEMORY_STATUS_EX, LPMEMORY_STATUS_EX):
	Rename from _MEMORYSTATUSEX, MEMORYSTATUSEX, LPMEMORYSTATUSEX.
	All users changed.
	(stat): Only root directory passed to GetDriveType.  Allow RAM
	disk as well as local fixed disk when w32-get-true-file-attributes
	is set to `local'.
	(CopySid_Proc, EqualSid_Proc, GetLengthSid_Proc): New typedefs.
	(equal_sid, get_length_sid, copy_sid): New wrapper functions.
	(w32_cached_id, w32_add_to_cache): New functions.
	(get_name_and_id): Look account names in the cache before calling
	lookup_account_sid.
	(g_b_init_get_length_sid, g_b_init_equal_sid, g_b_init_copy_sid):
	New initialization flags.
	(globals_of_w32): Initialize them to zero.
	(w32_system_process_attributes): Use w32_cached_id and
	w32_add_to_cache.

2008-08-14  Lawrence Mitchell  <wence@gmx.li>

	* lread.c (Fread_char, Fread_char_exclusive): If no character
	event is read before timeout is reached, return nil, rather than
	converting to a number.

2008-08-14  Chong Yidong  <cyd@stupidchicken.com>

	* fns.c (use_dialog_box): Doc fix.

	* s/darwin.h: Undefine HAVE_RES_INIT, which appears to be harmful
	on OS X.

2008-08-13  Chong Yidong  <cyd@stupidchicken.com>

	* frame.c (Qns_parse_geometry): New var.
	(Fx_parse_geometry): For HAVE_NS, call ns-parse-geometry.

2008-08-11  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c (x_produce_glyphs): Handle the case when font has no
	space character in calculating tabs.

2008-08-11  Dan Nicolaescu  <dann@ics.uci.edu>

	* Makefile.in (bootstrap-emacs): Use ln -f in the CANNOT_DUMP case.

2008-08-10  Glenn Morris  <rgm@gnu.org>

	* process.c (procfs_system_process_attributes): Use EMACS_INTs to
	silence gcc "limited range of data type" warnings in some
	make_fixnum_or_float calls.

2008-08-09  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (w32_system_process_attributes): If the process does not
	exist, return nil.

	* w32.c: Include thelp32.h, psapi.h and coding.h.
	(_MEMORYSTATUSEX, _PROCESS_MEMORY_COUNTERS_EX): New struct
	declarations.
	(CreateToolhelp32Snapshot_Proc, Process32First_Proc)
	(Process32Next_Proc): New typedefs.
	(g_b_init_create_toolhelp32_snapshot, g_b_init_process32_first)
	(g_b_init_process32_next, g_b_init_open_thread_token)
	(g_b_init_impersonate_self, g_b_init_revert_to_self)
	(g_b_init_get_process_memory_info, g_b_init_global_memory_status)
	(g_b_init_get_process_working_set_size)
	(g_b_init_global_memory_status_ex): New static variables.
	(globals_of_w32): Initialize them.
	(create_toolhelp32_snapshot, process32_first, process32_next)
	(open_thread_token, impersonate_self, revert_to_self)
	(get_process_memory_info, get_process_working_set_size)
	(global_memory_status, global_memory_status_ex): New wrapper
	functions.
	(w32_list_system_processes, w32_system_process_attributes)
	(enable_privilege, restore_privilege, ltime, process_times):
	New functions.
	(convert_time_raw): New function.
	(convert_time): Remove conversion of FILETIME into time in 100
	nsec units, call convert_time_raw instead.

	* process.h (w32_list_system_processes, w32_system_process_attributes):
	Add prototypes.
	(Qeuid, Qegid, Qcomm, Qstate, Qppid, Qpgrp, Qsess, Qttname)
	(Qminflt, Qmajflt, Qcminflt, Qcmajflt, Qutime, Qstime, Qcutime)
	(Qpri, Qnice, Qthcount, Qstart, Qvsize, Qrss, Qargs, Quser, Qgroup)
	(Qetime, Qpcpu, Qpmem, Qtpgid, Qcstime): Add extern declarations.

	* process.c (Fsystem_process_attributes): Doc fix.

2008-08-08  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c (move_it_to): When stopping at a charpos, check if that's
	a continued multi-char glyph; if so, advance to the actual glyph.

2008-08-07  Dan Nicolaescu  <dann@ics.uci.edu>

	* s/darwin.h (OTHER_FILES): Do not define here, defined in config.in.

	* Makefile.in (ALL_OBJC_CFLAGS): New variable.
	(.m.o): Use it.
	* config.in: Regenerate.

2008-08-07  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c (redisplay_window): Revert last change.
	(try_window): Check bottom scroll margin too.

2008-08-06  Adrian Robert  <Adrian.B.Robert@gmail.com>

	* config.in: Regenerate.

	* Makefile.in (emacs): Remove ifndef NS conditional for 'emacs
	-list-load-path-shadows'.
	(nsgui.h): Reduce number of things depending on it.

2008-08-06  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c (try_scrolling): Use iterator to find the scroll margin,
	instead of window-end which does the wrong thing at eob.
	(try_cursor_movement): Minor optimization.
	(redisplay_window): If scroll margin is defined, don't assume
	window doesn't need scrolling.

2008-08-06  Adrian Robert  <Adrian.B.Robert@gmail.com>

	* config.in: Regenerate.

	* Makefile.in: Move nsXXX.m dependencies into big alphabetical list.
	(mostlyclean): Don't delete *.d under NS.

	* nsterm.h (NS_HAVE_INTEGER): Change to NS_HAVE_NSINTEGER.

2008-08-06  Kenichi Handa  <handa@m17n.org>

	* xfont.c (xfont_list_family): Return a list of symbols, not strings.

2008-08-06  Andreas Schwab  <schwab@suse.de>

	* config.in: Regenerate.

2008-08-05  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c (redisplay_window): Don't enforce scroll-margin when
	forcing a window start.

	* fileio.c (Vauto_save_list_file_name): Move here from file.el.
	(auto_save_1): Update modtime when auto-save-list-file-name is on.

2008-08-04  Adrian Robert  <Adrian.B.Robert@gmail.com>

	* emacs.c (main): Under NS, set working dir to HOME when get a "psn"
	argument.

2008-08-05  Juanma Barranquero  <lekktu@gmail.com>

	* buffer.c (syms_of_buffer) <scroll-up-aggressively>:
	<scroll-down-aggressively, before-change-functions>:
	<after-change-functions>: Reflow docstrings.

2008-08-04  Adrian Robert  <Adrian.B.Robert@gmail.com>
	    Ken Raeburn  <raeburn@gnu.org>

	Dock menu customization, based on a patch by Ken Raeburn, plus some
	other fixes.
	* nsmenu.m (dockMenu): New variable.
	(EmacsDialog -clicked:): Fix mistake in change of 2008-07-17.

	* nsterm.h (dockMenu): Declare.

	* nsterm.m (KEY_NS_NEW_FRAME): New definition.
	(ns_term_init): Initialize dockMenu.
	(EmacsApp -newFrame:, -applicationDockMenu:): New methods.
	(EmacsView -windowShouldClose:): Don't behave specially if <= 1 frame
	left.

	* lisp.h (LSB_TAG): Use on DARWIN_OS, not NS_IMPL_COCOA.

2008-08-04  Chong Yidong  <cyd@stupidchicken.com>

	* nsterm.h: Test directly for NS_HAVE_INTEGER before defining it.

	* config.in: Regenerate.

2008-08-04  Seiji Zenitani  <zenitani@mac.com>

	* nsfns.m (x-create-frame): Set the frame parameter alpha to nil.

2008-08-04  Chong Yidong  <cyd@stupidchicken.com>

	* nsterm.h (find_and_call_menu_selection): Fix prototype.

2008-08-04  Adrian Robert  <Adrian.B.Robert@gmail.com>

	* emacs.c (main: unexec_init_emacs_zone): Call if on DARWIN_OS.

	* keyboard.h: Comment an #endif.

	* lisp.h (have_menus_p): Adjust comment.

	* menu.c (find_and_return_menu_selection): Fix comparison with
	client_data.

	* nsmenu.m (popup_activated_flag): New variable.
	(popup_activated): New function.
	(menu-or-popup-active-p): New exported lisp definition.
	(ns_popup_menu): Set popup_activated_flag.  Call discard_menu_items()
	when popup done.
	(ns_popup_dialog): Set popup_activated_flag.

	* nsterm.m (EmacsView -conversationIdentifier): Use NSInteger
	version for GNUstep (handled by conditional typedef in nsterm.m).
	(ns_get_color): Remove special-casing for "darkblue", "dark blue" (now
	in rgb.txt).

	* process.c (init_process): Use DARWIN_OS, not DARWIN.

	* sysselect.h: Conditionalize init_process undef on DARWIN_OS.

	* syssignal.h (FORWARD_SIGNAL_TO_MAIN_THREAD): Do it also under NS.

	* xdisp.c (redisplay_internal, note_mouse_highlight): Under NS,
	shortcircuit if popup_activated like GTK and X toolkit.

	* m/inter386.h: Change DARWIN to DARWIN_OS.

	* s/darwin.h: Add #define DARWIN_OS.  Get rid of C_SWITCH_SYSTEM def.
	Change LIBS_MACGUI to LIBS_NSGUI.  Move temacs-conditionalized defs
	closer to C_SWITCH_SYSTEM_TEMACS so usage is understood.  Expand
	comment on NO_SOCK_SIGIO.

2008-08-03  Chong Yidong  <cyd@stupidchicken.com>

	* nsterm.m (windowDidResize): Remove stopModal call.

2008-08-03  Andreas Schwab  <schwab@suse.de>

	* vm-limit.c (get_lim_data) [HAVE_GETRLIMIT && RLIMIT_AS]: Define.
	(check_memory_limits): Don't handle HAVE_GETRLIMIT here.

2008-08-02  Chong Yidong  <cyd@stupidchicken.com>

	* vm-limit.c (check_memory_limits): Don't use getrlimit on cygwin.
	Don't use uninitialized pointer variable when using getrlimit.

2008-08-02  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (compute_metrics): Don't mess with glyph_idx setting here.

2008-08-02  Eli Zaretskii  <eliz@gnu.org>

	* alloc.c (NSTATICS): Bump to 0x640.

	* s/gnu-linux.h (HAVE_PROCFS, LISTPROC, PROCATTR): New defines.

	* lisp.h: Add prototype for directory_files_internal.

	* process.c (Fsystem_processes_list, Fsystem_process_attributes):
	New functions.
	(syms_of_process): Defsubr them.  Add initializations for various
	Q* symbols used in procfs_system_process_attributes.
	(procfs_list_system_processes, procfs_system_process_attributes)
	[HAVE_PROCFS]: New functions.
	(time_from_jiffies, ltime_from_jiffies, get_up_time, procfs_ttyname)
	(procfs_get_total_memory): New functions.

2008-08-01  Juanma Barranquero  <lekktu@gmail.com>

	* xfaces.c (Fx_load_color_file): Fix previous change;
	it is #ifdef WINDOWSNT, not WINDOWS_NT.

2008-08-01  Michael Albinus  <michael.albinus@gmx.de>

	* dbusbind.c (xd_read_message): Handle D-Bus error messages.

2008-08-01  Adrian Robert  <Adrian.B.Robert@gmail.com>

	* nsterm.h (NSInteger, NSUInteger): Add defines for non-Leopard.

2008-08-01  Chong Yidong  <cyd@stupidchicken.com>

	* nsfns.m (ns_frame_parm_handlers): Add empty entry for x_set_alpha.

	* nsterm.m (EmacsApp -application:openFiles:): GNUstep does not
	define NSApplicationDelegateReplySuccess.
	(EmacsView -converstationIdentifier): Use long instead of
	NSInteger for GNUstep, since it doesn't have NSInteger.

	* xmenu.c: Revert last change.

	* keyboard.h: Fix last change.

2008-08-01  Juanma Barranquero  <lekktu@gmail.com>

	* xfaces.c (x-load-color-file): Use RGB() instead of manually shifting
	on Windows.

2008-08-01  Adrian Robert  <Adrian.B.Robert@gmail.com>

	Warning clearing and clean-up in NS port.
	* keyboard.h (xmalloc_widget_value, digest_single_submenu):
	Add prototypes.
	* nsgui.h (FACE_DEFAULT): Remove, unused.
	(XGCValues): Change colors to unsigned long.
	* nsterm.h (EmacsApp): Add declaration of all methods implemented in
	nsterm.m.
	(EmacsMenu -addItemWithWidgetValue:): Change to use NSMenuItem class.
	(ns_list_fonts): Remove, unused.
	(ns_font_to_xlfd, ns_fontname_to_xlfd): Drop prototypes.
	* nsfns.m (interpret_services_menu): Use NSMenuItem class.
	* nsfont.m (nsfont_open): Fix cast error in glyphs,metrics alloc.
	(nsfont_draw): Compare face colors to 0, not nil.
	* nsmenu.m (struct widget_value): Drop unneeded declaration.
	(EmacsMenu -addItemWithWidgetValue:, -fillWithWidgetValue:)
	(-addSubmenuWithTitle:): Use NSMenuItem class.
	(ns_popup_menu): Use NO, not NULL, for enabled setting.
	* nsterm.m (ns_draw_glyph_string): Don't compare font to ~0.
	(ns_clip_to_row): Make gc arg a BOOL.
	(ns_draw_fringe_bitmap, ns_draw_window_cursor): Use YES, NO in
	ns_clip_to_row() call.
	(ns_draw_glyph_string): Drop face comparison to ~0 (no longer
	used).  Cast FRAME_FONT assignments.
	(ns_read_socket): Cast call to EmacsApp-fulfillService:withArg:.
	(ns_string_to_lispmod): Change arg to const char.
	(ns_term_init): Use NSMenuItem class.
	(EmacsApp -openFile:): Move to different section of file.
	(EmacsApp -application:openFiles:): Don't return a value, call
	-replyToOpenOrPrint:.
	(EmacsView -keyDown:): Fix up cast.
	(EmacsView -converstationIdentifier): Use NSInteger instead of long.
	(EmacsView -menuDown:): Cast tag in call to
	find_and_call_menu_selection().
	(ns_list_fonts): Remove, unused.
	(ns_font_to_xlfd): Make static.  Cast result of UTF8String.
	(ns_fontname_to_xlfd): Make static.
	* w32menu.c (xmalloc_widget_value, digest_single_submenu):
	Remove prototypes (now in keyboard.h).
	(next_menubar_widget_id): Remove, unused.
	* xmenu.c (xmalloc_widget_value, digest_single_submenu):
	Remove prototypes (now in keyboard.h).
	* xfaces.c (ns_list_fonts, w32_list_fonts): Remove, unused.

2008-08-01  Dan Nicolaescu  <dann@ics.uci.edu>

	* Makefile.in (dispnew.o, gtkutil.o, sound.o, atimer.o)
	(floatfns.o): Depend on syssignal.h.
	(term.o): Depend on syssignal.h, systty.h, and $(INTERVAL_SRC).

	* systty.h: Fix previous change that removed BSD_TERMIOS.
	Add comments to #ifdefs.

2008-08-01  Adrian Robert  <Adrian.B.Robert@gmail.com>

	* w32fns.c (w32-load-color-file): Remove.
	(x-open-connection): Use renamed Fx_load_color_file.
	* xfaces.c (x-load-color-file): Add.
	* nsterm.m (ns_initialize): Load colors from etc/rgb.txt instead of
	Emacs.clr.
	(hide_hourglass): BLOCK_INPUT before UNBLOCK.

2008-07-31  Michael Albinus  <michael.albinus@gmx.de>

	* dbusbind.c (Fdbus_call_method_asynchronously)
	(Fdbus_method_error_internal): New defuns.
	(xd_read_message): Handle also reply messages.
	(Vdbus_registered_functions_table): Extend docstring.

2008-07-31  Juanma Barranquero  <lekktu@gmail.com>

	* keyboard.c (gobble_input): Fix previous change.

2008-07-31  Dan Nicolaescu  <dann@ics.uci.edu>

	* bitmaps/README:
	* xfns.c:
	* termcap.c:
	* term.c:
	* syswait.h:
	* systty.h:
	* systime.h:
	* syssignal.h:
	* sysdep.c:
	* process.h:
	* process.c:
	* print.c:
	* ndir.h:
	* lread.c:
	* keyboard.c:
	* getpagesize.h:
	* floatfns.c:
	* fileio.c:
	* emacs.c:
	* doc.c:
	* dispnew.c:
	* dired.c:
	* data.c:
	* callproc.c:
	* buffer.c:
	* README:
	* Makefile.in:
	* s/template.h:
	* s/msdos.h:
	* m/vax.h: Remove VMS support.
	* s/vms.h:
	* vlimit.h:
	* uaf.h:
	* temacs.opt:
	* param.h:
	* ioctl.h: Remove file.

2008-07-31  Dan Nicolaescu  <dann@ics.uci.edu>

	* s/ms-w32.h (MULTI_KBOARD): Remove.
	* xterm.c:
	* xselect.c:
	* xfns.c:
	* window.c:
	* w32term.c:
	* w32fns.c:
	* terminal.c:
	* termhooks.h:
	* term.c:
	* sysdep.c:
	* keyboard.h:
	* keyboard.c:
	* frame.h:
	* frame.c:
	* frame.c: Remove references to MULTI_KBOARD, it is now the default.
	* config.in: Regenerate.

2008-07-30  Jason Rumney  <jasonr@gnu.org>

	* w32font.h (struct w32font_info): Use unicode version of textmetrics.

	* w32font.c (w32font_encode_char): Leave as unicode if in range.
	(w32font_open_internal): Get unicode version of textmetrics.
	Don't enable or disable glyph indices here.
	(w32font_open): Disable use of glyph indices.

	* w32uniscribe.c (uniscribe_open): Enable use of glyph indices.

2008-07-30  Chong Yidong  <cyd@stupidchicken.com>

	* minibuf.c (Vread_buffer_function): Doc fix.

2008-07-30  John Paul Wallington  <jpw@pobox.com>

	* minibuf.c (read_buffer_completion_ignore_case): New var.
	(Fread_buffer): Use it.

2008-07-30  Dan Nicolaescu  <dann@ics.uci.edu>

	* systty.h (sensemode): Remove empty #if.  Remove reference to
	BSD_TERMIOS, unused.

	* sysdep.c: Remove reference to DGUX.
	(closedir): Remove reference to BROKEN_CLOSEDIR, unused.

	* config.in: Regenerate.

2008-07-30  Jason Rumney  <jasonr@gnu.org>

	* w32uniscribe.c (uniscribe_encode_char): Fix glyph buffer size.

2008-07-29  Jason Rumney  <jasonr@gnu.org>

	* w32uniscribe.c (uniscribe_shape): Avoid using context if cache
	is populated.
	(uniscribe_encode_char): Always use uniscribe.
	Avoid using context if cache is populated.

2008-07-29  Jan Djärv  <jan.h.d@swipnet.se>

	* xmenu.c (Fx_menu_bar_open_internal): Use activate_item signal to
	open menu.

	* gtkutil.c (menu_nav_ended): Remove.
	(create_menus): Remove signal connect for menu_nav_ended.

2008-07-28  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c (redisplay_window): Check return value of
	compute_window_start_on_continuation_line before forcing a window
	start.

2008-07-28  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_text_extents): Use w32_metric_cache consistently.

	* w32term.c (w32_enable_unicode_output, cleartype_active):
	Remove obsolete display options.
	(x_draw_glyph_string_background): Don't use old cleartype_active
	workaround.
	(w32_initialize): Remove cleartype_active initialization.
	(syms_of_w32term): Remove w32_enable_unicode_output initialization.

2008-07-28  Andreas Schwab  <schwab@suse.de>

	* lisp.h (init_weak_hash_tables, syms_of_font)
	(xd_read_queued_messages, syms_of_dbusbind): Declare.
	(remove_hash_entry): Don't declare.
	* eval.c (maybe_call_debugger): Make static and move before use.
	* gtkutil.c: Include <X11/Xft/Xft.h> if HAVE_XFT.
	* xdisp.c: Include "gtkutil.h" if USE_GTK.
	* xterm.h (x_set_frame_alpha): Declare.

2008-07-28  Jan Djärv  <jan.h.d@swipnet.se>

	* gtkutil.c (menu_nav_ended): Revert change from 2008-07-24.
	(create_menus): Connect selection-done to menu_nav_ended.

2008-07-27  Adrian Robert  <Adrian.B.Robert@gmail.com>

	* nsfns.m (x-create-frame): Add copy of parms argument to beginning.
	Set Vx_resource_name to a fallback.  Replace read of 'buffered'
	parameter with read of 'alpha' one.
	(Qns_frame_parameter): Remove.
	* nsselection.m (selection-coding-system)
	(next-selection-coding-system, Vselection_coding_system)
	(Vnext_selection_coding_system): Drop.

2008-07-27  Adrian Robert  <Adrian.B.Robert@gmail.com>

	* nsfns.m (do-applescript, do_applescript): Rename to
	ns-do-applescript, ns_do_applescript, and move within file.

2008-07-27  Dan Nicolaescu  <dann@ics.uci.edu>

	Remove support for Mac Carbon.
	* mactoolbox.c:
	* macterm.h:
	* macterm.c:
	* macselect.c:
	* macmenu.c:
	* macgui.h:
	* macfns.c:
	* mac.c: Remove file.
	* s/darwin.h:
	* m/intel386.h:
	* xfaces.c:
	* xdisp.c:
	* window.c:
	* tparam.c:
	* termhooks.h:
	* termcap.c:
	* term.c:
	* syssignal.h:
	* sysselect.h:
	* sysdep.c:
	* process.c:
	* lread.c:
	* lisp.h:
	* keyboard.c:
	* image.c:
	* fringe.c:
	* frame.h:
	* frame.c:
	* fontset.c:
	* font.h:
	* font.c:
	* fns.c:
	* fileio.c:
	* emacs.c:
	* dispnew.c:
	* dispextern.h:
	* config.in:
	* atimer.c:
	* Makefile.in: Remove code for Carbon

2008-07-26 YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (XDrawLine) [USE_MAC_IMAGE_IO]: Remove spurious return.

2008-07-26  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.h (kCGBitmapByteOrder32Host): New define for
	non-universal SDKs.

	* image.c (mac_create_cg_image_from_image, image_load_image_io)
	[USE_MAC_IMAGE_IO]: Remove conditionals for kCGBitmapByteOrder32Host.

	* macterm.c (XDrawLine, XCreatePixmapFromBitmapData)
	[USE_MAC_IMAGE_IO]: Remove conditionals for kCGBitmapByteOrder32Host.

2008-07-26  David Robinow  <drobinow@gmail.com>  (tiny change)

	* w32inevt.c: Include dispextern.h.

2008-07-26  Andreas Schwab  <schwab@suse.de>

	* print.c (print_object): Fix off-by-one in last change.

2008-07-25  Juanma Barranquero  <lekktu@gmail.com>

	* term.c (syms_of_term): Don't initialize default_orig_pair,
	default_set_foreground and default_set_background on Windows.

2008-07-25  Jason Rumney  <jasonr@gnu.org>

	* w32uniscribe.c (uniscribe_shape): Pass NULL for control arg to
	ScriptItemize.  Clean up return value checking.  Remove unused
	variables.
	(uniscribe_encode_char): Encode non-BMP characters with uniscribe
	shaping engine.

	* w32font.c (w32font_has_char): Handle the case where we can't
	determine the script for a character.

2008-07-25  Chong Yidong  <cyd@stupidchicken.com>

	* term.c (syms_of_term): Initialize default_orig_pair,
	default_set_foreground, and default_set_background.

	* getloadavg.c (nl): Rename to name_list to avoid ncurses.h
	clash (bug#86).
	(getloadavg): Callers changed.

	* image.c (svg_load_image): Fix last change.
	(svg_load_image): Use rsvg_handle_get_dimensions to check that
	image size is valid.  Use g_object_unref instead of deprecated
	rsvg_handle_free to free rsvg handle.
	(x_from_xcolors): Don't initialize pixmap (silence compiler).

2008-07-25  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_encode_char): Encode characters outside BMP as
	surrogates before looking up glyph index.
	(w32font_text_extents): Encode as surrogates if falling back to
	functions that need UTF-16 wide chars.

	* w32uniscribe.c (uniscribe_encode_char): Encode characters outside
	BMP as surrogates before looking up glyph index.

2008-07-25  Chong Yidong  <cyd@stupidchicken.com>

	* image.c (svg_load_image): Check for failure in return value of
	rsvg_handle_get_pixbuf.  Free rsvg handle when done.

2008-07-25  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (Fx_select_font): Reverse sense of second arg.

2008-07-24  Stefan Monnier  <monnier@iro.umontreal.ca>

	* syntax.c (struct lisp_parse_state, char_quoted, inc_bytepos)
	(dec_bytepos, find_defun_start): Use EMACS_INT for buffer positions.

	* puresize.h (PURESIZE_CHECKING_RATIO): New macro.
	(PURESIZE): Use it.

2008-07-24  Dan Nicolaescu  <dann@ics.uci.edu>

	* m/amdx86-64.h (HAVE_LIB64_DIR): Consolidate ifdefs.
	* m/alpha.h (TEXT_END):
	* m/ibmrs6000.h (TEXT_END):
	* m/macppc.h (TEXT_END):
	* s/darwin.h (TEXT_END):
	* s/msdos.h (TEXT_END): Remove, unused.
	* s/gnu-linux.h (BSD_PGRPS): Add a comment.
	* s/cygwin.h: Remove comment.

	* ecrt0.c (NODOT_GLOBAL_START): Remove code, unused.
	(DOT_GLOBAL_START): Remove conditional, redundant for CRT0_DUMMIES.
	* m/intel386.h (DOT_GLOBAL_START):
	* m/vax.h (DOT_GLOBAL_START): Remove, redundant with CRT0_DUMMIES.
	(USG): Remove, file not used on USG platforms.

	* Makefile.in (HAVE_X11): Remove empty #else.

2008-07-24  Andreas Schwab  <schwab@suse.de>

	* fileio.c (Finsert_file_contents): Properly adjust undo list
	after format conversion.

2008-07-24  Jan Djärv  <jan.h.d@swipnet.se>

	* gtkutil.c (xg_get_font_name): Cast w to GTK_FONT_SELECTION_DIALOG.
	(menu_nav_ended): Remove.
	(create_menus): Remove signal connect for menu_nav_ended.
	(xg_update_menubar): Also take deactivate_cb as parameter, pass it to
	create_menus.
	(xg_modify_menubar_widgets): Pass deactivate_cb to xg_update_menubar.

2008-07-23  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32_enumfont_pattern_entity): Return height consistent
	with opened font.
	(w32font_open): Set font type to gdi.

	* w32uniscribe.c (uniscribe_open): Set font type to uniscribe.

2008-07-23  Dan Nicolaescu  <dann@ics.uci.edu>

	* s/usg5-4.h (ADDR_CORRECT): Remove, unused.
	* unexaix.c (ADDR_CORRECT): Remove conditional, the only user
	defines it.
	* unexec.c (ADDR_CORRECT): Define unconditionally.

	* m/ibmrs6000.h (C_SWITCH_MACHINE): Remove.

	* unexec.c: Remove code depending on !COFF and USG, the file is
	not used for such systems.

	* s/netbsd.h (A_TEXT_OFFSET, A_TEXT_SEEK):
	* s/freebsd.h (A_TEXT_OFFSET, A_TEXT_SEEK): Remove, unused.
	(LD_SWITCH_SYSTEM_1): Remove, update users.

	* s/darwin.h (DATA_END):
	* m/intel386.h (DATA_END):
	* m/ibmrs6000.h (DATA_END):
	* m/alpha.h (DATA_END): Remove, unused.

	* config.in: Regenerate.
	* s/ms-w32.h (subprocesses): Define unconditionally.
	* s/template.h (subprocesses): Update comment.
	* s/vms.h (subprocesses):
	* s/usg5-4.h (subprocesses):
	* s/hpux10-20.h (subprocesses):
	* s/gnu-linux.h (subprocesses):
	* s/cygwin.h (subprocesses):
	* s/bsd-common.h (subprocesses):
	* s/aix4-2.h (subprocesses):
	* s/darwin.h (subprocesses): Do not define, defined by default now.

	* Makefile.in (C_SWITCH_SITE, LD_SWITCH_SITE): Remove, unused.
	Remove all references.
	(temacs): Add GNUstep specific ld flags.

	* nsterm.m (syms_of_nsterm): Provide ns, not ns-windowing,
	similarly to what X does.

2008-07-22  Adrian Robert  <Adrian.B.Robert@gmail.com>

	* nsfns.m (x-list-fonts): Remove.
	(syms_of_nsfns): Drop the x-list-fonts declaration.
	* nsterm.m: Get rid of remaining "//" comments.

2008-07-22  Chong Yidong  <cyd@stupidchicken.com>

	* xselect.c (Fx_rotate_cut_buffers_internal): Doc fix.

	* nsselect.m (Fns_selection_exists_p, Fns_selection_owner_p)
	(Fx_get_selection_internal, Fns_rotate_cut_buffers_internal)
	(Fns_own_selection_internal, Fx_disown_selection_internal)
	(Fns_get_cut_buffer_internal, Fns_store_cut_buffer_internal):

	* nsmenu.m (Fns_reset_menu, Fx_popup_menu): Change to use 'doc: /*
	... */' style of docstrings.  Doc fixes.

2008-07-22  Dan Nicolaescu  <dann@ics.uci.edu>

	* terminfo.c (UP, BC, PC): Undo previous change.

	* nsfns.m: Rename ns prefixed functions/variables to the
	corresponding x versions.  Update references.

2008-07-22  Stefan Monnier  <monnier@iro.umontreal.ca>

	* syntax.c (char_quoted): Check "charpos > beg" before decrementing.

2008-07-22  Dan Nicolaescu  <dann@ics.uci.edu>

	* nsfns.m (x_set_menu_bar_lines, x_set_tool_bar_lines):
	Remove forwarding functions.
	(ns_set_menu_bar_lines): Rename to x_set_menu_bar_lines, make
	non-static.
	(ns_set_tool_bar_lines): Rename to x_set_tool_bar_lines, make
	non-static.
	(ns_frame_parm_handlers): Use the new names.
	(syms_of_nsfns): Move to the end of file.

	* nsterm.m (syms_of_nsterm): Move to the end of file.

	* dispnew.c (init_display): Remove code for X10.

2008-07-22  Jason Rumney  <jasonr@gnu.org>

	* w32proc.c (Fw32_long_file_name): Don't append dir separator to
	bare drive.

2008-07-22  Adrian Robert  <Adrian.B.Robert@gmail.com>

	* nsterm.m (syms_of_nsterm): Remove debugging println.

2008-07-22  David Reitter  <david.reitter@gmail.com>

	* nsfns.m (do_applescript, F_do_applescript): NS version of the
	Carbon implementation of the same functionality: execute arbitrary
	AppleScript code.

2008-07-21  Adrian Robert  <Adrian.B.Robert@gmail.com>

	* nsfns.m (Fx_create_frame, Fx_read_file_name, Fx_get_resource)
	(Fx_set_resource, Fx_set_alpha, Fx_server_max_request_size)
	(Fx_server_vendor, Fx_server_version, Fx_display_screens)
	(Fx_display_mm_height, Fx_display_mm_width)
	(Fx_display_backing_store, Fx_display_visual_class)
	(Fx_display_save_under, Fx_open_connection)
	(Fx_close_connection, Fx_hide_emacs, Fx_font_name)
	(Fx_list_colors, Fx_perform_service, Fx_color_defined_p)
	(Fx_color_values, Fxw_display_color_p, Fx_display_grayscale_p)
	(Fx_display_pixel_width, Fx_display_pixel_height)
	(Fx_display_usable_bounds, Fx_display_planes)
	(Fx_display_color_cells, Vns_icon_type_alist): Change to use 'doc: /*
	... */' style of docstrings.

2008-07-21  Dan Nicolaescu  <dann@ics.uci.edu>

	* m/mips.h (LOAD_AVE_TYPE, LOAD_AVE_CVT): Do not define, not used
	on this platform.
	(mips):
	* m/iris4d.h (mips): Do not define.
	* sysdep.c (init_sys_modes): Use __mips__ instead of mips.

	* m/ibmrs6000.h (LD_SWITCH_SITE): Remove.

	* image.c:
	* nsfns.m:
	* nsselect.m:
	* nsterm.h:
	* nsterm.m: Rename ns prefixed functions/variables to the
	corresponding x versions.  Update references.

	* m/ibms390x.h (NO_REMAP): Do not undefine.

	* m/amdx86-64.h: Use SOLARIS2 instead of sun.

2008-07-21  Chong Yidong  <cyd@stupidchicken.com>

	* nsfns.m: Change NS to Nextstep in docstrings and error messages.
	(Fns_create_frame, Fns_read_file_name, Fns_get_resource)
	(Fns_set_resource, Fns_set_alpha, Fns_server_max_request_size)
	(Fns_server_vendor, Fns_server_version, Fns_display_screens)
	(Fns_display_mm_height, Fns_display_mm_width)
	(Fns_display_backing_store, Fns_display_visual_class)
	(Fns_display_save_under, Fns_open_connection)
	(Fns_close_connection, Fns_hide_emacs, Fns_font_name)
	(Fns_list_colors, Fns_perform_service, Fns_color_defined_p)
	(Fns_color_values, Fxw_display_color_p, Fx_display_grayscale_p)
	(Fns_display_pixel_width, Fns_display_pixel_height)
	(Fns_display_usable_bounds, Fx_display_planes)
	(Fns_display_color_cells, Vns_icon_type_alist): Doc fixes.

2008-07-21  Ami Fischman  <ami@fischman.org>  (tiny change)

	* print.c (print_object): Check print_depth before searching for
	circularities.

2008-07-21  Michael Albinus  <michael.albinus@gmx.de>

	* dbusbind.c (Fdbus_register_signal): Use sprintf + strcat instead
	only sprintf.

2008-07-21  Kenichi Handa  <handa@m17n.org>

	* ftfont.c (adjust_anchor): Check if DeltaValue is not NULL.

2008-07-20  Andreas Schwab  <schwab@suse.de>

	* syntax.c (find_start_pos, find_start_value)
	(find_start_value_byte, find_start_begv, find_defun_start)
	(back_comment, scan_sexps_forward): Use EMACS_INT for buffer positions.

2008-07-20  Dan Nicolaescu  <dann@ics.uci.edu>

	* s/sol2-3.h: Insert contents of s/sol2.h.
	(LD_SWITCH_SYSTEM): Remove redundant definition.
	* s/sol2.h: Remove, unused.

2008-07-20  Adrian Robert  <Adrian.B.Robert@gmail.com>

	* nsterm.m (ns_get_color): Recognize HSB,AHSB be synonyms for HSV,AHSV.

2008-07-20  Adrian Robert  <Adrian.B.Robert@gmail.com>

	* Makefile.in (ns_appdir): Fix typo in find command.

2008-07-20  Dan Nicolaescu  <dann@ics.uci.edu>

	* m/intel386.h (NO_REMAP): Do no define for USG, not used.

	* s/usg5-4.h (LIBS_SYSTEM): Remove, system for which this was
	added not supported anymore.

	* s/usg5-4-2.h (LIBS_SYSTEM):
	* s/sol2.h (LIBS_SYSTEM): Do not undefine.

	* s/netbsd.h (GETPGRP_NO_ARG, N_TRELOFF):
	* s/lynxos.h (GETPGRP_NO_ARG):
	* s/hpux10-20.h (NO_SIOCTL_H):
	* s/gnu.h (GETPGRP_NO_ARG):
	* s/gnu-linux.h (NO_SIOCTL_H):
	* s/freebsd.h (GETPGRP_NO_ARG, N_TRELOFF):
	* s/cygwin.h (GETPGRP_NO_ARG):
	* s/irix6-5.h (LIBS_SYSTEM, GETPGRP_NO_ARG): Remove, unused.
	(C_DEBUG_SWITCH): Remove duplicate definition.

	* m/ibms390.h: Remove boilerplate comments.

	* sysdep.c (closedir): Use SOLARIS2 instead of sun && USG5_4.

	* process.c (HAVE_SERIAL): Consolidate ifdefs.
	(wait_reading_process_output): Remove code for SunOS, platform not
	supported anymore.  Use SOLARIS2 instead of sun.

2008-07-19  Adrian Robert  <Adrian.B.Robert@gmail.com>

	* font.c (font_open_by_name): Under NS, default lface height to zero.
	(font_open_for_lface): Under NS, set size based on frame fontsize.
	* nsterm.m (EmacsView-changeFont:): Remove some commented code.
	* frame.c (x_set_frame_parameters): Remove HAVE_NS ifdef.

2008-07-19  Adrian Robert  <Adrian.B.Robert@gmail.com>

	* nsterm.m (ns_antialias_text, ns_use_qd_smoothing)
	(ns_use_system_highlight_color): Switch these from DEFVAR_BOOL to
	DEFVAR_LISP and change all code accordingly to use Qt/Qnil instead of
	YES/NO.
	* nsterm.h (prevUseHighlightColor): Make a Lisp_Object.
	* nsfont.m (nsfont_draw): Treat ns_use_qd_smoothing as Lisp_Object.
	* Makefile.in (clean): Clear out build destination dir.

2008-07-19  Adrian Robert  <Adrian.B.Robert@gmail.com>

	* Makefile.in (nsgui.h-related dependencies): Remove abbrev, xfns,
	xterm, xselect.
	* lisp.h: Remove declaration of hash_remove.
	* nsgui.h: Remove redefinitions of hash_remove.
	* fns.c (hash_remove): Rename to hash_remove_from_table.

2008-07-19  Seiji Zenitani  <zenitani@mac.com>

	* nsfont.m (nsfont_fmember_to_entity, nsfont_make_fontset_for_font):
	strdup() the family UTF8String before modifying it.

2008-07-19  Adrian Robert  <Adrian.B.Robert@gmail.com>

	* nsterm.m (ns_maybe_dumpglyphs_background): Compare result from
	NS_FACE_BACKGROUND with 0 instead of nil.
	* nsfont.m (nsfont_draw): Same.

2008-07-19  Chong Yidong  <cyd@stupidchicken.com>

	* nsfns.m (ns_set_background_color): Fix crash.

2008-07-18  Chong Yidong  <cyd@stupidchicken.com>

	* Makefile.in (SOME_MACHINE_LISP): Remove ns-carbon-compat.elc.

2008-07-18  Dan Nicolaescu  <dann@ics.uci.edu>

	* puresize.h (BASE_PURESIZE): Increase to 1240000.

2008-07-17  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* gtkutil.c: Include <config.h> instead of "config.h".

	* lisp.h (Foverlay_buffer): Add EXFUN.

	* process.c (create_process) [!WINDOWSNT && FD_CLOEXEC]: Wait for
	child process to complete child_setup.  Undo 2005-09-21 change.

	* s/darwin.h: Mention setsid after vfork.

2008-07-17  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* Makefile.in (frame.o, keyboard.o, xdisp.o, xfaces.o):
	Depend on macgui.h.

	* macfns.c (Fx_server_version): Don't use gestaltSystemVersionMajor,
	gestaltSystemVersionMinor, or gestaltSystemVersionBugFix.

	* macterm.c (keycode_to_xkeysym_table): Add entries for f17, f18,
	and f19.
	[MAC_OSX] (fn_keycode_to_keycode_table): Likewise.

	* macterm.h (gestaltSystemVersionMajor, gestaltSystemVersionMinor)
	(gestaltSystemVersionBugFix) [MAC_OS_X_VERSION_MAX_ALLOWED < 1040]:
	Remove enumerators.

	* mactoolbox.c [USE_MAC_TSM] (mac_handle_text_input_event):
	Check if FACE_FROM_ID returns NULL.

2008-07-17  David Robinow  <drobinow@gmail.com>  (tiny change)

	* w32inevt.c (change_frame_size): Remove extern declaration.
	(resize_event, maybe_generate_resize_event): Pass SAFE arg to
	change_frame_size.

2008-07-17  Adrian Robert  <Adrian.B.Robert@gmail.com>

	* getloadavg.c: Revert last change (2008-07-15).

2008-07-17  Adrian Robert  <Adrian.B.Robert@gmail.com>

	* Makefile.in: Replace emacsapp, emacsbindir, emacsappsrc variables
	set here with ns_appdir, ns_appresdir, ns_appbindir, ns_appsrc) set
	from configure.

2008-07-17  Dan Nicolaescu  <dann@ics.uci.edu>

	* s/sol2.h:
	* s/sol2-4.h: Reorganize conditionals.

	* ecrt0.c: Remove code depending on m68000, not used anymore.

	* fns.c (hash_remove): Make static.
	* lisp.h (hash_remove): Don't prototype.

	* m/ibmrs6000.h:
	* m/ibms390x.h:
	* m/macppc.h: Remove boilerplate comments.

	* m/sparc.h (A_TEXT_OFFSET, A_TEXT_SEEK): Remove, only used on
	Solaris, which does not need them.

	* m/vax.h: Remove comments about unsupported systems.

	* s/darwin.h: Reorganize ifdefs.

2008-07-17  Andreas Schwab  <schwab@suse.de>

	* s/cygwin.h (LIB_STANDARD_LIBSRC): Don't define.

2008-07-17  Stefan Monnier  <monnier@iro.umontreal.ca>

	Use SDATA.  Follow coding convention of placing operators at
	beginning of next line rather than end of previous line, and placing
	spaces around infix operators.

	* Makefile.in: Undef LIB_STANDARD before defining it to silence warning
	in case it was defined already.
	USE @GNUSTEP_MAKEFILES@ rather than envvars.
	* nsterm.m (ns_term_init): Pass Qt and Qnil rather than YES/NO to
	ns_default.
	(applicationShouldTerminate, setValuesFromPanel): Use EQ to compare
	Lisp_Objects.
	* nsterm.h (Fx_display_grayscale_p, Fx_display_planes)
	(ns_defined_color, ns_color_to_lisp): Declare.
	* nsselect.m (ns_handle_selection_request, ns_handle_selection_clear)
	(Fns_own_selection_internal): Make the big ugly hack more explicit, so
	it's accepted even with USE_LISP_UNION_TYPE.
	* nsmenu.m (ns_update_menubar): Use EQ to compare Lisp_Objects.
	(update_frame_tool_bar): Remove apparently obsolete tests for
	non-integerness of f->tool_bar_lines.
	(windowShouldClose, addButton, clicked, runDialogAt): Make the big ugly
	hack more explicit, so it's accepted even with USE_LISP_UNION_TYPE.
	* nsfont.m (nsfont_driver): Use just 0 rather than an invalid cast.
	(nsfont_open): Don't confuse NULL for Qnil.
	* nsfns.m (ns_implicitly_set_icon_type): Use EQ to compare Lisp_Objects.
	* menu.h (find_and_call_menu_selection):
	* menu.c (find_and_call_menu_selection): Use just int for vector size.
	(find_and_return_menu_selection): Always return something.
	* frame.h: Include dispextern.h for Display_Info.
	(display_x_get_resource): Declare.

2008-07-16  Adrian Robert  <Adrian.B.Robert@gmail.com>

	* syntax.c: Remove stdio.h include accidentally introduced in
	Emacs.app commit.
	* Makefile.in: Change GNUSTEP to NS_IMPL_GNUSTEP, COCOA to
	NS_IMPL_COCOA.
	* keyboard.c (handle_async_input, input_available_signal): Remove
	BSD4_1 conditional code, introduced accidentally in Emacs.app commit.

2008-07-16  Stefan Monnier  <monnier@iro.umontreal.ca>

	* nsterm.m (lisp_to_mod): Use parse_solitary_modifier instead.
	(ns_lisp_to_color): Don't mess with internal Lisp data fields.
	(ns_term_init, ns_term_shutdown, initFrameFromEmacs, ns_list_fonts):
	Use SDATA.

	* keymap.c: Remove all NS-specific code.
	(where_is_preferred_modifier, Vwhere_is_preferred_modifier): New vars.
	(preferred_sequence_p): Rename from ascii_sequence_p; pay attention to
	where_is_preferred_modifier, return a different value depending on how
	preferred is the binding.
	(where_is_internal): Adjust accordingly.
	(Fwhere_is_internal): Refresh where_is_preferred_modifier.
	Adjust to new preferred_sequence_p.
	(syms_of_keymap): Declare `where-is-preferred-modifier'.
	* keyboard.c (parse_solitary_modifier): Not static any more.
	* keyboard.h (parse_solitary_modifier): Declare.

2008-07-16  Andreas Schwab  <schwab@suse.de>

	* Makefile.in (SOME_MACHINE_LISP): Remove easy-mmode, fix spelling
	of easymenu.

2008-07-16  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c (move_it_in_display_line): Account for word wrap, so
	that we don't move off the line.

2008-07-16  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keyboard.c (Qsuper): Remove.
	(parse_menu_item): Don't call where_is_internal specially for NS.

2008-07-16  Dan Nicolaescu  <dann@ics.uci.edu>

	* s/gnu-linux.h: Remove boilerplate comments.

	* m/alpha.h (__ELF__): Consolidate conditions.

	* m/m68k.h (linux): Use GNU_LINUX instead.
	Remove boilerplate comments.

	* m/intel386.h: Undo refactoring from previous change.
	(LIB_STANDARD): All systems that define USG define LIB_STANDARD
	too, remove dead code.
	(linux): Use GNU_LINUX instead.

2008-07-16  Jason Rumney  <jasonr@gnu.org>

	* w32gui.h: Repeat 26 June changes lost by last change.

2008-07-16  Dan Nicolaescu  <dann@ics.uci.edu>

	* systty.h: Remove code for Aix on 386, unsupported platform.

	* s/ms-w32.h: Remove boilerplate comments.
	(fcloseall, fgetchar, flushall, fputchar, getw, putw): Remove, unused.

	* s/gnu-linux.h (TERM): Remove support.
	(HAVE_SYSVIPC): Remove, unused.
	(A_TEXT_OFFSET, A_TEXT_SEEK, ADJUST_EXEC_HEADER): Remove, not used
	for this system.

	* process.c: Remove support for IRIS, unused.
	Remove support for TERM, not relevant anymore.

	* unexalpha.c (DEFAULT_ENTRY_ADDRESS): Remove, replace the only
	used with the definition.

	* s/aix4-2.h (static): Do not undef.

	* m/ibmrs6000.h: Remove code depending on USG5_4, this file is
	only used on Aix.
	(HAVE_SYSVIPC): Remove, unused.

	* m/hp800.h (CANNOT_DUMP): Do not undef.

	* m/alpha.h: Fix comment.

	* s/usg5-4.h (HAVE_SYSVIPC): Remove, unused.
	(USG_SHARED_LIBRARIES): Remove, only used in unexec.c which is not
	used by this configuration.
	* emacs.c: Remove code depending on USG_SHARED_LIBRARIES.
	* unexec.c: Remove code depending on HPUX and
	USG_SHARED_LIBRARIES, not used with this file.  Remove code
	depending on IRIS, unused.  Remove if 0-ed code.

	* s/template.h: Remove comments about static.

	* sysdep.c: Remove code depending on NEED_PTEM_H, unused.
	Remove if 0-ed code.
	(baud_convert): Don't depend on BAUD_CONVERT, all definitions the
	were the same as the default.
	* s/vms.h (BAUD_CONVERT): Remove, same as the default.
	Remove boilerplate comments.
	* s/hpux10-20.h (BAUD_CONVERT): Remove, same as the default.
	(HAVE_SYSVIPC): Remove, unused.
	(LD_SWITCH_SYSTEM_TEMACS): Simplify, hp9000s700 not supported anymore.

	* m/ia64.h (PNTR_COMPARISON_TYPE): Remove, same as the default.
	Remove boilerplate comments.
	* m/amdx86-64.h (PNTR_COMPARISON_TYPE): Remove, same as the default.
	Remove boilerplate comments.
	* m/ibms390x.h (PNTR_COMPARISON_TYPE): Remove, same as the default.
	Remove boilerplate comments.
	* lisp.h (PNTR_COMPARISON_TYPE): Define it unconditionally.

	* m/intel386.h (DATA_SEG_BITS): Remove definitions, only used on
	USG systems which do not use DATA_SEG_BITS.
	Refactor code.  Remove boilerplate comments.

	* m/ibms390.h:
	* m/m68k.h:
	* s/bsd-common.h:
	* s/cygwin.h:
	* s/darwin.h:
	* s/freebsd.h:
	* s/gnu.h:
	* s/msdos.h: Remove boilerplate comments.

	* m/iris4d.h: Remove boilerplate comments and code for systems that
	 do not use this file.
	(IRIS_4D): Remove, unused.

	* m/mips.h: Remove boilerplate comments and code for systems that
	 do not use this file.
	(SIGN_EXTEND_CHAR):
	* m/arm.h (SIGN_EXTEND_CHAR): Remove, unused.
	* unexmips.c: Remove file, unused.

	* editfns.c (Fuser_full_name): Replace the only use of
	USER_FULL_NAME with its value.
	* config.in: Regenerate.

2008-07-16  David Reitter  <david.reitter@gmail.com>

	* Makefile.in: Add ns-win, ns-carbon-compat, easy-mmode and
	easy-menu to SOME_MACHINE_LISP for the new NeXTstep port.

2008-07-16  Glenn Morris  <rgm@gnu.org>

	* emacs.c (system-type): Doc fix.

2008-07-15  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keyboard.c (parse_menu_item): Don't use cachelist, even under NS.
	If the cache doesn't work, let's fix it, rather than work around it.

2008-07-15  Adrian Robert  <Adrian.B.Robert@gmail.com>

	* Makefile.in: Correct additions for nsfont.o in last commit.
	* nsfont.m: New file (forgot last commit).

2008-07-15  Chris Hall  <chris@web.workinglinux.com>  (tiny change)

	* callproc.c (set_initial_environment): Initialize
	Vprocess_environment under CANNOT_DUMP (fixes crash when
	batch-compiling for bootstrap).

2008-07-15  Chris Hall  <chris@web.workinglinux.com>  (tiny change)
	    YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	(make_initial_frame): Call init_frame_faces(f) in CANNOT_DUMP case --
	fix crash due to different init order.

2008-07-15  Adrian Robert  <Adrian.B.Robert@gmail.com>

	Changes and additions for NeXTstep windowing system (Cocoa and
	GNUstep) support.

	* Makefile.in:
	* config.in: Support defines and build commands for NS port.
	* blockinput.h (BLOCK_INPUT, UNBLOCK_INPUT, TOTALLY_UNBLOCK_INPUT)
	(UNBLOCK_INPUT_TO): Don't use under NS unless EXPERIMENTAL_CONTROL_G.
	* dispextern.h: Include nsgui.h and add needed typedefs under NS
	windowing.
	(struct face): Add synth_ital field.
	* dispnew.c: Include nsterm.h when compiling under NS windowing.
	(init_display): Initialize Vinitial_window_system to "ns" when so
	compiled.
	* emacs.c: Include GSConfig.h when compiling under GNUstep.
	(display_arg): Use under NS.
	(main): Under NS, allocate autorelease pool and handle command line
	args.  Move syms_of_xmenu() call under #ifdef HAVE_X_WINDOWS.
	(standard_args): Add NS-specific args.
	(shut_down_emacs): Shut down NS terminal if compiled under NS.
	* font.c (DEFAULT_ENCODING): New variable.
	(font_find_for_lface): Use it.
	(syms_of_font): Load syms_of_nsfont under NS.
	* font.h: Declare nsfont_driver when compiled under NS.
	* fontset.c: When compiling under NS, include nsterm.h.
	(fontset_from_font): Autoconstruct fontset under NS.
	* frame.c (various): Under NS, include nsterm.h, add Qns window system
	symbol, document and use it.
	(do_switch_frame): When for_deletion under Cocoa, add
	Fraise_frame(Qnil).
	(x_set_frame_parameters): Ensure font attribute changes are picked up.
	(x_get_arg): Allow "yes" and "no" as boolean values.
	(syms_of_frame): Declare Qns.  Init Vdefault_frame_scroll_bars to
	Qright under Cocoa.
	(focus-follows-mouse): Default to 0 under NS.
	* frame.h (enum output_method): Add output_ns.
	(external_tool_bar, external_menu_bar, FRAME_EXTERNAL_TOOLBAR)
	(FRAME_EXTERNAL_MENU_BAR): Use under NS.
	(FRAME_WINDOW_P): NS-specific definition.
	* fringe.c (max_used_fringe_bitmap): Make public.
	* getloadavg.c (mach/mach.h): Include it under NeXT descendant OS's.
	(getloadavg): Use NeXT code under descendant OS's.
	* image.c (includes and header section, x_create_bitmap_from_data)
	(x_create_bitmap_from_file, free_bitmap_record, image_background)
	(image_background_transparent, x_clear_image_1)
	(x_create_x_image_and_pixmap, x_destroy_x_image, x_put_x_image)
	(Create_Pixmap_From_Bitmap_Data, xpm_load_image, lookup_rgb_color)
	(x_to_xcolors, x_from_xcolors, x_disable_image)
	(x_build_heuristic_mask, syms_of_image): Add NS support parallel to
	other GUIs, including XPM support using code originally written for
	Carbon GUI.
	(png_load, jpeg_load, tiff_load, gif_load): Add implementations
	using NS API.
	(image_ascent): Use font metrics macros instead of direct struct field
	access.
	* keyboard.c (includes): Add nsterm.h when compiling under NS.
	(kbd_buffer_get_event): Handle NS as other GUI windowing systems.
	Also, handle NS as GTK for menu bar purposes.
	(make_lispy_event): Handle NS as other GUI windowing systems, and as X
	toolkit where they differ.
	(parse_menu_item): Prefer keybindings using 'super' modifier.  Also,
	use cachelist, still needed under NS.
	* keyboard.h (ENCODE_MENU_STRING, XtPointer, Boolean): Handle as NTGUI.
	(struct widget_value): Define it here for menu.c.
	* keymap.c (includes): Include modifier internals.
	(lisp_to_mod, modifier_sequence_p): New functions, compiled only under
	NS.
	(where_is_internal, Fwhere_is_internal): When compiled under NS, add
	support for preferring sequences using certain modifiers, specified by
	the FIRSTONLY argument.
	* lisp.h (hash_remove): Rename to avoid name clash when compiling
	under NS GNUstep implementation.
	(USE_LSB_TAG): Use it under Cocoa when compiling under NS.
	* lread.c (init_lread): Treat NS as HAVE_CARBON for turn_off_warning.
	* menu.c: Include nsterm.h under NS.
	(single_menu_item, parse_single_submenu, xmalloc_widget_value)
	(free_menubar_widget_tree_value, update_submenu_strings)
	(find_and_call_menu_selection): Treat NS as X and NT.
	(find_and_return_menu_selection): New function, used for popup menus.
	* nsgui.h:
	* nsterm.h:
	* nsfns.m:
	* nsimage.m:
	* nsmenu.m:
	* nsselect.m:
	* nsterm.m: New files.
	* process.c (wait_reading_process_output): Under NS, call ns_select()
	instead of plain select().
	* syntax.c (char_quoted): Under NS, avoid a crash when called near
	beginning of buffer.
	* sysselect.h (init_process): Rename when compiling under Cocoa to
	avoid name conflict.
	* termhooks.h (display_info): Add ns_display_info to union.
	* terminal.c (Fterminal_live_p): Add ns to terminal types.
	* terminfo.c (UP, BC, PC): Don't declare when compiling under NS in
	COCOA environment.
	* unexnext.c: Update to work with mach API on Mac OS X, and to use new
	unexec() signature.  (Note, this will dump, but the resulting file
	crashes; unexosx is used instead; keeping around for reference and
	possible aid in getting dump working under GNUstep.)
	* w32gui.h (button_type, widget_value): Remove definitions (now in
	keyboard.h).
	* window.c: Include nsterm.h when compiling under NS.
	* xdisp.c (includes): Include nsterm.h when compiling under NS.
	(set_frame_menubar, update_menu_bar, display_menu_bar): Handle NS as
	other GUI windowing systems.
	(update_tool_bar, redisplay_tool_bar, redisplay_window): Handle NS as
	GTK.
	(x_consider_frame_title): Under NS, set icon type and frame
	modified-state indicator; use ns_set_name_as_filename() when using
	formatted title.
	(update_window_cursor): Make public when compiling under NS.
	(display_hourglass_p, syms_of_xdisp, hourglass_shown_p)
	(hourglass_atimer, Vhourglass_delay
	* xfaces.c (header section, init_frame_faces, clear_font_table)
	(defined_color, unload_color, x_face_list_fonts)
	(prepare_face_for_display): Add NS support parallel to other GUIs.
	Emulate GCs like other non-X GUIs.
	(split_font_name): Don't lowercase font name under NS.
	(merge_face_ref, Finternal_set_lisp_face_attribute): Support stippling
	under NS.
	* s/darwin.h: Add support for compilation under NS.

2008-07-15  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (Fx_create_frame): Remove duplicate unwind_protect.
	(w32_show_hourglass): Rename from show_hourglass.
	(w32_hide_hourglass): Rename from hide_hourglass.
	(DEFAULT_HOURGLASS_DELAY): Revert from last change.
	(Vhourglass_delay): Declare extern.
	(hourglass_started): Remove.

	* xdisp.c (Vhourglass_delay): Remove static.
	(hourglass_started, start_hourglass, cancel_hourglass):
	Don't include these versions on WINDOWSNT.

2008-07-15  Adrian Robert  <Adrian.B.Robert@gmail.com>

	* dispextern.h (hourglass_shown_p, hourglass_atimer): New extern
	variables (formerly in xfns.c).
	(show_hourglass, hide_hourglass): New prototypes (same).
	* xdisp.c (display_hourglass_p, hourglass_shown_p, hourglass_atimer)
	(Vhourglass_delay, DEFAULT_HOURGLASS_DELAY): New variables (formerly
	in xfns.c).
	(syms_of_xdisp): Declare/initialize display-hourglass,
	hourglass-delay.  Initialize hourglass_atimer, hourglass_shown_p.
	(hourglass_started, start_hourglass, cancel_hourglass): New functions,
	formerly in xfns.c.
	* xfns.c (display_hourglass_p, hourglass_atimer, hourglass_shown_p)
	(Vhourglass_delay, DEFAULT_HOURGLASS_DELAY, hourglass_started)
	(start_hourglass, cancel_hourglass): Remove.
	(show_hourglass, hide_hourglass): Remove prototypes and static
	modifiers.
	(syms_of_xfns): Remove display-hourglass, hourglass-delay,
	hourglass_atimer, hourglass_shown_p declaration/initialization.
	* macfns.c (display_hourglass_p, hourglass_atimer, hourglass_shown_p)
	(Vhourglass_delay, DEFAULT_HOURGLASS_DELAY, hourglass_started)
	(start_hourglass, cancel_hourglass): Remove.
	(show_hourglass, hide_hourglass): Remove prototypes and static
	modifiers.
	(syms_of_macfns): Remove display-hourglass, hourglass-delay,
	hourglass_atimer, hourglass_shown_p declaration/initialization.
	* w32fns.c (display_hourglass_p, Vhourglass_delay)
	(DEFAULT_HOURGLASS_DELAY): Remove.
	(syms_of_w32fns): Remove display-hourglass, hourglass-delay,
	hourglass_shown_p declaration/initialization.

2008-07-14  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (w32_get_arg): Remove wrapper function.
	(w32_createwindow, x_icon, x_create_tip_frame): Use x_get_arg
	directly.
	(Fx_create_frame): Sync with xfns.c.  Use x_get_arg directly.

2008-07-14  Kenichi Handa  <handa@m17n.org>

	* xfont.c (xfont_open): Add workaround for X's bug.

2008-07-14  Emanuele Giaquinta  <emanuele.giaquinta@gmail.com>  (tiny change)

	* fontset.c: Include <stdio.h> unconditionally.

2008-07-13  Michael Albinus  <michael.albinus@gmx.de>

	* dbusbind.c (Fdbus_register_signal): Allow also signal arguments
	for filtering.

2008-07-13  Dan Nicolaescu  <dann@ics.uci.edu>

	* s/vms.h: Use __GNUC__ instead of _GNUC_.

	* m/macppc.h:
	* m/alpha.h: Use GNU_LINUX instead of LINUX.  Reorganize conditionals.

	* m/ibms390x.h (XINT, XUINT): Don't define, same as the default
	(SPECIAL_EMACS_INT):
	* m/ia64.h (SPECIAL_EMACS_INT):
	* m/amdx86-64.h (SPECIAL_EMACS_INT):
	* s/gnu.h (NLIST_STRUCT):
	* s/aix4-2.h (X11R5_INHIBIT_I18N):
	* s/gnu-linux.h (LINUX):
	* s/msdos.h (HAVE_FACES):
	* s/ms-w32.h (HAVE_FACES): Don't define, unused.

	* systty.h:
	* sysdep.c (setup_pty): Don't depend on SYSV_PTYS, it is not used
	anymore.

2008-07-12  Dan Nicolaescu  <dann@ics.uci.edu>

	* syswait.h: Remove old if 0 code.  Do not define WAITTYPE, it was
	always defined as int.

	* s/netbsd.h (HAVE_UNION_WAIT, HAVE_WAIT_HEADER, WAIT_USE_INT):
	* s/gnu.h (HAVE_WAIT_HEADER, WAIT_USE_INT, HAVE_UNION_WAIT):
	* s/gnu-linux.h (HAVE_WAIT_HEADER):
	* s/freebsd.h (HAVE_WAIT_HEADER):
	* s/bsd-common.h (HAVE_UNION_WAIT):
	* s/aix4-2.h (HAVE_WAIT_HEADER):
	* m/mips.h (HAVE_UNION_WAIT):
	* s/usg5-4.h (HAVE_WAIT_HEADER, WAITTYPE): Do not define, not used.
	(COFF, static): Do not define, they are undefined later in the file.

	* process.c (update_status): Don't use a union.
	(status_convert):
	(sigchld_handler): Use int instead of WAITTYPE.

2008-07-12  Chong Yidong  <cyd@stupidchicken.com>

	* indent.c (Fvertical_motion): Restore hscroll before moving to
	goal column.

2008-07-11  Dan Nicolaescu  <dann@ics.uci.edu>

	* lisp.h: Remove left over code.

2008-07-11  Andreas Schwab  <schwab@suse.de>

	* lisp.h: Fix logic in last change.

	* menu.h: New file.
	* menu.c: Include it.
	* xmenu.c: Likewise.
	* Makefile.in: Update dependencies.

2008-07-11  Kenichi Handa  <handa@m17n.org>

	* fontset.c (fontset_from_font): Cancel the previous change.

2008-07-11  Dan Nicolaescu  <dann@ics.uci.edu>

	* lisp.h:
	* w32heap.c:
	* emacs.c:
	* alloc.c: Replace all references of NO_UNION_TYPE with
	USE_LISP_UNION_TYPE.

	* m/xtensa.h (NO_UNION_TYPE):
	* m/vax.h (NO_UNION_TYPE):
	* m/template.h (NO_UNION_TYPE):
	* m/sparc.h (NO_UNION_TYPE):
	* m/mips.h (NO_UNION_TYPE):
	* m/macppc.h (NO_UNION_TYPE):
	* m/m68k.h (NO_UNION_TYPE):
	* m/iris4d.h (NO_UNION_TYPE):
	* m/intel386.h (NO_UNION_TYPE):
	* m/ibms390x.h (NO_UNION_TYPE):
	* m/ibms390.h (NO_UNION_TYPE):
	* m/ibmrs6000.h (NO_UNION_TYPE):
	* m/ia64.h (NO_UNION_TYPE):
	* m/hp800.h (NO_UNION_TYPE):
	* m/arm.h (NO_UNION_TYPE):
	* m/amdx86-64.h (NO_UNION_TYPE):
	* m/alpha.h (NO_UNION_TYPE): Remove definition, all platform were
	defining it the same.

2008-07-10  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c (move_it_to): Backtrack if past the edge of a wrapped line.

2008-07-10  Dan Nicolaescu  <dann@ics.uci.edu>

	* fileio.c:
	* sysdep.c
	* systty.h:
	* m/ibmrs6000.h:
	* m/iris4d.h:
	* s/aix4-2.h:
	* s/freebsd.h:
	* s/gnu-linux.h:
	* s/hpux10-20.h:
	* s/hpux11.h:
	* s/netbsd.h:
	* s/sol2-3.h:
	* s/sol2-4.h:
	* s/sol2.h:
	* s/usg5-4.h:
	* s/vms.h: Remove references to unused variables.

2008-07-10  Andreas Schwab  <schwab@suse.de>

	* ftfont.c (ftfont_resolve_generic_family): Remove foundry from
	pattern before matching the generic family.

2008-07-10  Dan Nicolaescu  <dann@ics.uci.edu>

	* unexec.c:
	* s/vms.h:
	* s/usg5-4-2.h:
	* s/sol2-5.h:
	* s/freebsd.h:
	* s/darwin.h: Remove dead code.

	* m/template.h:
	* m/sparc.h:
	* m/mips.h:
	* m/m68k.h:
	* m/iris4d.h:
	* m/intel386.h:
	* m/ibms390x.h:
	* m/ibms390.h:
	* m/ia64.h:
	* m/hp800.h:
	* m/arm.h:
	* m/amdx86-64.h: Remove dead code and references to unused
	and compiler defined symbols.

	* unexmips.c:
	* unexelf.c: Remove references to desupported systems.

	* m/powermac.h: Remove file, it is now identical to m/macppc.h.

	* m/powermac.h: Remove boilerplate comments.
	(NO_REMAP): Remove unused definition.

	* m/macppc.h (UNEXEC, NO_TERMIO): Don't define, the s/ files
	define them.

2008-07-10  Kenichi Handa  <handa@m17n.org>

	* xfont.c (xfont_open): Log the reason of failure.

2008-07-09  Stefan Monnier  <monnier@iro.umontreal.ca>

	* fontset.c (fontset_get_font_group):
	* font.c (font_check_otf): Specify argument types.

2008-07-09  Kenichi Handa  <handa@m17n.org>

	* coding.c (detect_coding_utf_8): Set detect_info->found only when
	non-ASCII char is found.

	* fontset.c (fontset_compare_rfontdef): Fix plus/minus.
	(reorder_font_vector): Change the arg preferred_family to font.
	Prefer the spec matching with font.
	(fontset_get_font_group): New function.
	(fontset_find_font): Change the format of an element of a realized
	fontset.  Use fontset_get_font_group.
	(fontset_font): Try the current fontset, the default fontset, the
	fallbacks of the current fontset, and the fallbacks of the default
	fontset in this order.
	(face_for_char): Delete the shortcut to use the current font.
	(fontset_from_font): Don't set fonts for Latin in the fontset.

	* font.h (font_make_object, font_match_p): Adjust prototypes.

	* ftfont.h [FT_BDF_H]: Include FT_BDF_H.

	* font.c (font_make_object): New arg entity and pixelsize.
	(font_check_otf_features, font_check_otf): New functions.
	(font_match_p): Check :lang, :script, and :otf properties.

	* xfont.c (xfont_open): Adjust it for the change of
	font_make_object.
	(xfont_text_extents): Fix initial setting of metrics.

	* ftfont.c (struct ftfont_info): New member index, delete member
	fc_charset_idx.  Make the member order compatible with struct
	xftfont_info.
	(fc_charset_table): Change charset names to registry names.
	(ftfont_pattern_entity): Delete the args registry and
	fc_charset_idx.  Change the value of :font-entity property
	to (FONTNAME . INDEX).  Always set :registry property to
	`iso10646-1'.
	(struct ftfont_cache_data): New struct.
	(ftfont_lookup_cache): New arg for_face.
	(ftfont_get_fc_charset, ftfont_get_otf): New functions.
	(ftfont_driver): Set the member otf_capability.
	(ftfont_get_charset): Adjust it for the change of
	fc_charset_table.
	(OTF_TAG_SYM): New macro.
	(ftfont_spec_pattern): Delete the arg fc_charset_idx.  Adjust it
	for the change of fc_charset_table.
	(ftfont_list): Adjust it for the change of ftfont_spec_pattern and
	ftfont_pattern_entity.  Add FC_INDEX to objset.
	(ftfont_match): Adjust it for the change of ftfont_spec_pattern
	and ftfont_pattern_entity.
	(ftfont_open): Adjust it for the change of ftfont_lookup_cache,
	font_make_object, struct ftfont_info.
	(ftfont_has_char): Use ftfont_get_fc_charset.
	(ftfont_otf_features, ftfont_otf_capability): New functions.
	(ftfont_shape): Use ftfont_get_otf.
	(ftfont_text_extents): Fix initial setting of metrics.

	* xftfont.c (struct xftfont_info): New member ft_size.  Make the
	member order compatible with struct ftfont_info.
	(xftfont_open): Add FC_CHARSET to the pattern.  Set
	xftfont_info->ft_size.  Don't unlock the face.  Check BDF
	properties if appropriate.
	(xftfont_close): Unlock the face.
	(xftfont_anchor_point, xftfont_shape): Deleted.
	(syms_of_xftfont): Don't set members anchor_point and shape of
	xftfont_driver.

	* w32uniscribe.c (uniscribe_open): Adjust it for the change of
	font_make_object.

	* w32font.c (w32font_open): Adjust it for the change of
	font_make_object.
	(w32font_open_internal): Don't set properties of font_object here.

2008-07-08  Chong Yidong  <cyd@stupidchicken.com>

	* macfns.c (x_create_tip_frame):
	* w32fns.c (x_create_tip_frame):
	* xfns.c (x_create_tip_frame): Pass parameter argument to
	face-set-after-frame-default.

	* xfaces.c (Finternal_merge_in_global_face): Save merged
	attributes for the default face back into the face vector.

2008-07-08  Andreas Schwab  <schwab@suse.de>

	* fontset.h: Declare fontset_from_font.  Don't declare
	new_fontset_from_font and fontset_from_font_name.
	* xterm.c: Include "fontset.h".
	* Makefile.in (xterm.o): Update dependencies.

2008-07-08  Glenn Morris  <rgm@gnu.org>

	* m/sparc.h: Define __sparc__ rather than sparc.  (Bug#507.)
	* alloc.c, ecrt0.c: Use __sparc__ rather than sparc.

2008-07-07  Chong Yidong  <cyd@stupidchicken.com>

	* frame.c (Qinhibit_face_set_after_frame_default): Var deleted.
	(x_set_frame_parameters): Don't bind it.

2008-07-07  Juanma Barranquero  <lekktu@gmail.com>

	* w32fns.c (map_w32_filename): Declare extern.

2008-07-07  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (WS_EX_LAYERED): Define if not already.

2008-07-06  Chong Yidong  <cyd@stupidchicken.com>

	* xfaces.c (set_font_frame_param): Don't try to set the font
	parameter if it is still unspecified in the lface.

2008-07-05  Chong Yidong  <cyd@stupidchicken.com>

	* xfaces.c (Finternal_merge_in_global_face): Don't realize default
	face if it didn't already exist.

	* xdisp.c (try_window_id): Give up if word-wrapping is on.

2008-07-05  Andreas Schwab  <schwab@suse.de>

	* xdisp.c (get_it_property): Move out of HAVE_WINDOW_SYSTEM section.

2008-07-05  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c (IT_OVERFLOW_NEWLINE_INTO_FRINGE): Turn it off if
	word-wrapping.
	(IT_DISPLAYING_WHITESPACE): New macro.
	(move_it_in_display_line_to): Handle MOVE_TO_X requests properly
	when word-wrapping.  Simplify word-wrapping logic.  Use correct
	pixel positions when saving copies of the iterator.
	(display_line): Use proper wrap point if the last character on a
	line was preceded by whitespace.

2008-07-04  Stefan Monnier  <monnier@iro.umontreal.ca>

	* Makefile.in (${etc}DOC): Depend on ${lisp} rather than ${shortlisp}.

2008-07-04  Kenichi Handa  <handa@m17n.org>

	* fns.c (Fstring_to_unibyte): Delete the arg ACCEPT-LATIN-1.

	* lisp.h: EXFUN adjusted for the change of Fstring_to_unibyte.

2008-07-02  Jason Rumney  <jasonr@gnu.org>

	* xfns.c (syms_of_xfns): Only define x-select-font when both
	HAVE_FREETYPE and USE_GTK

	* xdisp.c (next_element_from_display_vector): Move assignment out
	of if statement.

2008-07-02  Toru Tsuneyoshi  <t_tuneyosi@hotmail.com>

	* lisp.h (Qdelete_file, Qdelete_directory): Declare extern.

	* fileio.c (delete_by_moving_to_trash, Qmove_file_to_trash): New vars.
	(syms_of_fileio): Initialize and export them.
	(Fdelete_directory, Fdelete_file): Optionally delete via trash.

	* w32fns.c (FOF_NO_CONNECTED_ELEMENTS): Define if not already.
	(Fsystem_move_file_to_trash): New function.
	(syms_of_w32fns): Export it to lisp.

2008-07-01  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_text_extents): Don't count overhang as part
	of width.

2008-06-30  Miles Bader  <miles@gnu.org>

	* dispextern.h (struct glyph, struct it, struct iterator_stack_entry):
	Add `avoid_cursor_p' field.

	* xdisp.c (push_it, pop_it): Save/restore avoid_cursor_p field.
	(set_cursor_from_row): Skip glyphs with avoid_cursor_p set.
	(append_glyph, append_composite_glyph, produce_image_glyph)
	(append_stretch_glyph): Initialize avoid_cursor_p.
	(get_it_property): Rename from `get_line_height_property'.
	(x_produce_glyphs): Use get_it_property.
	(handle_line_prefix, push_display_prop): New functions.
	(display_line, move_it_in_display_line_to): Handle line/wrap prefixes.
	(Vwrap_prefix, Qwrap_prefix, Vline_prefix, Qline_prefix):
	New variables.
	(syms_of_xdisp): Initialize them.

2008-06-30  Kenichi Handa  <handa@m17n.org>

	* xftfont.c (xftfont_open): Don't call FcConfigSubstitute and
	XftDefaultSubstitute (they are called in XftFontMatch).
	(xftfont_open): Fix args to ftfont_font_format.

	* ftfont.c (fc_charset_table): New member lang.
	(ftfont_resolve_generic_family): New arg pattern.
	(ftfont_spec_pattern): Check fc_cahrset_table[]->lang.
	(ftfont_list): Call ftfont_resolve_generic_family with `pattern'.
	(ftfont_open): Fix args to ftfont_font_format.
	(ftfont_font_format): New arg filename.

2008-06-30  Chong Yidong  <cyd@stupidchicken.com>

	* xfaces.c (Finternal_merge_in_global_face): If default face was
	modified, realize it again.  Update the font face attribute.

2008-06-29  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (x_set_frame_alpha): Fix logic.

2008-06-29  Kenichi Handa  <handa@m17n.org>

	* fontset.c (Finternal_char_font): Return font-object instead of
	font-name.

	* composite.c (get_composition_id): Fix the width calculation for TAB.

2008-06-29  Stefan Monnier  <monnier@iro.umontreal.ca>

	* indent.c (Fvertical_motion): Properly handle float column arg.

2008-06-28  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (pfnGetFontUnicodeRanges): Remove unused function pointer.
	(pfnSetLayeredWindowAttributes): New function pointer.
	(w32_initialize): Initialize it when supported.
	(x_set_frame_alpha): New function.

	* w32fns.c (Fx_create_frame): Initialize frame parameter `alpha'.
	(w32_frame_parm_handlers): Set alpha handler.

	* frame.c (x_set_alpha) [HAVE_NTGUI]: Call x_set_frame_alpha.

2008-06-27  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (x_to_w32_font, w32_to_x_font, x_to_w32_weight)
	(w32_to_x_weight, w32_to_all_x_charsets): Remove obsolete functions.
	(w32_to_x_charset, x_to_w32_charset)
	(Qw32_charset_ansi, Qw32_charset_symbol, Qw32_charset_default)
	(Qw32_charset_shiftjis, Qw32_charset_hangeul, Qw32_charset_johab)
	(Qw32_charset_chinesebig5, Qw32_charset_gb2312, Qw32_charset_oem)
	(Qw32_charset_easteurope, Qw32_charset_turkish, Qw32_charset_baltic)
	(Qw32_charset_russian, Qw32_charset_arabic, Qw32_charset_greek)
	(Qw32_charset_hebrew, Qw32_charset_vietnamese, Qw32_charset_thai)
	(Qw32_charset_mac, Vw32_charset_info_alist): Move to w32font.c.
	(Qw32_charset_unicode): Remove.
	(syms_of_w32fns): Update for above changes.

	* w32font.c (w32_to_x_charset, x_to_w32_charset)
	(Qw32_charset_ansi, Qw32_charset_symbol, Qw32_charset_default)
	(Qw32_charset_shiftjis, Qw32_charset_hangeul, Qw32_charset_johab)
	(Qw32_charset_chinesebig5, Qw32_charset_gb2312, Qw32_charset_oem)
	(Qw32_charset_easteurope, Qw32_charset_turkish, Qw32_charset_baltic)
	(Qw32_charset_russian, Qw32_charset_arabic, Qw32_charset_greek)
	(Qw32_charset_hebrew, Qw32_charset_vietnamese, Qw32_charset_thai)
	(Qw32_charset_mac, Vw32_charset_info_alist): Move from w32fns.c.
	(syms_of_w32font): Update for above changes.

2008-06-27  Dan Nicolaescu  <dann@ics.uci.edu>

	* s/usg5-4.h: Fix previous change: keep the correct branch of a
	removed #if.
	(USG_SHARED_LIBRARIES): Remove duplicate definition.

2008-06-26  Juanma Barranquero  <lekktu@gmail.com>
	    Eli Zaretskii  <eliz@gnu.org>

	* makefile.w32-in (LOCAL_FLAGS):
	Don't include WINDOWSNT, DOS_NT and _UCHAR_T.

	* sysdep.c (_spawnlp, _getpid):
	Declare with explicit _cdecl instead of _CRTAPI1.

	* editfns.c (Fget_internal_run_time):
	Check for WINDOWSNT with #ifdef, not #if.

2008-06-26  Jason Rumney  <jasonr@gnu.org>

	* w32font.h (FONT_HANDLE, FONT_TEXTMETRIC): New macros.

	* w32term.c (x_draw_glyph_string_foreground)
	(x_draw_composite_glyph_string_foreground): Sync with xterm.c.
	Use FONT_HANDLE macro.
	(x_draw_glyph_string): Use FONT_TEXTMETRIC macro.

	* w32uniscribe.c (uniscribe_otf_capability, uniscribe_shape)
	(uniscribe_encode_char): Use FONT_HANDLE macro.

	* w32font.c (Fx_select_font): Use FONT_HANDLE macro.
	(w32font_text_extents): Use precast w32_font.
	(w32font_close): Free cached metrics.
	(w32font_open_internal): Allocate space for name on stack.

2008-06-26  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c (extend_face_to_end_of_line): Fix last change.

2008-06-26  Jason Rumney  <jasonr@gnu.org>

	* w32term.h (FONT_AVG_WIDTH): Remove obsolete macro.
	(CP_8BIT, CP_UNICODE, CP_UNKNOWN): Remove obsolete constants.

2008-06-26  Juanma Barranquero  <lekktu@gmail.com>

	* Makefile.in (SOME_MACHINE_OBJECTS): Remove w32bdf.o.

2008-06-26  Jason Rumney  <jasonr@gnu.org>

	* w32bdf.c, w32bdf.h: Remove obsolete files.

	* makefile.w32-in: Remove refs to w32bdf.h and w32bdf.c.

	* w32gui.h: Don't include w32bdf.h.
	(XCharStruct, enum w32_char_font_type, W32FontStruct):
	Remove obsolete font support.

	* w32font.h (struct w32font_info): Remove compat_w32_font.
	Add hfont member.
	(FONT_COMPAT): Remove obsolete macro.

	* w32font.c (w32font_close): Remove compat code.  Delete hfont member.
	(w32font_encode_char, w32font_text_extents): Use new hfont member.
	(w32font_open_internal): Remove compat code.  Set new hfont member.
	(Fx_select_font): Use new hfont member.

	* w32uniscribe.c (uniscribe_otf_capability, uniscribe_shape)
	(uniscribe_encode_char): Use new hfont member.

	* w32term.c (x_draw_glyph_string_foreground)
	(x_draw_composite_glyph_string_foreground): Use new hfont member.
	(x_draw_glyph_string): Use metrics in w32font_info.

2008-06-26  Kenichi Handa  <handa@m17n.org>

	* xdisp.c (handle_auto_composed_prop): Fix for the terminal case.

2008-06-26  Dan Nicolaescu  <dann@ics.uci.edu>

	* unexnext.c:
	* m/ews4800.h:
	* m/hp9000s300.h:
	* m/ibm370aix.h:
	* m/mips-siemens.h:
	* m/ncr386.h:
	* m/next.h:
	* m/pmax.h:
	* m/powerpcle.h:
	* m/tandem-s2.h:
	* s/386bsd.h:
	* s/bsd386.h:
	* s/bsd4-1.h:
	* s/bsd4-2.h:
	* s/bsdos2-1.h:
	* s/bsdos2.h:
	* s/bsdos3.h:
	* s/bsdos4.h:
	* s/nextstep.h:
	* s/ultrix4-3.h:
	* s/usg5-0.h:
	* s/usg5-2-2.h:
	* s/usg5-2.h:
	* s/usg5-4-3.h:
	* s/ux4800.h:
	* s/uxpds.h:
	* s/uxpv.h: Remove support for obsolete systems.
	* s/hpux.h, s/hpux10.h, s/hpux8.h, s/hpux9.h, s/hpux9shr.h:
	Remove, insert contents in s/hpux-10.20.h.
	* s/aix3-1.h, s/aix3-2-5.h, s/aix3-2.h, s/aix4-1.h, s/aix4.h:
	Remove, insert contents in s/aix4-2.h.
	* s/usg5-3.h: Remove, insert contents in s/usg5-4.h.
	* s/bsd4-3.h: Rename to ...
	* s/bsd-common.h: ... this.
	* data.c:
	* doc.c:
	* ecrt0.c:
	* emacs.c:
	* fileio.c:
	* floatfns.c:
	* keyboard.c:
	* mem-limits.h:
	* print.c:
	* process.c:
	* sysdep.c:
	* syssignal.h:
	* systty.h:
	* syswait.h:
	* term.c:
	* unexec.c:
	* unexelf.c:
	* unexhp9k800.c:
	* m/hp800.h:
	* m/ibmrs6000.h:
	* m/mips.h:
	* m/vax.h:
	* s/darwin.h:
	* s/freebsd.h:
	* s/gnu.h:
	* s/ms-w32.h:
	* s/msdos.h:
	* s/netbsd.h:
	* s/template.h: Remove references to obsolete variables.

	* Makefile.in: Add dependencies for all unexec files.
	(admindir): Remove unused variable.
	(UNEXEC_SRC): Remove references.

2008-06-25  Chong Yidong  <cyd@stupidchicken.com>

	* xfns.c (x_default_font_parameter): If Xft is available, first
	try Monospace-12 for the default font.

2008-06-25  Jason Rumney  <jasonr@gnu.org>

	* xdisp.c (get_glyph_face_and_encoding): Encode invalid glyphs as 0.

2008-06-25  Stefan Monnier  <monnier@iro.umontreal.ca>

	* bytecode.c (Fbyte_code): Disable debugging code that doesn't compile.

	* buffer.c (syms_of_buffer): Remove default-word-wrap.

2008-06-25  Juanma Barranquero  <lekktu@gmail.com>

	* xdisp.c (syms_of_xdisp) <truncate-partial-width-windows>: Doc fix.
	<scroll-conservatively>: Fix typo in docstring.

	* xselect.c (Fx_send_client_event): Doc fix.

2008-06-25  Kenichi Handa  <handa@m17n.org>

	* xfaces.c (Fx_list_fonts): Call Flist_fonts with the arg PREFER.

	* font.c (font_parse_fcname): Remove unused variables.
	(font_sort_entites): Delete the arg SPEC.  Caller changed.
	Fix for the case of ! best_only.
	(font_delete_unmatched): Check DPI and AVGWIDTH too.

	* lisp.h (Fstring_to_unibyte): EXFUN it.

	* character.h (str_to_unibyte): Extern it.

	* character.c (str_to_unibyte): New function.

	* fns.c (Fstring_to_unibyte): New function.
	(syms_of_fns): Defsubr it.

2008-06-24  Kenichi Handa  <handa@m17n.org>

	* font.c (font_score): Even if the PIXEL_SIZE is the same, check
	DPI too.
	(font_sort_entites): Setup prefer_prop[FONT_DPI_INDEX] too.

2008-06-24  Andreas Schwab  <schwab@suse.de>

	* Makefile.in (${lispsource}loaddefs.el): Rename from
	../lisp/loaddefs.el.
	(bootstrap-clean): Do what distclean does but don't remove
	Makefile.
	(distclean): Depend on bootstrap-clean and remove Makefile.

2008-06-24  Chong Yidong  <cyd@stupidchicken.com>

	* buffer.h (struct buffer): New member word_wrap.

	* buffer.c (syms_of_buffer): New variables default-word-wrap and
	word-wrap.
	(init_buffer_once): Initialize them.

	* dispextern.h (struct it): Replace bool truncate_lines_p with a
	line_wrap enum possessing three possible values.

	* termopts.h: Replace truncate_partial_width_windows with
	Vtruncate_partial_width_windows.

	* dispnew.c (direct_output_for_insert): Avoid direct output when
	inserting a space with word wrap on.

	* indent.c (compute_motion): Obey integer values of
	truncate-partial-width-windows.

	* xdisp.c (Vtruncate_partial_width_windows): New Lisp_Object,
	replacing truncate_partial_width_windows.
	(init_iterator): If Vtruncate_partial_width_windows is an integer,
	truncate only if the window width is below that integer.
	(start_display, resize_mini_window, produce_stretch_glyph)
	(display_string, move_it_in_display_line_to): Use line_wrap.
	(back_to_previous_visible_line_start, reseat_1): Reset
	string_from_display_prop_p.
	(display_line): Extend default face to end of line when wrapping.

2008-06-24  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (display_line, move_it_in_display_line_to): Add ability
	to wrap continued lines at word boundaries.

2008-06-24  Jason Rumney  <jasonr@gnu.org>

	* font.c (Ffont_face_attributes): Multiply pixel size before point
	conversion to avoid multiplying rounding error.

2008-06-23  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (x_draw_glyph_string_background)
	(x_draw_glyph_string): Remove old bdf font code.

	* w32term.h (FONT_TYPE_FOR_UNIBYTE, FONT_TYPE_FOR_MULTIBYTE): Remove.

2008-06-22  Kenichi Handa  <handa@m17n.org>

	* font.c (font_find_for_lface): Try the adstyle specified in
	the property of LFACE_FONT of LFACE (if any).

2008-06-21  Seiji Zenitani  <zenitani@mac.com>
	    Ryo Yoshitake  <ryo@shiftmode.net>

	* xterm.c (x_set_frame_alpha): Add x_catch_errors for bug#437.

2008-06-22  Stefan Monnier  <monnier@iro.umontreal.ca>

	* Makefile.in (${lisp} ${SOME_MACHINE_LISP}, ../lisp/loaddefs.el):
	Use $(BOOTSTRAPEMACS) rather than witness-emacs.
	(bootstrap-emacs${EXEEXT}): Merge witness-emacs into it.
	(witness-emacs): Remove.
	(lisp, shortlisp): Move loaddefs.el earlier.
	(mostlyclean): Forget about witness-emacs.

2008-06-22  Glenn Morris  <rgm@gnu.org>

	* Makefile.in (witness-emacs): Depend on temacs${EXEEXT}.
	(.SUFFIXES): Declare .el.elc as a suffix rule, for non-GNU makes.

2008-06-21  Stefan Monnier  <monnier@iro.umontreal.ca>

	* Makefile.in (PRECOMP): Remove.
	(${lisp} ${SOME_MACHINE_LISP}): Remove pseudo dependency on PRECOMP.
	(witness-emacs): Run `compile-first'.
	(.el.elc): Use the new compile-onefile target.

2008-06-21  Kenichi Handa  <handa@m17n.org>

	* xftfont.c (xftfont_open): Handle QCembolden only when
	FC_EMBOLDEN is defined.

2008-06-21  Andreas Schwab  <schwab@suse.de>

	* Makefile.in (witness-emacs): Use ../lisp, not $(lispsource).
	(.el.elc): Likewise.

2008-06-21  Miles Bader  <miles@gnu.org>

	* Makefile.in (../lisp/loaddefs.el): Build autoloads in the lisp
	build dir, not the lisp source dir.

2008-06-21  Stefan Monnier  <monnier@iro.umontreal.ca>

	* Makefile.in (emacs${EXEEXT}): Link the new emacs to bootstrap-emacs.
	(bootstrapclean): Remove.
	(.el.elc): New rule.
	(PRECOMP): New var.
	(../lisp/subdirs.el): Remove.
	(bootstrap-emacs${EXEEXT}): Remove subdirs.el and charpro.el dependency.
	(witness-emacs): New target.
	(mostlyclean): Remove witness-emacs as well.
	(../lisp/loaddefs.el, ${lisp} ${SOME_MACHINE_LISP}):
	Add witness-emacs dependency.

2008-06-20  Chong Yidong  <cyd@stupidchicken.com>

	* font.c (Ffont_face_attributes): Omit key-attribute pairs not
	defined by the font.

2008-06-20  Stefan Monnier  <monnier@iro.umontreal.ca>

	* Makefile.in (emacs${EXEEXT}): Depend on the machine-specific files.
	(bootstrap-clean): New target that keeps TAGS around.
	(../lisp/subdirs.el, ../lisp/loaddefs.el): New targets.
	(bootstrap-emacs${EXEEXT}): Depend on subdirs.el.

2008-06-20  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c, w32term.c, w32term.h, w32gui.h [OLD_FONT]:
	Remove obsolete font code.

	* w32font.c (font_matches_spec): Use csb bitfield from font signature
	to determine language support.

2008-06-20  Stefan Monnier  <monnier@iro.umontreal.ca>

	* sysdep.c (cfsetspeed): New fun extracted from the code.
	(cfmakeraw): Move before first use.

2008-06-20  Angelo Graziosi  <angelo.graziosi@alice.it>  (tiny change)

	* sysdep.c (cfmakeraw): Provide fallback implementation.
	(serial_configure): Provide fallback implementation of cfsetspeed.

2008-06-20  Kenichi Handa  <handa@m17n.org>

	* xftfont.c (xftfont_open): Add FOUNDRY, SPACING, DPI, SCALABLE to
	the pattern.

	* fontset.c (fontset_from_font): Copy font_spec before changing
	the elements.

	* xfns.c (x_default_font_parameter): Try "monospace-12" too.

2008-06-20  Stefan Monnier  <monnier@iro.umontreal.ca>

	* w32fns.c, xfns.c (x_default_font_parameter): Only set `font-param'
	for explicit `font' parameters.

	* frame.c (x_set_font): Remove unexplained call to fix inf-recursion.

2008-06-19  Kenichi Handa  <handa@m17n.org>

	* frame.c: Include <ctype.h>.
	(x_set_font_backend): Allow spacing characters in the X resource
	for FontBackend.

2008-06-19  Stefan Monnier  <monnier@iro.umontreal.ca>

	* w32fns.c, xfns.c (Qfont_param): New var.
	(syms_of_w32fns): Initialize it.
	(x_default_font_parameter): Record explicit `font' into
	`font-parameter'.

2008-06-18  Kenichi Handa  <handa@m17n.org>

	* font.c (font_parse_xlfd): Fix previous change.
	(font_parse_fcname): Don't use :fc-unknown-spec.
	(FRAME_X_DISPLAY_INFO): Be sure to have at least 1 pixel height.
	(Fcopy_font_spec): Preserve the order of elements in FONT_EXTRA.
	(font_add_log): Prepend the driver name to the resulting fonts.

	* ftfont.c (ftfont_pattern_entity): New arg extra.  Caller changed.
	(ftfont_spec_pattern): Don't check QCfc_unknown_spec and QCname.
	(ftfont_list) [FC_FONTFORMAT]: Include FC_FONTFORMAT in objset.

	* xftfont.c (QChinting , QCautohint, QChintstyle, QCrgba)
	(QCembolden): New variables.
	(syms_of_xftfont): DEFSYM them.
	(xftfont_open): Call XftFontMatch.  Don't trust the result of
	XftTextExtents8 if the pixel_size is less than 5.

2008-06-18  Andreas Schwab  <schwab@suse.de>

	* font.c (Ffont_face_attributes): Only define if HAVE_WINDOW_SYSTEM.
	(syms_of_font): Only defsubr if HAVE_WINDOW_SYSTEM.

2008-06-18  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_list, w32font_match): Add logging.

	* w32uniscribe.c (uniscribe_list, uniscribe_match): Add logging.

2008-06-17  Chong Yidong  <cyd@stupidchicken.com>

	* font.c (font_parse_fcname): Store divider characters for
	unknown-spec list.  For known key symbols, intern using correct
	symbol name.

2008-06-17  Kenichi Handa  <handa@m17n.org>

	* xfaces.c (realize_default_face): If the frame is not on window
	system, set the fontset of face to nil.

2008-06-17  Naohiro Aota  <nao.aota@gmail.com>  (tiny change)

	* fontset.c (fontset_pattern_regexp): Escape some reg-expr characters.

2008-06-16  Juanma Barranquero  <lekktu@gmail.com>

	* dispextern.h (lookup_non_ascii_face, split_font_name_into_vector)
	(build_font_name_from_vector): Delete externs.

	* xfaces.c (struct font_name): Don't declare.

2008-06-16  Stefan Monnier  <monnier@iro.umontreal.ca>

	* font.c (font_unparse_gtkname): Use EQ to compare Lisp_Objects.

2008-06-16  Chong Yidong  <cyd@stupidchicken.com>

	* font.c (font_parse_fcname): Fix handling of unknown-spec string.

2008-06-16  Juanma Barranquero  <lekktu@gmail.com>

	* font.c (Ffont_spec): Fix usage in docstring.
	(Ffont_face_attributes): Doc fix.

2008-06-16  Andreas Schwab  <schwab@suse.de>

	* font.c (Ffont_face_attributes): Fix definition.

2008-06-16  Jason Rumney  <jasonr@gnu.org>

	* font.h (font_style_symbolic_from_value): Remove.

	* font.c (font_style_symbolic_from_value): Remove.
	(font_style_symbolic): Revert to pre 2008-06-13 version.

	* w32font.c (w32_to_fc_weight): New function.
	(w32font_full_name, logfont_to_fcname): Use it.

2008-06-16  Kenichi Handa  <handa@m17n.org>

	* font.c (font_check_object): Delete it.
	(font_clear_cache): Check if a font-object is alive.
	(font_open_entity): Likewise.  Set FONT_OBJLST_INDEX of a
	font-object to nil.
	(font_close_object): Don't check FONT_CLOSE_OBJECT.
	(font_at): Don't call font_check_object.
	(Ffont_get): Return a symbol for :weight, :slant, and :width.

2008-06-16  Katsumi Yamaoka  <yamaoka@jpl.org>

	* puresize.h (BASE_PURESIZE): Increase to 1230000.

2008-06-16  Chong Yidong  <cyd@stupidchicken.com>

	* font.c (font_parse_fcname): Correctly parse KEY=VAL values.

2008-06-15  Chong Yidong  <cyd@stupidchicken.com>

	* font.c (font_parse_fcname): Only one decimal point.
	(font_unparse_fcname): Handle data in family and foundry indices
	as symbols, not strings.
	(font_unparse_gtkname, Ffont_face_attributes): New functions.

	* xfns.c (Fx_select_font): Give GTK font dialog the default font name.

	* font.h (font_unparse_gtkname): Add prototype.

2008-06-15  Naohiro Aota  <nao.aota@gmail.com>  (tiny change)

	* fontset.c (fontset_pattern_regexp): Escape `+' characters in pattern.

2008-06-15  Andreas Schwab  <schwab@suse.de>

	* font.c (font_update_drivers): Fix crash when no drivers match.

2008-06-15  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xfns.c (Fx_create_frame): internal-border-width default to 0 for Gtk.
	* gtkutil.c (xg_create_frame_widgets): Don't set internal_border_width.

2008-06-14  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xdisp.c (syms_of_xdisp): Default underline-minimum-offset to 1.

2008-06-13  Stefan Monnier  <monnier@iro.umontreal.ca>

	* process.c (Fserial_process_configure, Fprocess_send_eof):
	Use EQ to compare Lisp_Objects.

2008-06-13  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (Fw32_select_font): Remove old font API function.

	* w32font.c (logfont_to_fcname): New function.
	(Fx_select_font): New font dialog function compatible with
	GTK/fontconfig version.

	* font.c (font_style_symbolic_from_value): New function.
	(font_style_symbolic): Use it.

	* font.h (font_style_symbolic_from_value): Declare new function.

2008-06-13  Juanma Barranquero  <lekktu@gmail.com>

	* font.c (syms_of_font) <font-weight-table, font-slant-table>:
	<font-width-table>: Fix typos in docstrings.

2008-06-13  Daniel Engeler  <engeler@gmail.com>

	These changes add serial port access.
	* process.c: Add HAVE_SERIAL.
	(Fdelete_process, Fprocess_status, Fset_process_buffer)
	(Fset_process_filter, Fset_process_sentinel, Fprocess_contact)
	(list_processes_1, select_wrapper, Fstop_process)
	(Fcontinue_process, Fprocess_send_eof, kill_buffer_processes)
	(status_notify): Modify to handle serial processes.
	[HAVE_SERIAL] (Fserial_process_configure)
	[HAVE_SERIAL] (make_serial_process_unwind, Fmake_serial_process):
	New functions.
	* process.h (struct Lisp_Process): Add `type'.
	* sysdep.c [HAVE_TERMIOS] (serial_open, serial_configure):
	New functions.
	* w32.c (_sys_read_ahead, sys_read, sys_write): Modify to handle
	serial ports.
	(serial_open, serial_configure) New functions.
	* w32.h: Add FILE_SERIAL.
	(struct _child_process): Add ovl_read, ovl_write.

2008-06-13  Kenichi Handa  <handa@m17n.org>

	* dispextern.h (enum lface_attribute_index): New member
	LFACE_FOUNDRY_INDEX.

	* font.c (font_score): Delete arg alternate_families.  Check only
	weight, slant, width, and size.  Ignore the difference of alias
	style symbols.
	(font_sort_entites): Adjust for the above change.  Reflect the
	order of font-driver to scores.
	(font_list_entities): Don't check alternate_familes here.
	(font_clear_prop): Handle foundry.
	(font_update_lface): Don't parse "foundry-family" form here.
	Handle FONT_FOUNDRY_INDEX.
	(font_find_for_lface): Likewise.  Handle alternate families here.
	If registry is nil, try iso8859-1 and ascii-0.
	(font_open_for_lface): Pay attention to size in ENTITY.
	(font_open_by_name): Simplify by calling font_load_for_lface.
	(free_font_driver_list): Delete it.
	(font_update_drivers): Preserve the order of backends.
	(syms_of_font): Setting of sort_shift_bits adjusted for the change
	of font_score and font_sort_entites.
	(font_update_sort_order): Likewise.

	* xfaces.c (LFACE_FOUNDRY): New macro.
	(check_lface_attrs): Check foundry.
	(set_lface_from_font): Don't parse "FOUNDRY-FAMILY" form.
	(merge_face_vectors): Check foundry.
	(merge_face_ref): Likewise.
	(Finternal_set_lisp_face_attribute): Likewise.
	(x_update_menu_appearance): Likewise.
	(Finternal_get_lisp_face_attribute): Likewise.
	(lface_hash): Likewise.
	(lface_same_font_attributes_p): Likewise.
	(x_supports_face_attributes_p): Likewise.
	(tty_supports_face_attributes_p): Likewise.
	(Finternal_set_alternative_font_family_alist): Intern strings.
	(Finternal_set_alternative_font_registry_alist): Downcase strings.
	(realize_default_face): Set LFACE_FOUNDRY (lface).

	* xfns.c (Fx_create_frame, x_create_tip_frame): Register X
	font-driver at first.

	* ftfont.c (ftfont_font_format) [! FC_FONTFORMAT]: Declare "int len;".

2008-06-12  Emanuele Giaquinta  <emanuele.giaquinta@gmail.com>  (tiny change)

	* lread.c (Fload): Use xfree, not free on saved_doc_string.

2008-06-12  Jim Meyering  <meyering@redhat.com>

	Make unexec_free handle NULL the same way free does.
	* unexmacosx.c (unexec_free): Ignore a NULL argument.

2008-06-12  Stefan Monnier  <monnier@iro.umontreal.ca>

	* character.h (CHAR_TO_BYTE_SAFE): New macro.
	* character.c (Fmultibyte_char_to_unibyte): Obey the docstring.
	* regex.c (RE_CHAR_TO_UNIBYTE): Use the new macro.
	(WEAK_ALIAS): Simplify.
	* syntax.c (skip_chars): Don't mark non-byte chars in the fastmap
	when searching a unibyte buffer.

2008-06-12  Chong Yidong  <cyd@stupidchicken.com>

	* xfns.c (Fx_select_font): Rename from x-font-dialog.

2008-06-12  Juanma Barranquero  <lekktu@gmail.com>

	* w32font.c: Include ctype.h.

2008-06-11  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_encode_char): Detect missing glyphs that are
	misreported as space.
	(add_font_entity_to_list): Support unicode-bmp and unicode-sip
	as aliases for registry iso10646-1.

2008-06-11  Stefan Monnier  <monnier@iro.umontreal.ca>

	* buffer.c (clone_per_buffer_values): Skip `name'.

2008-06-11  Chong Yidong  <cyd@stupidchicken.com>

	* font.c (font_parse_fcname): Fix last change; accept decimal
	points in font size.

2008-06-10  Jason Rumney  <jasonr@gnu.org>

	* w32uniscribe.c (add_opentype_font_name_to_list):
	Skip non unicode fonts.

2008-06-10  Chong Yidong  <cyd@stupidchicken.com>

	* xfns.c (Fx_font_dialog): New function.

	* gtkutil.c (xg_dialog_response_cb): Rename from
	xg_file_response_callback.
	(pop_down_dialog): Rename from pop_down_file_dialog.
	(xg_get_file_name): Callers changed.
	(xg_get_font_name): New function.

	* gtkutil.h (xg_get_font_name): Insert prototype.

2008-06-10  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xdisp.c (underline_minimum_offset): Rename from xterm.c's
	x_underline_minimum_display_offset.
	(syms_of_xdisp): Declare it here rather than in xterm.c.
	* dispextern.h (underline_minimum_offset): Declare it.
	* w32term.c (x_draw_glyph_string): Use it.
	* xterm.c (x_underline_minimum_display_offset): Move to xdisp.c.
	(syms_of_xterm): Don't declare it any more.
	(x_draw_glyph_string): Adjust to the new name.

2008-06-10  David De La Harpe Golden  <david@harpegolden.net>  (tiny change)

	* xterm.c (x_underline_minimum_display_offset): New var.
	(x_draw_glyph_string): Use it.
	(syms_of_xterm): Declare it.

2008-06-10  Chong Yidong  <cyd@stupidchicken.com>

	* font.c (font_parse_fcname): Accept GTK-style font names too.

2008-06-10  Stefan Monnier  <monnier@iro.umontreal.ca>

	* dired.c (file_name_completion): Don't return t if the match is exact
	but with different capitalization.
	* minibuf.c (Ftry_completion): Simplify.

	* window.c (Vwindow_point_insertion_type): New var.
	(set_window_buffer): Use it.
	(syms_of_window): Init and export it to Lisp.

2008-06-10  Kenichi Handa  <handa@m17n.org>

	* font.h (font_intern_prop): Prototype adjusted.

	* font.c (font_intern_prop): New arg force_symbol.
	(font_parse_xlfd, font_parse_fcname, font_parse_family_registry):
	Adjust for the change of font_intern_prop.

	* ftfont.c (ftfont_pattern_entity):
	* w32font.c (add_font_name_to_list, w32_enumfont_pattern_entity)
	(w32_registry):
	* w32uniscribe.c (add_opentype_font_name_to_list): Adjust for
	the change of font_intern_prop.

2008-06-09  Juanma Barranquero  <lekktu@gmail.com>

	* w32menu.c (digest_single_submenu): Declare extern.

2008-06-09  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (x_make_frame_visible): Use alternate restore flags.

	* w32menu.c (Fx_popup_menu): Unwind protect while building menu.
	(parse_single_submenu): Remove.
	(digest_single_submenu): Remove.
	(syms_of_w32menu): Don't initialise variables that have moved
	to menu.c.
	(set_frame_menubar): Sync with version in xmenu.c.
	(w32_menu_show): Sync with xmenu_show in xmenu.c.

	* menu.c (single_keymap_panes, push_menu_pane, push_menu_item):
	Make static again.

2008-06-09  Jason Rumney  <jasonr@gnu.org>

	Changes to w32 files related to the move of common menu code
	to menu.c on 2008-06-08 by Chong Yidong.

	* menu.c [HAVE_NTGUI]: Include w32term.h, move widget related
	defs to w32gui.h.
	(single_keymap_panes, push_menu_item, push_menu_pane):
	Make globally visible.

	* w32menu.c (enum button_type, widget_value, local_heap, local_alloc)
	(local_free, malloc_widget_value, free_widget_value)
	(MENU_ITEMS_ITEM_NAME, MENU_ITEMS_ITEM_ENABLE, MENU_ITEMS_ITEM_VALUE)
	(MENU_ITEMS_ITEM_EQUIV_KEY, MENU_ITEMS_ITEM_DEFINITION)
	(MENU_ITEMS_ITEM_TYPE, MENU_ITEMS_ITEM_SELECTED, MENU_ITEMS_ITEM_HELP)
	(MENU_ITEMS_ITEM_LENGTH, enum menu_item_idx): Remove defs.
	(menu_items, menu_items_allocated, menu_items_used)
	(menu_items_n_panes, menu_items_submenu_depth): Remove global vars.
	(init_menu_items, finish_menu_items, discard_menu_items)
	(grow_menu_items, push_submenu_start, push_submenu_end)
	(push_left_right_boundary, push_menu_pane, push_menu_item)
	(keymap_panes, single_keymap_panes, list_of_panes, list_of_items)
	(free_menubar_widget_tree_value, parse_single_submenu)
	(update_submenu_strings): Remove functions.
	(xmalloc_widget_value): Remove and declare extern.

	* makefile.w32-in ($(SRC)/menu.$(O)): New target.
	(OBJ1): Build it.

	* w32gui.h (widget_value, XtPointer, Boolean, enum button_type)
	(local_heap, local_alloc, local_free, malloc_widget_value)
	(free_widget_value): Define here.

2008-06-09  Kenichi Handa  <handa@m17n.org>

	* font.h (Qascii_0): Extern it.

	* font.c (Qascii_0): New variable.
	(syms_of_font): DEFSYM it.
	(font_open_by_name): If the registry "iso8859-1" fails, try also
	"ascii-0".

	* ftfont.c (ftfont_spec_pattern): Accept the registry `ascii-0'.

2008-06-08  Kenichi Handa  <handa@m17n.org>

	* .gdbinit (xfont): New command.

2008-06-08  Andreas Schwab  <schwab@suse.de>

	* menu.c [HAVE_X_WINDOWS]: Include "xterm.h".
	* Makefile.in (menu.o): Update dependencies.

	* Makefile.in (obj): Always add menu.o.
	* emacs.c (main): Always call syms_of_menu.
	* keyboard.h: Remove extra #ifdef HAVE_X_WINDOW.

2008-06-08  Chong Yidong  <cyd@stupidchicken.com>

	* Makefile.in: Compile menu.c.

	* lisp.h: Declare syms_of_menu.

	* emacs.c (main): Call syms_of_menu.

	* keyboard.h: Relocate platform-independent menu definitions from
	xmenu.c.

	* menu.c: New file.  Relocate platform-independent menu
	definitions from xmenu.c.  Suggested by Adrian Robert.

	* xmenu.c: Remove platform-independent menu definitions.
	(menu_items menu_items_inuse, menu_items_allocated)
	(menu_items_used, menu_items_n_panes)
	(menu_items_submenu_depth): Move to keyboard.h.
	(init_menu_items, finish_menu_items, unuse_menu_items)
	(discard_menu_items, restore_menu_items, save_menu_items)
	(grow_menu_items, push_submenu_start, push_submenu_end)
	(push_left_right_boundary, push_menu_pane, push_menu_item)
	(keymap_panes, single_keymap_panes, single_menu_item)
	(list_of_panes, list_of_items, find_and_call_menu_selection)
	(xmalloc_widget_value, free_menubar_widget_value_tree)
	(parse_single_submenu, digest_single_submenu)
	(update_submenu_strings): Move to menu.c.

2008-06-07  Stefan Monnier  <monnier@iro.umontreal.ca>

	* dispnew.c (Flast_nonminibuf_frame): Handle the NULL case.

2008-06-06  Miles Bader  <miles@gnu.org>

	* xdisp.c (x_produce_glyphs): Calculate tab width based on current
	face, not frame default.

2008-06-05  Martin Rudalics  <rudalics@gmx.at>

	* window.c (pop_up_windows, pop_up_frames)
	(display_buffer_reuse_frames, Vpop_up_frame_function)
	(Vdisplay_buffer_function, Veven_window_heights)
	(Vspecial_display_buffer_names, Vspecial_display_regexps)
	(Vspecial_display_function, Vsame_window_buffer_names)
	(Vsame_window_regexps, split_height_threshold)
	(Vsplit_window_preferred_function): Move those vars to window.el.
	(display_buffer_1, Fspecial_display_p, Fsame_window_p)
	(Fdisplay_buffer): Move those functions to window.el.
	(syms_of_window): Remove corresponding declarations.
	(display_buffer): New function.
	(temp_output_buffer_show, Fother_window_for_scrolling): Use it.
	* dispnew.c (Flast_nonminibuf_frame): New function.
	* buffer.c (Fpop_to_buffer): Move to window.el.

2008-06-05  Stefan Monnier  <monnier@iro.umontreal.ca>

	* data.c (set_internal): Fix up call to let_shadows_buffer_binding_p.

2008-06-05  Kenichi Handa  <handa@m17n.org>

	* coding.c (detect_coding): Fix previous change.
	(detect_coding_system): Likewise.

2008-06-05  Stefan Monnier  <monnier@iro.umontreal.ca>

	* character.h (MAKE_CHAR_MULTIBYTE): Check the arg is a (uni)byte.

	* keymap.c (Vminibuffer_local_filename_must_match_map):
	Rename from Vminibuffer_local_must_match_filename_map.
	(syms_of_keymap):
	* minibuf.c (Fcompleting_read): Adjust accordingly.
	* commands.h: Rename declaration as well.

2008-06-05  Kenichi Handa  <handa@m17n.org>

	* font.c (Ffont_spec): Don't use font_parse_family_registry for
	family name.
	(Ffont_put): Likewise.

	* fontset.c (fontset_find_font): Call font_open_for_lface with the
	current font-spec.

	* xfont.c (xfont_list): Don't set registry to iso8859-1 even if it
	is unspecified.

	* xfaces.c (realize_x_face): If the font-related face attributes
	are the same as those of default face, realize a new fontset from
	default->fontset.
	(Fx_family_fonts): Use font_parse_family_registry instead of Ffont_put.

2008-06-05  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xdisp.c (move_it_in_display_line_to): Improve the type of its args.
	(move_it_in_display_line): New wrapper.

	* window.c (window_scroll_pixel_based_preserve_x)
	(window_scroll_preserve_hpos, window_scroll_preserve_vpos): New vars.
	(window_scroll_pixel_based, window_scroll_line_based):
	Use them to preserve column positions.
	(syms_of_window): Initialize them.

	* indent.c (Fvertical_motion): Extend first arg to allow passing an
	(HPOS . VPOS) pair.

	* dispextern.h (move_it_in_display_line): Declare.

2008-06-05  Juanma Barranquero  <lekktu@gmail.com>

	* window.c (Fwindow_parameter): Return VALUE, not (PARAMETER . VALUE).
	(Fwindow_parameters): Return copy of parameter alist.  Doc fix.
	(Fset_window_parameter): Return VALUE, not parameter alist.  Doc fix.

2008-06-04  Juanma Barranquero  <lekktu@gmail.com>

	* window.c (Fset_window_parameter): Doc fix.
	(Fwindow_parameters, Fwindow_parameter): Remove redundant check.

2008-06-04  Joakim Verona  <joakim@verona.se>

	* window.h (struct window): Add new member window_parameters.

	* window.c (Fwindow_parameters, Fwindow_parameter)
	(Fset_window_parameter): New defuns.
	(syms_of_window): Defsubr the new defuns.
	(make_window): Initialize window_parameters to nil.

2008-06-04  John Paul Wallington  <jpw@pobox.com>

	* eval.c (Fdefmacro): Doc fix.

2008-06-04  Kenichi Handa  <handa@m17n.org>

	* coding.c (detect_coding): Fix handling of coding->head_ascii.
	Be sure to call setup_coding_system when we find a proper coding system.
	(detect_coding_system): Fix handling of coding->head_ascii.

2008-06-03  Andreas Schwab  <schwab@suse.de>

	* font.c (font_prop_validate_spacing): Fix last change.

2008-06-03  Kenichi Handa  <handa@m17n.org>

	* font.c (font_prop_validate_spacing): Handle uppercase symbols.
	(font_parse_fcname): Fix handling of unknown key.

	* xfont.c (xfont_list): Try an alias.

	* charset.c (char_charset): Return NULL if the arg charset_list is
	specified and C doesn't belong to any of them.

2008-06-02  Chip Coldwell  <coldwell@redhat.com>

	* font.c (font_pixel_size): Don't take cdr of an integer.

2008-06-02  Jim Meyering  <meyering@redhat.com>

	Make "xfree (NULL)" a no-op; remove useless if-before-xfree.
	* alloc.c (xfree): Return right away for a NULL arg.
	* lread.c (nosuffix): Remove now-useless if-before-xfree tests.
	* gtkutil.c (xg_gtk_scroll_destroy): Likewise.
	* mac.c (create_apple_event_from_event_ref): Likewise.
	(create_apple_event_from_drag_ref, cfstring_create_normalized):
	Likewise.
	* doprnt.c (doprnt1): Likewise.
	* frame.c (frame): Likewise.
	* keyboard.c (wipe_kboard): Likewise.
	* macterm.c (x_free_frame_resources, xlfdpat_destroy, XFreePixmap)
	(init_font_name_table, mac_unload_font, x_delete_display): Likewise.
	* term.c (tty_default_color_capabilities, maybe_fatal)
	(delete_tty): Likewise.
	* w16select.c (string): Likewise.
	* w32.c (w32_get_resource, SET_ENV_BUF_SIZE): Likewise.
	* w32bdf.c (w32_free_bdf_font): Likewise.
	* w32fns.c (w32_unload_font): Likewise.
	* w32font.c (w32font_close): Likewise.
	* window.c (size_window): Likewise.
	* xselect.c (receive_incremental_selection): Likewise.
	* xterm.c (x_free_frame_resources, x_delete_display): Likewise.
	* mactoolbox.c (create_apple_event_from_drag_ref): Likewise.
	* w32.c (stat): Likewise.

	Remove useless if-before-free tests.
	* editfns.c (Fset_time_zone_rule): Likewise.
	* lread.c (nosuffix): Likewise.
	* ralloc.c (get_bloc): Likewise.
	* regex.c (reg_free): Likewise.
	* xftfont.c (xftfont_open, xftfont_close): Likewise.
	* xrdb.c (get_user_app, get_environ_db, x_load_resources): Likewise.
	* xsmfns.c (smc_save_yourself_CB): Likewise.

2008-06-02  Kenichi Handa  <handa@m17n.org>

	* font.c (font_find_for_lface): Handle float font size.
	(font_open_for_lface): Likewise.

	* xfaces.c (x_supports_face_attributes_p): Check face->font before
	comparing the properties.

2008-06-01  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32_enumfont_pattern_entity): Use requested registry.
	Treat iso10646-1 and Windows DEFAULT_CHARSET specially.
	Duplicate iso8859-1 fonts as iso10646-1 if no registry specified.
	Don't add empty script list.
	(w32_registry): Only map DEFAULT_CHARSET to iso10646-1 here.

2008-06-01  Dan Nicolaescu  <dann@ics.uci.edu>

	* Makefile.in (dot, dotdot): Remove, update users.
	".." has been used elsewhere in the file for a long time.
	(LIBXT_STATIC): Remove conditional based on unused variable.

2008-06-01  Miles Bader  <miles@gnu.org>

	* xfaces.c (Vface_remapping_alist): New variable.
	(syms_of_xfaces): Initialize it.
	(enum named_merge_point_kind): New type.
	(struct named_merge_point): Add `named_merge_point_kind' field.
	(push_named_merge_point): Make cycle detection respect different
	named-merge-point kinds.
	(lface_from_face_name_no_resolve): Rename from `lface_from_face_name'.
	Remove face-name alias resolution.
	(lface_from_face_name): New definition using
	`lface_from_face_name_no_resolve'.
	(get_lface_attributes_no_remap): Rename from `get_lface_attributes'.
	Call lface_from_face_name_no_resolve instead of lface_from_face_name.
	(get_lface_attributes): New definition that layers face-remapping on
	top of get_lface_attributes_no_remap.  New arg `named_merge_points'.
	(lookup_basic_face): New function.
	(lookup_derived_face): Pass new last arg to `get_lface_attributes'.
	(realize_named_face): Call `get_lface_attributes_no_remap' instead of
	`get_lface_attributes'.
	(face_at_buffer_position): Use `lookup_basic_face' to lookup
	DEFAULT_FACE_ID if necessary.  When optimizing the default-face case,
	return default_face's face-id instead of the constant DEFAULT_FACE_ID.

	* xdisp.c (init_iterator): Pass base_face_id through
	`lookup_basic_face' when we actually use it as a face-id.
	(handle_single_display_prop): Use `lookup_basic_face' to lookup
	DEFAULT_FACE_ID.

	* fontset.c (Finternal_char_font): Use `lookup_basic_face' to
	lookup the initial face-id.

	* dispextern.h (lookup_basic_face, Vface_remapping_alist): New decls.

2008-06-01  Juanma Barranquero  <lekktu@gmail.com>

	* textprop.c (syms_of_textprop) <text-property-default-nonsticky>:
	(Fremove_text_properties): Fix typos in docstrings.

2008-05-31  Kenichi Handa  <handa@m17n.org>

	* font.c (font_list_entities): Fix the car part of data to be
	stored in the cache.

	* ftfont.c (ftfont_font_format): Don't use strcasestr.

2008-05-30  Stefan Monnier  <monnier@iro.umontreal.ca>

	* chartab.c (Foptimize_char_table, optimize_sub_char_table):
	Add a `test' argument so another predicate than `equal' can be used.
	(map_sub_char_table): Use `eq' rather than `equal' to merge ranges.
	(map_char_table): Remove unused vars `c' and `i'.
	* lisp.h (Foptimize_char_table): Adjust declaration.
	* charset.c (Fclear_charset_maps): Adjust call to Foptimize_char_table.

2008-05-30  Kenichi Handa  <handa@m17n.org>

	* font.c (Ffont_info): Define only if HAVE_WINDOW_SYSTEM is defined.
	(syms_of_font): Defsubr Sfont_info only if HAVE_WINDOW_SYSTEM is
	defined.

2008-05-30  Stefan Monnier  <monnier@iro.umontreal.ca>

	* data.c (Fmake_variable_buffer_local, Fmake_local_variable)
	(Fmake_variable_frame_local): Disallow mixing buffer-local and
	frame-local settings for the same variable.

2008-05-30  Kenichi Handa  <handa@m17n.org>

	* fontset.c (Ffont_info): Move to font.c.
	(syms_of_fontset): Delete defsubr of Sfont_info.

	* font.c (font_style_to_value, font_score): Delete casting of the
	args to xstcasecmp.
	(register_font_driver): Increment num_font_drivers only when
	registering the driver globally.
	(Ffont_info): Move from fontset.c.  Handle a font object too.
	(syms_of_font): Defsubr Sfont_info.

2008-05-29  Kenichi Handa  <handa@m17n.org>

	* coding.h (enum define_coding_utf8_arg_index): New enum.
	(enum coding_attr_index): Change coding_attr_utf_16_bom to
	coding_attr_utf_bom.
	(enum utf_bom_type): Rename from utf_16_bom_type.
	(struct utf_16_spec): Adjust for the above change.
	(struct coding_system): Add utf_8_bom in `spec' union.

	* coding.c (CODING_UTF_8_BOM): New macro.
	(enum coding_category): Delete coding_category_utf_8, add
	coding_category_utf_8_auto, coding_category_utf_8_nosig, and
	coding_category_utf_8_sig.
	(CATEGORY_MASK_UTF_8): Delete it.
	(CATEGORY_MASK_UTF_8_AUTO, CATEGORY_MASK_UTF_8_NOSIG)
	(CATEGORY_MASK_UTF_8_SIG): New macros.
	(CATEGORY_MASK_ANY): Delete CATEGORY_MASK_UTF_8, add
	CATEGORY_MASK_UTF_8_AUTO, CATEGORY_MASK_UTF_8_NOSIG, and
	CATEGORY_MASK_UTF_8_SIG.
	(CATEGORY_MASK_UTF_8): New macro.
	(UTF_BOM, UTF_8_BOM_1, UTF_8_BOM_2, UTF_8_BOM_3): New macros.
	(detect_coding_utf_8): Check BOM.
	(decode_coding_utf_8, encode_coding_utf_8): Handle BOM.
	(decode_coding_utf_16): Adjust for the change of enum utf_bom_type.
	(encode_coding_utf_16): Likewise.
	(setup_coding_system): Likewise.  Set CODING_UTF_8_BOM (coding).
	(detect_coding, detect_coding_system): Handle utf-8-auto.
	(Fdefine_coding_system_internal): Handle `bom' property for utf-8.
	(syms_of_coding): Fix setting up of Vcoding_category_table.

2008-05-29  Stefan Monnier  <monnier@iro.umontreal.ca>

	* process.c (Faccept_process_output): If `millisec' is non-nil,
	`seconds' default to 0.
	(wait_reading_process_output): Also return non-nil if we read output
	from a non-running process.

2008-05-29  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_open_internal): Prefer truetype fonts unless
	`raster' specified.
	(add_font_entity_to_list): Allow non-opentype truetype fonts back
	in the uniscribe backend, but disallow any font that has no
	unicode subrange support.

2008-05-29  Juanma Barranquero  <lekktu@gmail.com>

	* xfaces.c (Fx_list_fonts, Finternal_copy_lisp_face):
	Fix typos in docstrings.

2008-05-29  Kenichi Handa  <handa@m17n.org>

	* xfaces.c (Fx_list_fonts): Make it return a list of font names.
	(Fx_family_fonts): Set frame correctly.

2008-05-28  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (x_draw_glyph_string): Use clipmask if specified.

2008-05-28  Stefan Monnier  <monnier@iro.umontreal.ca>

	* fileio.c (Fwrite_region): Delay the defaulting to beg&z to after
	calling build_annotations.

2008-05-28  Juanma Barranquero  <lekktu@gmail.com>

	* coding.c (Fdecode_coding_region, Fencode_coding_region)
	(Fencode_coding_string):
	(syms_of_coding) <coding-system-for-read, coding-system-for-write>:
	<latin-extra-code-table>: Fix typos in docstrings.
	(syms_of_coding) <coding-system-alist>: Doc fix.
	(syms_of_coding) <translation-table-for-input>: Reflow docstring.

2008-05-28  Kenichi Handa  <handa@m17n.org>

	* fontset.c (Ffont_info): Don't call font_close_object.

	* font.c (font_parse_family_registry): Use Ffont_put to validate
	foundry and family.
	(font_delete_unmatched): Don't check spacing.
	(font_list_entities): Add spacing to the spec to list fonts.

	* ftfont.c (ftfont_spec_pattern): Don't set FC_SPACING to pattern.
	(ftfont_list): Check spacing here.  Don't include FC_CHARSET in objset.

	* coding.c (encode_coding_raw_text): Fix previous change.
	(encode_coding_object): When the dst_object is a buffer and is
	different from src_object, move gap to PT.

2008-05-27  Chong Yidong  <cyd@stupidchicken.com>

	* xterm.c (x_draw_glyph_string): If a clipmask is specified, use it.

2008-05-27  Stefan Monnier  <monnier@iro.umontreal.ca>

	* coding.c (encode_coding_raw_text): Set coding->produced_char for
	all branches.  Compute it differently.

	* xdisp.c [!HAVE_WINDOW_SYSTEM]: Include font.h for --without-x.

2008-05-27  Juanma Barranquero  <lekktu@gmail.com>

	* w32font.c (compute_metrics): Rewrite an "else { if () ... else ... }"
	into "else if () ... else ...".

2008-05-27  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_open_internal): Determine if glyph indices
	are likely to work here.

2008-05-27  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c (draw_glyphs): If mouse-highlighting is on, attempt to
	draw overlap glyphs with appropriate highlighting.

2008-05-27  Kenichi Handa  <handa@m17n.org>

	* xfont.c (xfont_open): Fix calculation of font->average_width.

2008-05-27  Stefan Monnier  <monnier@iro.umontreal.ca>

	* casefiddle.c (casify_object): Try to guess better whether the
	argument is a byte or a char.

2008-05-26  Andreas Schwab  <schwab@suse.de>

	* xselect.c (x_reply_selection_request): Properly handle format == 32.
	Always send multiples of format size.

	* xterm.c (x_set_frame_alpha): Fix type mismatch.

2008-05-26  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_text_extents): Zero whole metrics struct first.
	(compute_metrics): Don't set failure if we just cleared the cache.
	(w32_weight_table): Remove unused variable.
	(w32_enumfont_pattern_entity): Use FONT_SPACING_CHARCELL for
	backwards compatibility.

2008-05-25  Kenichi Handa  <handa@m17n.org>

	* w32term.c (x_draw_glyph_string):
	* xterm.c (x_draw_glyph_string): Fix calculation of underline position.

	* xfaces.c: Delete unused function prototypes.
	(xstrlwr, font_frame): Delete them.
	(clear_face_cache): Delete unused variable.

	* xftfont.c (xftfont_open): Delete unused variable.
	If underline_thickness is not 1, adjust underline_position.

	* ftxfont.c (ftxfont_open): Delete unused variable.

	* fontset.c (face_for_char): Optimize for the case of no charset
	property.

	* font.c (LGSTRING_HEADER_SIZE, LGSTRING_GLYPH_SIZE)
	(check_gstring, check_otf_features, otf_list, otf_tag_symbol)
	(otf_open, font_otf_capability, generate_otf_features)
	(font_otf_DeviceTable, font_otf_ValueRecord, font_otf_Anchor):
	Comment out by surrounding "#if 0" and "#endif" for the moment.
	(Ffont_drive_otf, Ffont_otf_alternates): Likewise.
	(syms_of_font): Codes for accessing above commented out.

2008-05-24  Eli Zaretskii  <eliz@gnu.org>

	* w32proc.c: Include dispextern.h.

	* w32.c: Include dispextern.h.

2008-05-23  Juanma Barranquero  <lekktu@gmail.com>

	* charset.c (Fencode_char, Fsplit_char): Doc fixes.
	(Fget_unused_iso_final_char, Fdecode_char, Fiso_charset):
	Fix typos in docstrings.

2008-05-23  Jason Rumney  <jasonr@gnu.org>

	* xsmfns.c: Remove includes that are already included by config.h.

2008-05-23  Kenichi Handa  <handa@m17n.org>

	* charset.c (Qemacs, charset_emacs): New variables.
	(char_charset): Fix for non-Unicode characters.
	(syms_of_charset): Define charset_emacs.

	* w32term.c (x_draw_glyph_string): Be sure to update
	s->underline_thickness and s->underline_position.  Be sure to draw
	underline within the current line area.

	* xterm.c (x_draw_glyph_string): Be sure to update
	s->underline_thickness and s->underline_position.  Be sure to draw
	underline within the current line area.

	* fontset.c: Delete unused variables and add casting for char *
	throughout the file.
	(fontset_font): Try the fallback fonts of the current fontset
	before consulting the default fontset.

	* ftfont.c (ftfont_spec_pattern): Free charset if necessary.

	* xfont.c (xfont_list_pattern): Free names returned from XListFonts.

2008-05-22  Jason Rumney  <jasonr@gnu.org>

	* font.c: Don't include strings.h.

	* dispextern.h, xfaces.c (xstrcasecmp): Rename from xstricmp.

	* dosfns.c, fileio.c, font.c, fontset.c, image.c, macfns.c:
	* macterm.c, process.c, w32.c, w32fns.c, w32proc.c, xfaces.c:
	* xfns.c, xfont.c: All callers of stricmp and strcasecmp changed
	to call xstrcasecmp.

	* xfont.c (xfont_list_pattern, compare_font_names): Use xstrcasecmp.

	* fontset.c (fs_query_fontset): Use xstrcasecmp.

	* font.c (font_style_to_value, font_score): Use xstrcasecmp.

	* dosfns.c (msdos_stdcolor_idx): Use xstrcasecmp.

2008-05-22  Kenichi Handa  <handa@m17n.org>

	* puresize.h (BASE_PURESIZE): Increase to 1220000.

	* font.c (font_prop_validate_style): Adjust for the format
	change of font_style_table.

	* w32font.c (w32font_open_internal): Call Ffont_xlfd_name with
	two args.

	* xfaces.c (x_update_menu_appearance): Call Ffont_xlfd_name with
	two args.

2008-05-22  Stefan Monnier  <monnier@iro.umontreal.ca>

	* minibuf.c (keys_of_minibuf): Delete.
	* lisp.h (keys_of_minibuf): Delete.
	* emacs.c (main): Don't call keys_of_minibuf.

2008-05-22  Kenichi Handa  <handa@m17n.org>

	* ftfont.c (ftfont_resolve_generic_family): Rename from
	ftfont_list_generic_family.  Return a single family for each
	generic family.
	(ftfont_spec_pattern): Add FC_FAMILY to pattern.
	(ftfont_list): Adjust for the change of ftfont_resolve_generic_family.
	Call font_add_log.
	(ftfont_match): Call font_add_log.

	* font.h (Ffont_xlfd_name): EXFUN adjusted.
	(FONT_DEBUG): Define it.
	(font_add_log): Extern it.
	(font_assert): Rename from xassert.

	* xfont.c (xfont_get_pcm): Change xassert to font_assert.
	(xfont_list_family): Call font_add_log.
	(xfont_match): Likewise.
	(memq_no_quit): Delete.

	* fontset.c (fontset_from_font, Ffontset_info): Add the 2nd arg in
	call of Ffont_xlfd_name.

	* xfaces.c (struct table_entry, slant_table, weight_table)
	(swidth_table): Move to font.c.

	* font.c: Checking of FONT_DEBUG is moved to font.h.  All calls of
	xassert are changed to font_assert.  Delete many unused variables.
	(Vfont_weight_table, Vfont_slant_table, Vfont_width_table):
	New variables.
	(struct table_entry): Move from xfaces.c and modified.
	(weight_table, slant_table, width_table): Move from xfaces.c and
	contents adjusted for the change of struct table_entry.
	(font_style_to_value, font_style_symbolic): Adjust for the
	format change of font_style_table.
	(font_parse_family_registry): Don't overwrite existing foundry and
	family of font_spec.
	(font_score): Fix calculation of diff for sizes.
	(font_sort_entites): Call font_add_log.
	(font_delete_unmatched): Return a newly created list.
	(font_list_entities): Fix previous change.  Call font_add_log.
	(font_matching_entity, font_open_entity, font_close_entity):
	Call font_add_log.
	(Ffont_xlfd_name): New arg FOLD-WILDCARDS.
	(Finternal_set_font_style_table): Delete.
	(BUILD_STYLE_TABLE): New macro.
	(build_style_table): New function.
	(Vfont_log, font_log_env_checked): New variables.
	(font_add_log): New function.
	(syms_of_font): Delete defsubr Sinternal_set_font_style_table.
	Declare Lisp variables "font-weight-table", "font-slant-table",
	"font-width-table", and "font-log".  Initialize font_style_table.

2008-05-21  Dan Nicolaescu  <dann@ics.uci.edu>

	* xterm.c (x_set_frame_alpha): Move declarations before statements.

2008-05-21  Seiji Zenitani  <zenitani@mac.com>
	    Ryo Yoshitake  <ryo@shiftmode.net>

	* frame.c (Qalpha): Add a new frame parameter `alpha'.
	(Vframe_alpha_lower_limit): New variable.
	(x_set_alpha): New function.

	* frame.h (Qalpha, Vframe_parameter_lower_limit): Export them.

	* xfns.c (x-create-frame, Qalpha):
	Initialize the frame parameter `alpha'.
	* xterm.c (OPAQUE, OPACITY): New.
	(x_set_frame_alpha): New function.
	(frame_highlight, frame_unhighlight): Call x_set_frame_alpha.

	* macfns.c (mac_frame_parm_handlers): A null handler for x_set_alpha.
	* w32fns.c (w32_frame_parm_handlers): Likewise.

2008-05-20  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (add_font_entity_to_list): Don't add non-opentype
	truetype fonts to opentype list.

2008-05-20  Juanma Barranquero  <lekktu@gmail.com>

	* fontset.c (Ffontset_info): Doc fix.
	(syms_of_fontset) <font-encoding-charset-alist, use-default-ascent>:
	<ignore-relative-composition>: Fix typos in docstrings.

	* font.c (syms-of-font) <font-encoding-alist>:
	(Ffontp, Ffont_make_gstring): Fix typos in docstrings.
	(Flist_fonts, Ffont_family_list, Ffont_fill_gstring, Fquery_font)
	(Ffont_otf_alternates): Doc fixes.

2008-05-20  Kenichi Handa  <handa@m17n.org>

	* Makefile.in (FONTSRC): Delete it.  Change all $(FONTSRC) to
	font.h through out the file.
	(FONT_DRIVERS): Rename from FONTOBJ.
	(obj): Change $(FONTOBJ) to $(FONT_DRIVERS).  Add font.o.
	(SOME_MACHINE_OBJECTS): Change $(FONTOBJ) to $(FONT_DRIVERS).

	* emacs.c (main): Call syms_of_font unconditionally.

	* font.h (find_font_encoding): Extern it.

	* font.c (Vfont_encoding_alist, find_font_encoding): Move from
	fontset.c.
	(font_pixel_size)[! HAVE_WINDOW_SYSTEM]: Return 1.
	(font_open_entity): Update FRAME_X_DISPLAY_INFO (f)->n_fonts,
	FRAME_SMALLEST_CHAR_WIDTH (f), and FRAME_SMALLEST_FONT_HEIGHT (f)
	only when HAVE_WINDOW_SYSTEM is defined.
	(font_close_object): Update FRAME_X_DISPLAY_INFO (f)->n_fonts only
	when HAVE_WINDOW_SYSTEM is defined.

	* fontset.c (Vfont_encoding_alist, find_font_encoding): Move to font.c.
	(syms_of_fontset): Move declaration of font-encoding-alist to font.c.

	* xfaces.c: Include font.h unconditionally.
	(merge_face_ref, merge_face_vectors)
	(Finternal_set_lisp_face_attribute): Cancel the previous change.

2008-05-20  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xdisp.c (select_frame_for_redisplay): Adjust for last change to
	indirect_variable.
	* eval.c (lisp_indirect_variable): New fun.
	(Fuser_variable_p): Use it.

2008-05-19  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp.h (indirect_variable):
	* data.c (indirect_variable, let_shadows_buffer_binding_p):
	Use Lisp_Symbol pointers rather than Lisp_Object.
	Adjust callers.
	* buffer.c (buffer_slot_type_mismatch): Use wrong-type-argument.
	To this end, change calling-convention.

	* minibuf.c (Finternal_complete_buffer): Only strip out hidden buffers
	if some non-hidden buffers are selected by string&pred.

2008-05-19  Chong Yidong  <cyd@stupidchicken.com>

	* process.c (wait_reading_process_output): Always check status
	when in batch mode.

2008-05-19  Kenichi Handa  <handa@m17n.org>

	* font.c (font_list_entities): Fix handling of cache.
	(font_matching_entity): Likewise.

	* ftfont.c (cs_iso8859_1): Delete.
	(ft_face_cache): New variable.
	(struct ftfont_info): New member fc_charset_idx.
	(ftfont_build_basic_charsets): Delete.
	(fc_charset_table): New variable.
	(ftfont_pattern_entity): New arg fc_charset_idx.  Store (FILENAME
	. FC_CHARSET_IDX) as :font-entity property in the font entity.
	Callers changed.
	(ftfont_lookup_cache, ftfont_get_charset): New functions.
	(ftfont_spec_pattern): New argument fc_charset_idx.
	Check registry more rigidly.  Change callers.
	(ftfont_open, ftfont_close, ftfont_has_char): Adjust for the
	change of :font-entity property of the font.

	* xftfont.c (xftfont_open): Adjust for the change of :font-entity
	property of the font.

2008-05-18  Juanma Barranquero  <lekktu@gmail.com>

	* coding.c (Fcoding_system_p): Rename argument to match docstring.
	(Funencodable_char_position, Fcheck_coding_systems_region)
	(Fdecode_coding_string, Fencode_coding_string): Fix typos in docstrings.
	(Fdetect_coding_region, Fdetect_coding_string, Fencode_coding_region)
	(Ffind_operation_coding_system, Fset_coding_system_priority)
	(Fcoding_system_eol_type): Doc fixes.

2008-05-17  Glenn Morris  <rgm@gnu.org>

	* sysdep.c (child_setup_tty): Handle systems with NLDLY, without FFDLY.

2008-05-16  Eli Zaretskii  <eliz@gnu.org>

	* dired.c (Ffile_attributes): Shut up GCC warnings about st_uid
	and st_gid.

	* frame.c (Fdelete_frame): Don't call font_update_drivers if
	HAVE_WINDOW_SYSTEM is not defined.

	* xfaces.c (merge_face_ref, merge_face_vectors)
	(Finternal_set_lisp_face_attribute): Use FONT_*_INDEX only when
	HAVE_WINDOW_SYSTEM is defined.
	(Fface_font): Fix non-HAVE_WINDOW_SYSTEM case.

2008-05-16  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keyboard.c (parse_menu_item): Do not cache key shortcut any more.

2008-05-15  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (x_draw_relief_rect): Remove unused variable `dpy'.

2008-05-15  Kenichi Handa  <handa@m17n.org>

	* font.c (font_find_for_lface): Reflect LFACE_FONT in the font
	preference.

2008-05-15  Glenn Morris  <rgm@gnu.org>

	* emacs.c (USAGE1, standard_args): Remove -disable-font-backend.

2008-05-15  Chong Yidong  <cyd@stupidchicken.com>

	* fns.c (init_fns): Don't initialize weak_hash_tables here.
	(init_weak_hash_tables): New fun.  Initialize weak_hash_tables.

	* alloc.c (init_alloc_once): Call init_weak_hash_tables.

2008-05-15  Kenichi Handa  <handa@m17n.org>

	* ftfont.c (ftfont_list): Downcase family name to check generic
	families.

	* xfaces.c (Finternal_set_lisp_face_attribute): Be sure to make a
	font-spec for QCfont value.

	* fontset.c (Fnew_fontset): Call font_unparse_xlfd with 256-byte
	buffer.  Check the return value of it.

2008-05-14  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (w32_get_glyph_overhangs): Remove.
	(w32_redisplay_interface): Use x_get_glyph_overhangs instead.

2008-05-14  Kenichi Handa  <handa@m17n.org>

	* font.c (font_prop_validate): Make nil a valid value.
	(font_clear_cache): Check if the cached vector of entities is nil
	or not.

2008-05-14  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* emacs.c (main_thread): Conditionalize on
	FORWARD_SIGNAL_TO_MAIN_THREAD instead of HAVE_GTK_AND_PTHREAD.
	(main) [FORWARD_SIGNAL_TO_MAIN_THREAD]: Initialize it.

	* syssignal.h (FORWARD_SIGNAL_TO_MAIN_THREAD): New define.
	(main_thread, SIGNAL_THREAD_CHECK): Conditionalize on
	FORWARD_SIGNAL_TO_MAIN_THREAD instead of HAVE_GTK_AND_PTHREAD.

2008-05-14  Kenichi Handa  <handa@m17n.org>

	* coding.c (detect_coding_iso_2022): Ignore a coding category that
	has no corresponding coding system.

2008-05-14  Jason Rumney  <jasonr@gnu.org>

	* font.h (struct font) [WINDOWSNT]: Remove codepage member.

	* w32font.h (w32font_open_internal): Update declaration.

	* w32font.c (w32font_open_internal): Change last argument from
	w32font_info struct to font object.  Fill in font object from
	font_entity.  Get Outline metrics if possible.  Use them to
	calculate underline position and thickness.  Use xlfd name as name
	property.  Don't set codepage.
	(w32font_open): Pass font_object to w32font_open_internal.  Don't
	update dpyinfo->smallest_font_height and dpyinfo->smallest_char_width.
	(w32font_draw): Use s->font.
	(clear_cached_metrics): Don't clear non-existent blocks.

	* w32term.c (w32_compute_glyph_string_overhangs): Don't compute if
	font was not found.
	(x_draw_glyph_string): Use underline position and thickness from font.

	* w32uniscribe.c (uniscribe_open): Pass font_object to
	w32font_open_internal.

2008-05-14  Kenichi Handa  <handa@m17n.org>

	These changes are to delete all legacy font-handling codes, and
	make Emacs use only font-backends.

	* Makefile.in: Delete USE_FONT_BACKEND conditionals.
	(frame.o, image.o, print.o): Depend on $(FONTSRC).

	* makefile.w32-in (WIN32OBJ): Add w32reg.$(O), remove w32bdf.$(O).

	* charset.h (Vcharset_non_preferred_head)
	(Vcurrent_iso639_language): Extern them.

	* charset.c (Vcharset_non_preferred_head): New variable.
	(Vcurrent_iso639_language): New variable.
	(syms_of_charset): Declare it as a Lisp variable.
	(char_charset): Don't check non preferred charsets.  As a last
	resort, return charset_unicode.
	(Fset_charset_priority): Update Vcharset_non_preferred_head.

	* composite.c: Throughout the file, delete all USE_FONT_BACKEND
	conditionals.  Don't check enable_font_backend.  Delete all codes
	used only when USE_FONT_BACKEND is not defined.

	* dispextern.h (struct glyph_string): Change type of `font' to
	`struct font *'.
	(struct glyph_string): New member underline_position and
	underline_thickness.
	(enum lface_attribute_index): Remove LFACE_AVGWIDTH_INDEX.
	(struct face): Change type of `font' to `struct font *'.  Remove
	members `font_name', `font_info_id'.
	(per_char_metric, encode_char): Delete externs.
	(calc_pixel_width_or_height): Adjust the prototype.

	* emacs.c (enable_font_backend): Delete extern.
	(main): Don't set enable_font_backend.  Don't check the command
	line argument "-disable-font-backend".

	* font.h (Qfont_spec, Qfont_entity, Qfont_object): Extern them.
	(enum font_property_index): New members FONT_DPI_INDEX,
	FONT_SPACING_INDEX, FONT_AVGWIDTH_INDEX, FONT_NAME_INDEX,
	FONT_FULLNAME_INDEX, FONT_FILE_INDEX, FONT_FORMAT_INDEX,
	FONT_OBJECT_MAX.  Delete FONT_FRAME_INDEX.
	(FONT_WEIGHT_NUMERIC, FONT_SLANT_NUMERIC, FONT_WIDTH_NUMERIC)
	(FONT_WEIGHT_SYMBOLIC, FONT_SLANT_SYMBOLIC, FONT_WIDTH_SYMBOLIC)
	(FONT_WEIGHT_FOR_FACE, FONT_SLANT_FOR_FACE, FONT_WIDTH_FOR_FACE)
	(FONT_WEIGHT_NAME_NUMERIC, FONT_SLANT_NAME_NUMERIC)
	(FONT_WIDTH_NAME_NUMERIC, FONT_SET_STYLE): New macros.
	(struct font_spec, struct font_entity): New structs.
	(FONT_ENCODING_NOT_DECIDED): Moved from fontset.h.
	(struct font): Many members from old "struct font_info" moved to
	here.  Members font and entity deleted.
	(FONT_SPEC_P, FONT_ENTITY_P, FONT_OBJECT_P, FONTP): Modified for
	the new font-related objects.
	(CHECK_FONT_SPEC, CHECK_FONT_ENTITY, CHECK_FONT_OBJECT)
	(CHECK_FONT_GET_OBJECT): Likewise.
	(XFONT_SPEC, XFONT_ENTITY, XFONT_OBJECT, XSETFONT): New macros.
	(PT_PER_INCH, POINT_TO_PIXEL, PIXEL_TO_POINT): Moved from font.h.
	(struct font_driver): New members case_sensitive anc check.  Type
	of the member list and open changed.
	(enable_font_backend, font_symbolic_weight, font_symbolic_slant)
	(font_symbolic_width, font_find_object, font_get_spec)
	(font_set_lface_from_name): Delete extern.
	(Fcopy_font_spec, Fmerge_font_spec, Ffont_family_list): New EXFUNs.

	* font.c: Include <strings.h>.
	(enable_font_backend): Delete it.
	(Qfont_spec, Qfont_entity, Qfont_object): New variables.
	(CHECK_VALIDATE_FONT_SPEC): Delete it.
	(PT_PER_INCH, POINT_TO_PIXEL, PIXEL_TO_POINT): Moved to font.h.
	(null_string): Delete it.
	(null_vector): Make it static.
	(font_family_alist): Delete it.
	(Qnormal): Extern it.
	(QCextra, QClanguage): Delete it.
	(QClang, QCavgwidth, QCfont_entity, QCfc_unknown_spec): New variables.
	(font_make_spec, font_make_entity, font_make_object)
	(font_intern_prop): Renamed from intern_downcase.  Don't downcase
	the string.  Callers changed.
	(font_pixel_size): Adjusted for the format change of font-related
	objects.
	(prop_name_to_numeric, prop_numeric_to_name): Delete them.
	(font_style_to_value, font_style_symbolic): New function.
	(build_font_family_alist): Delete it.
	(font_registry_charsets): Use Fassoc_string instead of
	assq_no_quit.
	(font_prop_validate_symbol): Don't return null_string.
	(font_prop_validate_style): Adjusted for the change of
	style-related values in a font vector.
	(font_property_table): Delete entries for QClanguage and
	QCantialias, add entries for QCavgwidth.
	(get_font_prop_index): Delete the 2nd argument FROM.
	(font_prop_validate): Arguments changed.
	(font_put_extra): Adjusted for the change of font-related objects.
	(font_expand_wildcards, font_parse_xlfd, font_unparse_xlfd)
	(font_parse_fcname, font_unparse_fcname)
	(font_prepare_composition): Likewise.
	(font_parse_family_registry): Renamed from font_merge_old_spec.
	(otf_open): Delete the 1st arg entity.
	(font_otf_capability): Adjusted for the above change.
	(font_score): New arg alternate_families.  Adjusted for the change
	of font-related objects.
	(font_sort_entites): New arg best_only.
	(font_symbolic_weight, font_symbolic_slant, font_symbolic_width):
	Delete them.
	(font_match_p): Check alternate families.
	(font_find_object): Delete it.
	(font_check_object): New function.
	(font_clear_cache): Adjusted for the change of font-related objects.
	(font_delete_unmatched): New arg.
	(font_list_entities): Call font_driver->list with a spec that
	doesn't specify style-related properties.
	(font_matching_entity): Arguments changed.  Caller changed.
	(font_open_entity): Adjusted for the change of font-related objects.
	(font_close_object, font_has_char, font_encode_char)
	(font_get_name, font_get_spec): Likewise.
	(font_spec_from_name, font_clear_prop, font_update_lface):
	New functions.
	(font_find_for_lface, font_open_for_lface, font_load_for_lface)
	(font_prepare_for_face, font_done_for_face, font_open_by_name)
	(font_at): Adjusted for the change of font-related objects.
	(font_range): New function.
	(Ffontp, Ffont_spec, Ffont_get, Ffont_put, Flist_fonts)
	(Ffont_xlfd_name): Adjusted for the change of font-related objects.
	(Fcopy_font_spec, Fmerge_font_spec): New function.
	(Ffont_family_list): Renamed from list-families.
	(Finternal_set_font_style_table): Arguments changed.
	(Ffont_fill_gstring, Ffont_shape_text, Fopen_font)
	(Ffont_drive_otf, Fquery_font, Ffont_match_p): Adjusted for the
	change of font-related objects.
	(syms_of_font): Delete "ifdef USE_FONT_BACKEND".  DEFSYM new symbols.

	* fontset.h (struct font_info): Delete it.  Most members go to
	struct font.
	(FONT_ENCODING_NOT_DECIDED): Moved to font.h.
	(enum FONT_SPEC_INDEX): Delete it.
	(font_info, list_fonts_func, load_font_func, query_font_func)
	(set_frame_fontset_func, find_ccl_program_func)
	(get_font_repertory_func, new_fontset_from_font_name): Delete
	externs.
	(fontset_from_font_name): Extern it.
	(FS_LOAD_FONT, FONT_INFO_ID, FONT_INFO_FROM_ID)
	(FONT_INFO_FROM_FACE): Deleted.
	(face_for_font): Adjust prototype.

	* fontset.c: Throughout the file, delete all USE_FONT_BACKEND
	conditionals.  Don't check enable_font_backend.  Delete all codes
	used only when USE_FONT_BACKEND is not defined.
	(get_font_info_func, list_font_func, load_font_func)
	(query_font_func, set_frame_fontset_func, find_ccl_program_func)
	(get_font_repertory_func): Delete them.
	(FONTSET_SPEC, FONT_DEF_NEW, FONT_DEF_SPEC, FONT_DEF_ENCODING)
	(FONT_DEF_REPERTORY, RFONT_DEF_FACE, RFONT_DEF_SET_FACE)
	(RFONT_DEF_FONT_DEF, RFONT_DEF_SPEC, RFONT_DEF_REPERTORY)
	(RFONT_DEF_OBJECT, RFONT_DEF_SET_OBJECT, RFONT_DEF_SCORE)
	(RFONT_DEF_SET_SCORE, RFONT_DEF_NEW): New macros.
	(fontset_compare_rfontdef): New function.
	(reorder_font_vector): Remove the argument CHARSET-ID.  Sort
	rfont-defs by qsort.  Adjusted for the change of font-group vector.
	(load_font_get_repertory): Deleted.
	(fontset_find_font): Use new macros to ref/set elements of
	font-def and rfont-def.
	(fontset_font): Fix the timing of remembering that no font for C.
	(free_face_fontset): Do nothing if the face has no fontset.
	(face_suitable_for_char_p): Use new macros to ref/set elements of
	rfont-def.
	(face_for_char): Likewise.  Call face_for_char with font_object.
	(fs_load_font): Delete.  Delete #pragma surrounding it.
	(fs_query_fontset): Use strcasecmp instead of strcmp.
	(generate_ascii_font_name): Adjusted for the format change of
	font-spec.
	(Fset_fontset_font): Likewise.  Use new macros to set elements of
	font-def.
	(Fnew_fontset): Use font_unparse_xlfd to generate
	FONTSET_ASCII (fontset).
	(new_fontset_from_font_name): Deleted.
	(fontset_from_font): Renamed from new_fontset_from_font.  Check if
	a fontset is already created for the font.  FIx updating of
	Vfontset_alias_alist.
	(fontset_ascii_font): Deleted.
	(Ffont_info): Adjusted for the format change of font-spec.
	(Finternal_char_font): Likewise.
	(Ffontset_info): Likewise.
	(syms_of_fontset): Don't check load_font_func.

	* fns.c (internal_equal): Handle PREV_FONT.

	* frame.h: Delete USE_FONT_BACKEND conditional.

	* frame.c: Throughout the file, delete all USE_FONT_BACKEND
	conditionals.  Don't check enable_font_backend.  Delete all codes
	used only when USE_FONT_BACKEND is not defined.
	(x_set_font): Call x_new_font, not x_new_fontset2.
	(x_set_font_backend): Use FRAME_FONT macro to check if a font is
	already set for the frame.

	* ftfont.c (ftfont_pattern_entity): Argument FRAME removed.  Make
	a font-entity by font_make_entity.  Use font_intern_prop instead
	of intern_downcase.  Use FONT_SET_STYLE to set a style-related
	font property.  If a font is scalable, set avgwidth property to 0.
	Set font-entity property by font_put_extra.
	(ftfont_list_generic_family): Argument SPEC and REGISTRY removed.
	(ffont_driver): Adjusted for the change of struct font_driver.
	(ftfont_spec_pattern): New function.
	(ftfont_list): Return a list, not vector.
	(ftfont_match): Use ftfont_spec_pattern to get a pattern.
	(ftfont_list_family): Don't downcase names.
	(ftfont_free_entity): Deleted.
	(ftfont_open): Return a font-object.  Adjusted for the change of
	struct font.  Get underline_thickness and underline_position from
	font property.  Don't update dpyinfo->smallest_font_height and
	dpyinfo->smallest_char_width.
	(ftfont_close): Don't free `struct font'.
	(ftfont_has_char): Adjusted for the format change of font-entity.
	(ftfont_encode_char, ftfont_text_extents): Likewise.

	* ftxfont.c (ftxfont_list): Return a list, not vector.
	(ftxfont_open): Return a font-object.  Adjusted for the change of
	struct font.  Get underline_thickness and underline_position from
	font property.  Don't update dpyinfo->smallest_font_height and
	dpyinfo->smallest_char_width.
	(ftxfont_close): Don't decrease FRAME_X_DISPLAY_INFO (f)->n_fonts.
	(ftxfont_draw): Adjusted for the change of struct font.

	* image.c (image_ascent): Don't include "charset.h".  Include
	"character.h" and "font.h".

	* lisp.h (enum pvec_type): New member PREV_FONT.
	(Fassoc_string): EXFUN it.

	* print.c: Include font.h.
	(print_object): Handle font-related objects.

	* xdisp.c: Throughout the file, delete all USE_FONT_BACKEND
	conditionals.  Don't check enable_font_backend.  Delete all codes
	used only when USE_FONT_BACKEND is not defined.
	(handle_auto_composed_prop): Do nothing if it->f is not on a
	window system.  Check how many following characters can be
	displayed by the same font.
	(calc_pixel_width_or_height): Type of the 4th arg is changed to
	'struct font *'.
	(get_char_face_and_encoding): Assign the whole encoding task to
	the `encode-char' method of a font driver.
	(fill_composite_glyph_string): Adjusted for the change of `struct
	face' and `struct glyph_string'.
	(fill_glyph_string): Likewise.
	(get_per_char_metric): Arguments changed.
	(x_get_glyph_overhangs): Adjusted for the change of `struct face'
	and `struct glyph_string'.
	(produce_stretch_glyph, calc_line_height_property)
	(x_produce_glyphs): Likewise.

	* xfaces.c: Throughout the file, delete all USE_FONT_BACKEND
	conditionals.  Don't check enable_font_backend.  Delete all codes
	used only when USE_FONT_BACKEND is not defined.  Use
	FONT_XXX_NAME_NUMERIC instead of face_numeric_xxx.
	(QCfoundry, QCadstyle, QCregistry, QCspacing, QCsize, QCavgwidth)
	(Qp): Extern them.
	(clear_font_table, load_face_font, xlfd_lookup_field_contents):
	Deleted.
	(struct font_name): Deleted.
	(xlfd_numeric_value, xlfd_symbolic_value): Deleted.
	(compare_fonts_by_sort_order): New function.
	(xlfd_numeric_slant, xlfd_symbolic_slant, xlfd_numeric_weight)
	(xlfd_symbolic_weight, xlfd_numeric_swidth, xlfd_symbolic_swidth):
	Deleted.
	(Fx_family_fonts): Use font_list_entities, and sort fonts by
	compare_fonts_by_sort_order.
	(Fx_font_family_list): Call Ffont_family_list.
	(face_numeric_value, face_numeric_weight, face_numeric_slant)
	(face_numeric_swidth, face_symbolic_value, face_symbolic_weight)
	(face_symbolic_slant, face_symbolic_swidth)
	(split_font_name_into_vector, build_font_name_from_vector)
	(xlfd_fixed_p, xlfd_point_size, pixel_point_size)
	(font_rescale_ratio, split_font_name, build_font_name)
	(free_font_names, sort_fonts, x_face_list_fonts)
	(face_font_available_p, sorted_font_list, cmp_font_names)
	(font_list_1, concat_font_list, font_list, remove_duplicates):
	Deleted.
	(Fx_list_fonts): Use Ffont_list.
	(LFACE_AVGWIDTH): Deleted.
	(check_lface_attrs): Don't check LFACE_AVGWIDTH.  Check LFACE_FONT
	by FONTP.
	(lface_fully_specified_p): Don't check LFACE_AVGWIDTH.
	(set_lface_from_font_name): Delete it.
	(set_lface_from_font): Renamed from
	set_lface_from_font_and_fontset.  Caller changed.  Don't set
	LFACE_AVGWIDTH.  Use FONT_XXX_FOR_FACE to get a symbol suitable
	for face.
	(merge_face_vectors): Copy font-spec if necessary.
	Clear properties of the font-spec if necessary.
	(merge_face_ref): Clear properties of the font-spec if necessary.
	(Finternal_set_lisp_face_attribute): Likewise.
	(set_font_frame_param): Use font_load_for_lface to load a
	font-object, and call Fmodify_frame_parameters with it.
	(x_update_menu_appearance): Don't check LFACE_AVGWIDTH.  Get XLFD
	font name by Ffont_xlfd_name.
	(Finternal_lisp_face_attribute_values): Don't check QCweight,
	QCslant, and QCwidth.
	(Fface_font): Get a font name from font->props[FONT_NAME_INDEX].
	(lface_same_font_attributes_p): Don't check LFACE_AVGWIDTH.
	Compare fonts by EQ.
	(lookup_non_ascii_face): Deleted.
	(face_for_font): The 2nd argument changed.
	(x_supports_face_attributes_p): Don't check LFACE_AVGWIDTH.
	Check atomic font properties by case insensitive.
	(realize_non_ascii_face): Set face->overstrike correctly.
	(realize_x_face): Likewise.  Check if LFACE_FONT is a font_object.
	(dump_realized_face): Get font name from
	font->props[FONT_NAME_INDEX].  Don't print font_info_id.

	* xfns.c: Throughout the file, delete all USE_FONT_BACKEND
	conditionals.  Don't check enable_font_backend.  Delete all codes
	used only when USE_FONT_BACKEND is not defined.
	(xic_create_xfontset): Original code deleted and renamed from
	xic_create_xfontset2.  Use FRAME_FONT, not FRAME_FONT_OBJECT.
	(x_make_gc): Don't set GCFont in GCs.
	(Fx_create_frame) [USE_LUCID]: Set xlwmenu_default_font to a font
	opened by "fixed".
	(syms_of_xfns): Don't set get_font_info_func, load_font_func,
	find_ccl_program_func, query_font_func, set_frame_fontset_func,
	get_font_repertory_func.

	* xfont.c: Include <stdlib.h> and "ccl.h".
	(struct xfont_info): New structure.
	(xfont_query_font): Deleted.
	(xfont_find_ccl_program): Renamed from x_find_ccl_program and
	moved from xterm.c.
	(xfont_driver): Adjusted for the change of struct font_driver.
	(compare_font_names): New function.
	(xfont_list_pattern): Sort font names case insensitively.  Make
	font_entity by calling font_make_entity.  Avoid auto-scaled fonts.
	(xfont_list): Return a list, not vector.
	(xfont_match): If the font doesn't have QCname property, generate
	a name from the other font properties.
	(xfont_open): Return a font-object.  Adjusted for the change of
	struct font.  Get underline_thickness and underline_position from
	font property.  Don't update dpyinfo->smallest_font_height and
	dpyinfo->smallest_char_width.
	(xfont_close): Don't free struct font.
	(xfont_prepare_face): Adjusted for the change of struct font.
	(xfont_done_face): Deleted.
	(xfont_has_char): Adjusted for the change of struct font.
	(xfont_encode_char, xfont_draw): Likewise.
	(xfont_check): New function.

	* xftfont.c (xftfont_list): Adjusted for the change of `list'
	callback function.
	(xftfont_match): Adjusted for the format change of font-entity.
	(xftfont_open): Adjusted for the format change of font-entity and
	font-object.  Adjusted for the change of struct font.  Return a
	font-object.  Don't update dpyinfo->smallest_font_height and
	dpyinfo->smallest_char_width.
	(xftfont_close): Block input while calling XftFontClose.
	(xftfont_prepare_face): Don't block input while calling
	xftfont_get_colors.  Adjusted for the change of struct font.
	(xftfont_shape): Return value of error case fixed.

	* xrdb.c (x_load_resources): Don't setup a fontset resource.

	* xterm.h: Throughout the file, delete all USE_FONT_BACKEND
	conditionals.
	(FONT_WIDTH): Return (f)->max_width.
	(struct x_display_info): Delete member `font'.
	(x_list_fonts, x_get_font_info, x_load_font, x_query_font)
	(x_find_ccl_program, x_get_font_repertory): Delete externs.
	(struct x_output): Change type of `font' to `struct font *'.

	* xterm.c: Throughout the file, delete all USE_FONT_BACKEND
	conditionals.  Don't check enable_font_backend.  Delete all codes
	used only when USE_FONT_BACKEND is not defined.  Don't include ccl.h.
	(x_per_char_metric, x_encode_char): Deleted.
	(x_set_cursor_gc, x_set_mouse_face_gc): Don't set GCFont.
	(x_compute_glyph_string_overhangs): Adjusted for the change of
	`struct face'.
	(x_draw_glyph_string_foreground)
	(x_draw_composite_glyph_string_foreground): Likewise.
	(x_draw_glyph_string): Likewise.  Use font->underline_position and
	font->underline_thickness.
	(x_new_font): Renamed from x_new_fontset2.
	(x_new_fontset, x_get_font_info, x_list_fonts): Deleted.
	(x_check_font): Call `check' method of a font driver.
	(x_font_min_bounds, x_compute_min_glyph_bounds, x_load_font)
	(x_query_font, x_get_font_repertory): Deleted.
	(x_find_ccl_program): Renamed and moved to xfont.c.
	(x_redisplay_interface): Adjusted for the change of `struct
	redisplay_interface'.

	* w32fns.c: Throughout the file, delete all USE_FONT_BACKEND
	conditionals.  Don't check enable_font_backend.  Delete all codes
	used only when USE_FONT_BACKEND is not defined.  Surround non-used
	code by "#ifdef OLD_FONT" and "endif".
	(Fw32_select_font): Use FONT_COMPAT to get old font structure.

	* w32font.h (struct w32font_info): New member.
	(FONT_COMPAT): New macro.
	(w32font_open_internal): Prototype adjusted.

	* w32gui.h (XGCValues): Surround `XFontStruct *font' by "if
	OLD_FONT" and "endif".

	* w32font.c: Throughout the file, delete all USE_FONT_BACKEND
	conditionals.  Don't check enable_font_backend.  Delete all codes
	used only when USE_FONT_BACKEND is not defined.
	(w32font_open): Return a font-object.  Make a font-object by
	font_make_object.  Adjusted for the change of struct w32font_info.
	(w32font_close): Don't free struct font.  Adjusted for the change
	of struct w32font_info.
	(w32font_encode_char, w32font_text_extents, w32font_draw):
	Adjusted for the change of struct w32font_info.
	(w32font_draw): Likewise.
	(w32font_list_internal): Return a list, not vector.
	(w32font_open_internal): Change the 4th arg to font-object.
	Adjusted for the change of struct w32font_info and font-object format.
	(add_font_name_to_list): Don't downcase names.
	(w32_enumfont_pattern_entity): Make a font-entity by
	font_make_entity.  Adjusted for the format change of font-entity.
	Use FONT_SET_STYLE to set a style-related font property.  If a
	font is scalable, set avgwidth property to 0.  Set font-entity
	property by font_put_extra.
	(font_matches_spec): Adjusted for the format change of font-entity.
	(w32_weight_table, w32_decode_weight): New variables.
	(w32_encode_weight): New function.
	(fill_in_logfont): Adjusted for the format change of font-spec.
	(w32font_full_name): Use FONT_WEIGHT_SYMBOLIC to get a symbol
	weight value.
	(w32font_driver): Adjusted for the change of struct font_driver.

	* w32term.h: Throughout the file, delete all USE_FONT_BACKEND
	conditionals.  Don't check enable_font_backend.  Surround non-used
	code by "#ifdef OLD_FONT" and "endif".
	(FONT_WIDTH, FONT_HEIGHT, FONT_BASE, FONT_DESCENT)
	(FONT_AVG_WIDTH): Adjusted for the change of struct font.

	* w32term.c: Throughout the file, delete all USE_FONT_BACKEND
	conditionals.  Don't check enable_font_backend.  Delete all codes
	used only when USE_FONT_BACKEND is not defined.  Surround non-used
	code by "#ifdef OLD_FONT" and "endif".

	* w32uniscribe.c: Delete USE_FONT_BACKEND conditional.
	(uniscribe_open): Return value changed to font-object.
	Adjusted for the format change of font-object.
	(uniscribe_otf_capability): Adjusted for the change of struct font.
	(add_opentype_font_name_to_list): Don't downcase names.
	(uniscribe_font_driver): Adjusted for the change of struct
	font_driver.

2008-05-13  Chong Yidong  <cyd@stupidchicken.com>

	* dispnew.c (update_frame_1): Check if tty output is still valid
	before flushing it.

2008-05-13  Jan Djärv  <jan.h.d@swipnet.se>

	* xterm.c (handle_one_xevent): Don't pass buttons higher than 3
	to Gtk+ menus.

2008-05-13  Stefan Monnier  <monnier@iro.umontreal.ca>

	* dired.c (file_name_completion): Tweak the code so as to always do it
	in a single pass.  Tighten the scope of some variables.

	* dired.c (Qdefault_directory): New var.
	(file_name_completion): Use it instead of Fexpand_file_name.
	(syms_of_dired): Initialize it.

2008-05-12  Stefan Monnier  <monnier@iro.umontreal.ca>

	* fileio.c (double_dollars): Remove dead code.

2008-05-10  Eli Zaretskii  <eliz@gnu.org>

	* dired.c (Ffile_attributes, Fdirectory_files_and_attributes):
	Mention w32-get-true-file-attributes in doc string.

	* w32proc.c (syms_of_ntproc) <w32-get-true-file-attributes>: Doc fix.

2008-05-09  Glenn Morris  <rgm@gnu.org>

	* fileio.c (Fread_file_name): Remove reference to insdef, deleted
	2008-04-23.

2008-05-09  Eli Zaretskii  <eliz@gnu.org>

	Support for reporting owner and group of each file on MS-Windows:
	* dired.c (stat_uname, stat_gname): New functions, with special
	implementation for w32.
	(Ffile_attributes): Use them instead of getpwuid and getgrgid.

	* w32.c: Rename the_passwd_* to dflt_passwd_*.
	(dflt_group_name): New static variable.
	(dflt_group): Rename from the_group.
	(init_user_info): Init dflt_group fields.  Get user's group name
	from LookupAccountSid.
	(g_b_init_get_file_security, g_b_init_get_security_descriptor_owner)
	(g_b_init_get_security_descriptor_group, g_b_init_is_valid_sid):
	New initialization states.
	(globals_of_w32): Initialize them to zero.  Initialize the default
	group name to "None".
	(GetFileSecurity_Name): New global var, the name of the function
	to call for GetFileSecurity.
	(GetFileSecurity_Proc, GetSecurityDescriptorOwner_Proc)
	(GetSecurityDescriptorGroup_Proc, IsValidSid_Proc): New typedefs.
	(get_file_security, get_security_descriptor_owner)
	(get_security_descriptor_group, is_valid_sid)
	(get_file_security_desc, get_rid, get_name_and_id)
	(get_file_owner_and_group): New functions.
	(stat): Use get_file_security_desc and get_file_owner_and_group to
	report the owner and primary group of each file.  Don't ignore the
	high 32 bits of file's size, now that st_size is 64-bit wide.
	Fix test when to get true file attributes.
	(init_user_info): Use get_rid instead of equivalent inline code.
	(fstat): Don't ignore the high 32 bits of file's size.

2008-05-09  Chong Yidong  <cyd@stupidchicken.com>

	* image.c (png_load): Use correct bit-depth for setting background
	color.

2008-05-08  Eli Zaretskii  <eliz@gnu.org>

	* Makefile.in (lisp, shortlisp): Rename epa-file-hook.elc to
	epa-hook.elc.

2008-05-08  Juanma Barranquero  <lekktu@gmail.com>

	* font.c (Ffont_match_p): Don't use `iff' in docstring.

2008-05-07  Dan Nicolaescu  <dann@ics.uci.edu>

	* macfns.c (Fx_create_frame): Make a copy of frame parameters
	because the original parameters are in pure storage now.
	(mac_window): Remove unused params.  Update callers.

2008-05-06  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lread.c (substitute_object_recurse): Use lower-level primitives.
	Don't signal errors when traversing sub-char-tables.
	Don't loop over all the possible characters when traversing char-tables.

	* print.c (print_preprocess): Add sub-char-tables to the print-table,
	just like we do in print.c.

2008-05-05  Stefan Monnier  <monnier@iro.umontreal.ca>

	* minibuf.c (Ftry_completion): Remove code left over from when we used
	scmp instead of Fcompare_strings.

2008-05-04  Juanma Barranquero  <lekktu@gmail.com>

	* w32fns.c (Fw32_battery_status): Fix computation of %t (h:min) format.

2008-05-04  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* image.c [USE_MAC_IMAGE_IO] (image_load_image_io):
	Create bitmap context in native byte order.

	* macterm.c (XDrawLine)
	(XCreatePixmapFromBitmapData) [USE_MAC_IMAGE_IO]: Create bitmap
	context in native byte order.

2008-05-04  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* config.in: Regenerate.

	* image.c (PIX_MASK_DRAW, PIX_MASK_RETAIN) [USE_MAC_IMAGE_IO]:
	New definitions for Image I/O support.
	(XGetImage, XPutPixel, XGetPixel, XDestroyImage)
	(mac_create_cg_image_from_image, x_create_x_image_and_pixmap)
	[USE_MAC_IMAGE_IO]: Add implementations for Image I/O support.
	(mac_data_provider_release_data, image_load_image_io)
	[USE_MAC_IMAGE_IO]: New functions.
	(CGImageCreateWithPNGDataProviderProcType) [MAC_OSX]: Remove typedef.
	(MyCGImageCreateWithPNGDataProvider) [MAC_OSX]: Remove variable.
	(init_image_func_pointer) [MAC_OSX]: Remove function.
	(image_load_quartz2d) [MAC_OSX]: Check availability of
	CGImageCreateWithPNGDataProvider at compile time.
	Use lowercase `false' for boolean constant.
	(png_load, jpeg_load, tiff_load, gif_load) [USE_MAC_IMAGE_IO]:
	Use image_load_image_io.
	(png_load) [!USE_MAC_IMAGE_IO && MAC_OSX]:
	Don't check MyCGImageCreateWithPNGDataProvider.
	(init_image) [MAC_OSX && TARGET_API_MAC_CARBON]:
	Don't call init_image_func_pointer.

	* macgui.h (Pixmap) [USE_MAC_IMAGE_IO]: New definition for Image I/O.

	* macterm.c (mac_cg_color_space_rgb) [USE_CG_DRAWING]:
	Make variable non-static.
	(XDrawLine, XCreatePixmap, XCreatePixmapFromBitmapData, XFreePixmap)
	[USE_MAC_IMAGE_IO]: Add implementations for Image I/O support.

	* macterm.h (ARGB_TO_ULONG, ALPHA_FROM_ULONG): New macros.
	(RED_FROM_ULONG): Mask off higher bits.
	(mac_cg_color_space_rgb) [USE_MAC_IMAGE_IO]: New extern.

	* s/darwin.h [HAVE_CARBON && HAVE_AVAILABILITYMACROS_H]:
	Include AvailabilityMacros.h.
	(USE_MAC_IMAGE_IO, LIBS_IMAGE) [HAVE_CARBON]: New defines.
	(LIBS_CARBON) [HAVE_CARBON]: Use LIBS_IMAGE.

2008-05-03  Stefan Monnier  <monnier@iro.umontreal.ca>

	* chartab.c (Fset_char_table_range): If range is t, really set all
	chars to that value.

2008-05-03  Eli Zaretskii  <eliz@gnu.org>

	* dired.c (Ffile_attributes): Don't allow the device number become
	negative.

2008-05-02  Daiki Ueno  <ueno@unixuser.org>

	* Makefile.in (lisp, shortlisp): Add epa-file-hook.elc.

2008-05-02  Juri Linkov  <juri@jurta.org>

	* minibuf.c (Fread_from_minibuffer, Fread_string, Fread_command)
	(Fread_variable, Fread_buffer, Fcompleting_read): Document the
	DEFAULT argument as a list of default values in docstrings.

2008-05-01  Chong Yidong  <cyd@stupidchicken.com>

	* puresize.h (BASE_PURESIZE): Increase to 1210000.

2008-05-01  Martin Rudalics  <rudalics@gmx.at>

	* dispnew.c (change_frame_size_1): Preserve small windows when
	shrinking frames by calling set_window_height|width with third
	arg 2.

	* window.h (struct window): Replace field too_small_ok by field
	resize_proportionally.

	* window.c (make_window): Initialize resize_proportionally.
	(enlarge_window): Temporarily set resize_proportionally to make
	sure that shrink_windows does scale the window proportionally.
	(shrink_windows): When window has resize_proportionally set try
	to shrink it proportionally by stealing from other windows.
	(struct saved_window, Fset_window_configuration)
	(compare_window_configurations): Handle resize_proportionally.
	(WINDOW_TOTAL_SIZE): New macro.
	(window_min_size, shrink_windows, size_window): Use it.
	(check_min_window_sizes): Remove.  Invalid values of
	window-min-height|width are handled by window_min_size_2 now.
	(size_window, Fsplit_window, enlarge_window)
	(adjust_window_trailing_edge, grow_mini_window): Don't call
	check_min_window_sizes.
	(window_min_size_2, window_min_size_1, window_min_size):
	New argument safe_p for retrieving "safe" minimum sizes.
	(Fdisplay_buffer, Fsplit_window, enlarge_window)
	(adjust_window_trailing_edge, grow_mini_window):
	Adjust arguments of window_min_size... functions.
	(shrink_windows): Argument min_size removed.  New argument
	safe_p allows shrinking windows to their safe minimum sizes.
	Calculate minimum size and decide whether a window shall be
	deleted for each window individually.
	(size_window): When nodelete_p equals 2, tell shrink_windows to
	delete windows only if their new minimum size is no more safe.
	(shrink_window_lowest_first): Call window_min_size_1 to make
	sure to preserve modeline of bottom-most window when resizing
	the minibuffer.
	(Fset_window_configuration, Fcurrent_window_configuration)
	(compare_window_configurations): Do not handle
	window-min-height|width any more.
	(syms_of_window): Clarify window-min-height|width doc-strings.

2008-04-30  Stefan Monnier  <monnier@iro.umontreal.ca>

	* dired.c (file_name_completion): Fix up the encoding/decoding issue
	some more.  Copy some of the code from Ftry_completions.
	Remove special case code that dates back to revision 1.1 when the
	slash was only added when necessary and that can't trigger nowadays.

2008-04-27  Kenichi Handa  <handa@m17n.org>

	* font.c (font_prop_validate): Signal `error' instead of `font'.

2008-04-29  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (Fw32_battery_status): New defun.
	(syms_of_w32fns): Defsubr it.

2008-04-28  Andreas Schwab  <schwab@suse.de>

	* dired.c (file_name_completion): Fix another mixing of encoded
	and decoded names.

2008-04-28  Juanma Barranquero  <lekktu@gmail.com>

	* w32fns.c (Fw32_define_rgb_color): Fix typo in docstring.

2008-04-27  Juanma Barranquero  <lekktu@gmail.com>

	* fringe.c (Fdefine_fringe_bitmap): Doc fix.

2008-04-27  Andreas Schwab  <schwab@suse.de>

	* dired.c (file_name_completion): Fix inappropriate mixing of
	encoded and decoded names.

	* xterm.c (XTread_socket): Fix use of uninitialized variable.

	* puresize.h (BASE_PURESIZE): Increase to 1200000.

2008-04-26  Eli Zaretskii  <eliz@gnu.org>

	* dired.c (Ffile_attributes) [WINDOWSNT]: Undo change from
	2008-03-31, it's not needed anymore with `struct stat' definition
	on nt/inc/sys/stat.h.  Undo changes from 2007-01-12 and 2007-01-13
	for the same reasons.

2008-04-25  Dennis Gilmore  <ausil@fedoraproject.org>  (tiny change)

	* m/sparc.h: Additional redefinitions for GNU/Linux.

2008-04-23  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (Vmac_ts_active_input_buf) [USE_MAC_TSM]: New variable.
	(syms_of_macterm) [USE_MAC_TSM]: Defvar it.
	(Qmouse_drag_overlay) [MAC_OSX]: New variable.
	(syms_of_macterm) [MAC_OSX]: Intern and staticpro it.
	(mac_get_selected_range, mac_store_buffer_text_to_unicode_chars)
	(mac_ax_selected_text_range) [MAC_OSX]: New functions.
	(mac_ax_number_of_characters) [MAC_OS_X_VERSION_MAX_ALLOWED >= 1030]:
	Likewise.

	* mactoolbox.c (Vmac_ts_active_input_buf) [USE_MAC_TSM]: Add extern.
	(fast_find_position, x_y_to_hpos_vpos, mac_ax_selected_text_range)
	(mac_ax_number_of_characters): Add externs.
	(mac_get_selected_range, mac_store_buffer_text_to_unicode_chars)
	[USE_MAC_TSM]: Likewise.
	(mac_handle_text_input_event) [MAC_OSX]:
	Handle kEventTextInputOffsetToPos for no active input area case.
	Handle kEventTextInputPosToOffset and kEventTextInputGetSelectedText.
	(mac_handle_document_access_event)
	[MAC_OS_X_VERSION_MAX_ALLOWED >= 1030]: New function.
	(install_application_handler) [MAC_OSX]: Register handlers for
	kEventTextInputPosToOffset and kEventTextInputGetSelectedText.
	(install_application_handler) [MAC_OS_X_VERSION_MAX_ALLOWED >= 1030]:
	Register mac_handle_document_access_event.

	* xdisp.c (x_y_to_hpos_vpos, fast_find_position) [HAVE_CARBON]:
	Make functions non-static.

2008-04-23  Stefan Monnier  <monnier@iro.umontreal.ca>

	* fileio.c (Vread_file_name_function, Vread_file_name_predicate)
	(read_file_name_completion_ignore_case, insert_default_directory)
	(Qdefault_directory): Move to minibuffer.el.
	(Fread_file_name): Call the new `read-file-name' instead.

2008-04-23  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c (create_apple_event) [TARGET_API_MAC_CARBON]:
	Make function non-static.
	(create_apple_event_from_event_ref) [TARGET_API_MAC_CARBON]:
	Remove function.
	(create_apple_event_from_drag_ref) [TARGET_API_MAC_CARBON]:
	Move to mactoolbox.c.
	(mac_event_parameters_to_lisp) [TARGET_API_MAC_CARBON]: New function.

	* macgui.h (CGFloat) [!CGFLOAT_DEFINED]: New typedef.
	(mac_rect_make): New macro.

	* macterm.c (mac_draw_image_string_atsui) [MAC_OSX]: Use CGFloat
	instead of float.
	(mac_draw_image_string_cg) [USE_CG_TEXT_DRAWING]: Likewise.
	(init_cg_color, mac_draw_line, mac_draw_cg_image, XSetForeground)
	(XSetBackground) [USE_CG_DRAWING]: Likewise.
	(mac_draw_image_string_atsui) [MAC_OSX]: Use mac_rect_make instead of
	CGRectMake.
	(mac_draw_image_string_cg) [USE_CG_TEXT_DRAWING]: Likewise.
	(mac_erase_rectangle, mac_draw_cg_image, mac_fill_rectangle)
	(mac_set_clip_rectangles) [USE_CG_DRAWING]: Likewise.
	(XCreatePixmap, XCreatePixmapFromBitmapData): Use Window
	instead of WindowRef in argument type.
	(XCreatePixmap) [!MAC_OS8]: Don't call SetPortWindowPort.
	(mac_invert_rectangle): Use CGContextSetBlendMode if available.
	(mac_set_clip_rectangles, mac_reset_clip_rectangles): Take argument F
	instead of DISPLAY.  All uses changed.
	(mac_handle_size_change): Don't call SET_FRAME_GARBAGED.
	(x_calc_absolute_position): Simplify so as not to use
	FRAME_PIXEL_WIDTH/FRAME_PIXEL_HEIGHT.

	* macterm.h (XCreatePixmap, XCreatePixmapFromBitmapData): Use Window
	instead of WindowRef in argument type.
	(create_apple_event_from_event_ref, create_apple_event_from_drag_ref)
	[TARGET_API_MAC_CARBON]: Remove externs.
	(create_apple_event, mac_event_parameters_to_lisp)
	[TARGET_API_MAC_CARBON]: Add externs.

	* mactoolbox.c (Vmac_ts_script_language_on_focus)
	(saved_ts_script_language_on_focus) [USE_MAC_TSM]: Remove externs.
	(XTread_socket) [USE_MAC_TOOLBAR]: Select window if its structure part
	is clicked.
	(x_activate_menubar): Remove extern for saved_menu_event_location.
	(create_apple_event_from_drag_ref) [TARGET_API_MAC_CARBON]:
	Move from mac.c.

2008-04-23  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* alloc.c [!SYSTEM_MALLOC && !SYNC_INPUT] (uninterrupt_malloc)
	[HAVE_GTK_AND_PTHREAD && !DOUG_LEA_MALLOC]: Don't use recursive mutex.

2008-04-23  Jason Rumney  <jasonr@gnu.org>

	* w32.c (stat): When Vw32_get_true_file_attributes is Qlocal, get
	attributes only for local files.

	* w32proc.c (syms_of_ntproc): Change Vw32_get_true_file attributes
	default to Qlocal.

2008-04-22  Juri Linkov  <juri@jurta.org>

	* buffer.c (Fswitch_to_buffer): Change interactive spec to call
	read-buffer-to-switch instead of using the letter "B".

2008-04-21  Stefan Monnier  <monnier@iro.umontreal.ca>

	* fileio.c (Qdefault_directory): New variable.
	(Fread_file_name): Use it to pass `dir' to the completion functions.

2008-04-20  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c (pos_visible_p): Check if iterator stops on a display string.

2008-04-19  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keyboard.c (Vpre_help_message): Remove.
	(show_help_echo): Remove default C code.

	* dired.c (directory_files_internal, file_name_completion):
	Only call ENCODE_FILE if the string is indeed decoded.

2008-04-18  Stefan Monnier  <monnier@iro.umontreal.ca>

	* Makefile.in (TOOLKIT_DEFINES): Remove.
	(LIBW): Use a bit less #if, remove left over OPEN_LOOK stuff.

2008-04-18  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* Makefile.in (MAC_OBJ): Add mactoolbox.o.
	(mactoolbox.o): New target.

	* mac.c [MAC_OSX] (select_and_poll_event, sys_select):
	Use mac_run_loop_run_once instead of CFRunLoopRunInMode.

	* macfns.c (x_set_background_color, mac_window, x_create_tip_frame):
	Use mac_set_frame_window_background instead of XSetWindowBackground.
	(x_set_tool_bar_lines) [USE_MAC_TOOLBAR]:
	Use mac_is_window_toolbar_visible instead of IsWindowToolbarVisible.
	(x_set_name_internal) [TARGET_API_MAC_CARBON]: Use mac_set_window_title
	instead of SetWindowTitleWithCFString.
	(mac_update_proxy_icon) [TARGET_API_MAC_CARBON]: Remove BLOCK_INPUT.
	Move function to mactoolbox.c.
	(mac_update_title_bar) [TARGET_API_MAC_CARBON]:
	Use mac_set_window_modified instead of SetWindowModified.
	Add BLOCK_INPUT around mac_set_window_modified/mac_update_proxy_icon.
	(mac_window, x_create_tip_frame): Use mac_create_frame_window.
	(Fx_focus_frame): Use mac_front_non_floating_window instead of
	FrontNonFloatingWindow.  Use mac_activate_window instead of
	ActivateWindow.  Use mac_active_non_floating_window instead of
	ActiveNonFloatingWindow.
	(show_hourglass, hide_hourglass) [TARGET_API_MAC_CARBON]:
	Use mac_show_hourglass and mac_hide_hourglass.
	(compute_tip_xy) [TARGET_API_MAC_CARBON]: Use mac_get_global_mouse
	instead of GetGlobalMouse.
	(Fx_show_tip): Use mac_move_window/mac_size_window/mac_show_window
	instead of MoveWindow/SizeWindow/ShowWindow, respectively.
	Use mac_bring_window_to_front instead of BringToFront.
	(Qfile_name_history) [TARGET_API_MAC_CARBON]: Move extern to
	mactoolbox.c.
	(Fx_file_dialog) [TARGET_API_MAC_CARBON]: Move function body to
	mac_file_dialog in mactoolbox.c.  Use mac_file_dialog.
	(mac_nav_event_callback) [TARGET_API_MAC_CARBON]: Move function to
	mactoolbox.c.

	* macgui.h [!HAVE_CARBON]: Include Quickdraw.h instead of QuickDraw.h.
	(XtPointer): Move typedef from macmenu.c.
	(enum button_type): Move enum from macmenu.c.
	(widget_value): Move typedef from macmenu.c.
	(M_APPLE, I_ABOUT, EXTRA_STACK_ALLOC, ARGV_STRING_LIST_ID)
	(DIALOG_LEFT_MARGIN, DIALOG_TOP_MARGIN, DIALOG_RIGHT_MARGIN)
	(DIALOG_BOTTOM_MARGIN, DIALOG_MIN_INNER_WIDTH, DIALOG_MAX_INNER_WIDTH)
	(DIALOG_BUTTON_BUTTON_HORIZONTAL_SPACE)
	(DIALOG_BUTTON_BUTTON_VERTICAL_SPACE, DIALOG_BUTTON_MIN_WIDTH)
	(DIALOG_TEXT_MIN_HEIGHT, DIALOG_TEXT_BUTTONS_VERTICAL_SPACE)
	(DIALOG_ICON_WIDTH, DIALOG_ICON_HEIGHT, DIALOG_ICON_LEFT_MARGIN)
	(DIALOG_ICON_TOP_MARGIN): Move defines from macmenu.c.
	(Selection): Move typedef from macselect.c.
	(RAM_TOO_LARGE_ALERT_ID, ABOUT_ALERT_ID) [MAC_OS8]: Move defines from
	macterm.c.
	(mac_set_window_title, mac_set_window_modified, mac_is_window_visible)
	(mac_is_window_collapsed, mac_bring_window_to_front)
	(mac_send_window_behind, mac_hide_window, mac_show_window)
	(mac_collapse_window, mac_front_non_floating_window)
	(mac_active_non_floating_window, mac_activate_window)
	(mac_move_window_structure, mac_move_window, mac_size_window)
	(mac_get_global_mouse, mac_is_window_toolbar_visible): New defines.

	* macmenu.c [!TARGET_API_MAC_CARBON]: Move includes to mactoolbox.c.
	(enum mac_menu_kind): Move enum to mactoolbox.c.
	(min_menu_id): Move variable to mactoolbox.c.
	(quit_dialog_event_loop) [TARGET_API_MAC_CARBON]: Likewise.
	(DIALOG_WINDOW_RESOURCE): Move define to mactoolbox.c.
	(DIALOG_BUTTON_COMMAND_ID_OFFSET, DIALOG_BUTTON_COMMAND_ID_P)
	(DIALOG_BUTTON_COMMAND_ID_VALUE, DIALOG_BUTTON_MAKE_COMMAND_ID)
	[TARGET_API_MAC_CARBON]: Likewise.
	(XtPointer): Move typedef to macgui.h.
	(enum button_type): Move enum to macgui.h.
	(widget_value): Move typedef to macgui.h.
	(DIALOG_LEFT_MARGIN, DIALOG_TOP_MARGIN, DIALOG_RIGHT_MARGIN)
	(DIALOG_BOTTOM_MARGIN, DIALOG_MIN_INNER_WIDTH, DIALOG_MAX_INNER_WIDTH)
	(DIALOG_BUTTON_BUTTON_HORIZONTAL_SPACE)
	(DIALOG_BUTTON_BUTTON_VERTICAL_SPACE, DIALOG_BUTTON_MIN_WIDTH)
	(DIALOG_TEXT_MIN_HEIGHT, DIALOG_TEXT_BUTTONS_VERTICAL_SPACE)
	(DIALOG_ICON_WIDTH, DIALOG_ICON_HEIGHT, DIALOG_ICON_LEFT_MARGIN)
	(DIALOG_ICON_TOP_MARGIN): Move defines to macgui.h.
	(popup_activated_flag): Make variable non-static.
	(x_activate_menubar, install_menu_quit_handler, pop_down_menu)
	(add_menu_item, fill_menu, dispose_menus):
	Move functions to mactoolbox.c.
	(restore_show_help_function, menu_target_item_handler)
	(install_menu_target_item_handler, mac_handle_dialog_event)
	(install_dialog_event_handler, pop_down_dialog, create_and_show_dialog)
	[TARGET_API_MAC_CARBON]: Likewise.
	(menu_quit_handler) [MAC_OS_X_VERSION_MAX_ALLOWED >= 1030]: Likewise.
	(mac_dialog) [!TARGET_API_MAC_CARBON]: Likewise.
	(find_and_call_menu_selection, name_is_separator): Make function
	non-static.
	(Vshow_help_function, timer_check) [TARGET_API_MAC_CARBON]: Move extern
	to mactoolbox.c.
	(set_frame_menubar): Don't call install_menu_quit_handler.
	(menu_item_selection): New variable.
	(mac_menu_show): Use create_and_show_popup_menu.
	(create_and_show_dialog) [TARGET_API_MAC_CARBON]: Don't return
	selection but set variable menu_item_selection.  All uses changed.
	(mac_fill_menubar): Rename from fill_menubar.  All uses changed.
	Call install_menu_quit_handler.  Move to mactoolbox.c.

	* macselect.c [!TARGET_API_MAC_CARBON]: Don't include Scrap.h.
	(Selection): Move typedef to macgui.h.
	(Vselection_converter_alist, Qmac_scrap_name, Qmac_ostype)
	(Vmac_apple_event_map, Qmac_apple_event_class, Qmac_apple_event_id):
	Make variables non-static.
	(Vmac_dnd_known_types) [TARGET_API_MAC_CARBON]: Likewise.
	(mac_handle_apple_event, cleanup_all_suspended_apple_events):
	Make functions non-static.
	(Vmac_service_selection) [MAC_OSX]: Likewise.
	(mac_get_selection_from_symbol, get_flavor_type_from_symbol)
	(mac_valid_selection_target_p, mac_clear_selection)
	(mac_get_selection_ownership_info, mac_valid_selection_value_p)
	(mac_put_selection_value, mac_selection_has_target_p)
	(mac_get_selection_value, mac_get_selection_target_list)
	(init_apple_event_handler, install_drag_handler, remove_drag_handler):
	Move functions to mactoolbox.c.
	(mac_do_track_drag, mac_do_receive_drag) [TARGET_API_MAC_CARBON]:
	Likewise.
	(copy_scrap_flavor_data, mac_handle_service_event)
	(install_service_handler) [MAC_OSX]: Likewise.
	(syms_of_macselect) <Vmac_dnd_known_types>:
	Use mac_dnd_default_known_types.

	* macterm.h (FRAME_OUTER_TO_INNER_DIFF_X, FRAME_OUTER_TO_INNER_DIFF_Y):
	Move to mactoolbox.c.
	(HOURGLASS_WIDTH, HOURGLASS_HEIGHT): Change to 15.
	(Fx_selection_owner_p): Add EXFUN.
	(install_window_handler, remove_window_handler, XSetWindowBackground):
	Remove externs.
	(do_apple_menu) [!TARGET_API_MAC_CARBON]: Likewise.
	(mac_prepare_for_quickdraw) [USE_CG_DRAWING]: Likewise.
	(x_raise_frame, x_lower_frame, mac_alert_sound_play)
	(install_application_handler, mac_get_frame_bounds, mac_get_frame_mouse)
	(mac_convert_frame_point_to_global, mac_set_frame_window_background)
	(mac_update_begin mac_update_end, mac_frame_up_to_date, x_flush)
	(mac_create_frame_window, mac_dispose_frame_window, mac_begin_clip)
	(mac_end_clip, mac_create_scroll_bar, mac_dispose_scroll_bar)
	(mac_set_scroll_bar_bounds, mac_redraw_scroll_bar, mac_fill_menubar)
	(create_and_show_popup_menu, mac_get_selection_from_symbol)
	(mac_valid_selection_target_p, mac_clear_selection)
	(mac_get_selection_ownership_info, mac_valid_selection_value_p)
	(mac_put_selection_value, mac_selection_has_target_p)
	(mac_get_selection_value, mac_get_selection_target_list): Add externs.
	(mac_update_proxy_icon, mac_show_hourglass, mac_hide_hourglass)
	(mac_reposition_hourglass, mac_file_dialog, create_and_show_dialog)
	(mac_dnd_default_known_types) [TARGET_API_MAC_CARBON]: Likewise.
	(mac_run_loop_run_once) [MAC_OSX]: Likewise.
	(mac_dialog) [!TARGET_API_MAC_CARBON]: Likewise.
	(mac_begin_cg_clip, mac_end_cg_clip) [USE_CG_DRAWING]: Likewise.
	(x_set_toolkit_scroll_bar_thumb) [!USE_TOOLKIT_SCROLL_BARS]: Likewise.
	(x_scroll_bar_set_handle) [!USE_TOOLKIT_SCROLL_BARS]: Likewise.

	* mactoolbox.c: New file.

2008-04-18  Jason Rumney  <jasonr@gnu.org>

	* dired.c (Ffile_attributes) [WINDOWSNT]: Cast uid and gid to unsigned.

2008-04-18  Stefan Monnier  <monnier@iro.umontreal.ca>

	* character.c (Fmultibyte_char_to_unibyte):
	Return latin1 chars unchanged.

	* fileio.c (Fexpand_file_name): Refine last fix so `nm' is only
	relocated if it points to `name'.

2008-04-17  Kenichi Handa  <handa@m17n.org>

	* data.c (Faset): Allow setting a multibyte character in an
	ASCII-only unibyte string.

	* lisp.h (STRING_SET_MULTIBYTE): New macro.

2008-04-16  Stefan Monnier  <monnier@iro.umontreal.ca>

	* Makefile.in: Don't use HAVE_GTK and don't -DUSE_GTK since it's now
	done in config.h.

2008-04-16  Juanma Barranquero  <lekktu@gmail.com>

	* character.c (Fchar_bytes, Fchar_width, Fstring_width)
	(Fchar_direction): Add usage in the docstring.

2008-04-15  Chong Yidong  <cyd@stupidchicken.com>

	* keyboard.c (read_key_sequence): Remove always-true checks.

2008-04-14  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_open_internal): Set max_bounds.descent in
	compatibility struct, for better underline positioning.

2008-04-13  David Hansen  <david.hansen@gmx.net>

	* dbusbind.c (dbus-get-unique-name): Remove extra copying of name
	string.

2008-04-12  Dan Nicolaescu  <dann@ics.uci.edu>

	* m/hp800.h (XUINT, XSET): Remove.

2008-04-12  Juanma Barranquero  <lekktu@gmail.com>

	* fileio.c (Fexpand_file_name): Add declaration for `p' missing in
	previous change.

2008-04-12  Stefan Monnier  <monnier@iro.umontreal.ca>

	* fileio.c (Fexpand_file_name): Tighten the scope of `p' and `o' vars.
	Relocate `nm' after calling DECODE_FILE, in case the GC was run.

2008-04-11  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keymap.h (map_keymap_canonical): Declare.
	* xmenu.c (single_keymap_panes): Use it.

2008-04-11  Glenn Morris  <rgm@gnu.org>

	* eval.c (Fdefvaralias): If the alias is bound and the target is not,
	set the target's value to that of the alias.

2008-04-11  Stefan Monnier  <monnier@iro.umontreal.ca>

	* term.c (set_tty_color_mode): Left over typo.

2008-04-10  Michael Albinus  <michael.albinus@gmx.de>

	* fileio.c (Fmake_symbolic_link): Surround code by #ifdef S_IFLNK
	only after check for file name handler functions.  Signal, when
	native functionality is not supported.
	(syms_of_fileio): Declare it unconditionally.

2008-04-10  Jason Rumney  <jasonr@gnu.org>

	* w32menu.c (is_simple_dialog, simple_dialog_show): New functions.
	(Fx_popup_dialog): Handle simple yes/no questions as dialogs.

	* w32.c (logon_network_drive): Also logon to remote drives that
	are mapped to drive letters.

2008-04-10  Glenn Morris  <rgm@gnu.org>

	* xdisp.c (truncate-partial-width-windows): Doc fix.

2008-04-10  Stefan Monnier  <monnier@iro.umontreal.ca>

	* fileio.c (read_file_name_cleanup, Fread_file_name_internal):
	Move functions to minibuffer.el.
	(syms_of_fileio): Don't declare them.

2008-04-09  Stefan Monnier  <monnier@iro.umontreal.ca>

	* minibuf.c (Vcompletion_auto_help): Move to minibuffer.el.
	(syms_of_minibuf): Remove its initialization.

	* minibuf.c (temp_echo_area_glyphs): Remove unused function.

2008-04-09  Juanma Barranquero  <lekktu@gmail.com>

	* editfns.c (Ffield_string_no_properties): Fix typo in docstring.

2008-04-09  Jason Rumney  <jasonr@gnu.org>

	* makefile.w32-in (distclean): Delete makefile too.
	(maintainer-clean): New target.

	* xdisp.c (redisplay_internal) [!WINDOWSNT]: Conditionalize last change.

	* w32term.c (w32_compute_glyph_string_overhangs): Compute overhangs
	for new font backend and composite cases.

2008-04-09  Jan Djärv  <jan.h.d@swipnet.se>

	* atimer.c (alarm_signal_handler): Call run_timers if not SYNC_INPUT.
	Most of the code moved to run_timers.
	(do_pending_atimers): Call run_timers.
	(run_timers): New function.

	* sysdep.c (emacs_write): If SYNC_INPUT and pending_atimers,
	run atimers.

	* process.c (wait_reading_process_output): The same as above.

2008-04-09  Stefan Monnier  <monnier@iro.umontreal.ca>

	* minibuf.c (last_exact_completion): Remove variable.
	(Fdelete_minibuffer_contents, do_completion, Fminibuffer_complete)
	(complete_and_exit_1, complete_and_exit_2)
	(Fminibuffer_complete_and_exit, Fminibuffer_complete_word)
	(Fdisplay_completion_list, display_completion_list_1)
	(Fminibuffer_completion_help, Fself_insert_and_exit)
	(Fexit_minibuffer, Fminibuffer_message): Move functions to
	minibuffer.el.
	(syms_of_minibuf): Remove corresponding initializations.

	* keyboard.c (Qdeactivate_mark): New var.
	(command_loop_1): Use it to call `deactivate-mark'.
	(syms_of_keyboard): Initialize it.

	* xdisp.c (redisplay_internal): Reset tty's color_mode when switching
	to another frame.
	* frame.c (do_switch_frame): Refine the top_frame/async_visible code.
	Don't call set_tty_color_mode.
	(store_frame_param): Reset previous_frame rather than call
	set_tty_color_mode.
	* term.c (set_tty_color_mode): Rewrite.
	* dispextern.h (set_tty_color_mode): New type.
	* termchar.h (struct tty_display_info): Add `previous_color_mode'.

2008-04-08  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keymap.c (access_keymap): Remove the value 2 for t_ok which was used
	for generic chars, which do not exist any more in emacs-unicode.

2008-04-08  Michael Albinus  <michael.albinus@gmx.de>

	* coding.c (detect_coding_emacs_mule)
	(Ffind_operation_coding_system): Fix typo.

2008-04-08  Jason Rumney  <jasonr@gnu.org>

	* w32uniscribe.c (SNAME): Extract only symbol name.

	* w32font.h (struct w32_metric_cache): New struct.
	(w32font_info): Use it.
	(W32METRIC_NO_ATTEMPT, W32METRIC_SUCCESS, W32METRIC_FAIL)
	(CACHE_BLOCKSIZE): New constants.

	* w32font.c (Qja, Qko, Qzh): New symbols.
	(syms_of_w32font): Initialise them.
	(font_matches_spec): Use them to filter by language.
	(recompute_cached_metrics): Remove function.
	(compute_metrics, clear_cached_metrics): New functions.
	(w32font_encode_char): Use them to manage metric cache.
	(w32font_text_extents): Cache metrics for all glyphs on demand.
	Delay converting glyph indices to WORD until needed.
	(w32font_open_internal): Initialize metric cache to empty.
	(registry_to_w32_charset): Charset should always be a symbol.
	(fill_in_logfont, list_all_matching_fonts): Family should
	always be a symbol.

2008-04-06  Jason Rumney  <jasonr@gnu.org>

	* w32uniscribe.c (uniscribe_shape): Increase items buffer size.
	Give up if glyph indices not supported.  Use uniscribe obtained
	ABC widths for individual metrics.  Map glyph clusters back to
	characters using fClusterStart flag.  Return number of glyphs
	produced, not chars processed.
	(uniscribe_shape): Map char at FROM to current glyph.

2008-04-05  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macmenu.c (fill_menu) [TARGET_API_MAC_CARBON]:
	Use SetMenuItemHierarchicalMenu.

2008-04-05  Jason Rumney  <jasonr@gnu.org>

	* image.c (pbm_load): Allow color values up to 65535.
	Throw an error if max_color_idx is outside the supported range.
	Report an error when image size is invalid.
	Read two bytes at a time when raw images have max_color_idx above 255.

2008-04-05  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (readdir): If FindFirstFile/FindNextFile return in
	cFileName a file name that includes `?' characters, use the 8+3
	alias in cAlternateFileName instead.

2008-04-05  Kenichi Handa  <handa@ni.aist.go.jp>

	* ccl.c (ccl_driver): If ccl->quit_silently is nonzero, don't
	append "CCL: Quitted" when the CCL program is quitted.
	(setup_ccl_program): Initialize ccl->quit_silently to zero.

	* ccl.h (struct ccl_program): New member quit_silently.

2008-04-05  Chong Yidong  <cyd@stupidchicken.com>

	* search.c (compile_pattern_1): Treat non-nil and non-string of
	search-spaces-regexp as nil.

	* minibuf.c (Fassoc_string): Tweak docstring.

2008-04-05  Eli Zaretskii  <eliz@gnu.org>

	* dired.c (Ffile_attributes): Support inode numbers wider than 32
	bits.  Remove ugly WINDOWSNT-specific kludge introduced on
	2008-03-14 to force inode be positive.

	* w32.c (sys_chown, stat, fstat): Use S_* constants instead of
	_S_* ones, since we now use our own sys/stat.h.
	(stat, fstat): Don't mangle the inode number.
	(init_user_info): Don't restrict UID and GID to 0-60000 range.

2008-04-04  Stefan Monnier  <monnier@iro.umontreal.ca>

	* frame.h (struct frame): Give one more bit to `visible' since we use
	values larger than 1 to indicate obscured frames on ttys.

	* keymap.c (Qkeymap_canonicalize): New var.
	(Fmap_keymap_internal): New fun.
	(describe_map): Use keymap-canonicalize.

	* undo.c (last_boundary_buffer, last_boundary_position): New vars.
	(Fundo_boundary): Set them.
	(syms_of_undo): Initialize them.
	(record_point): Use them instead of last_point_position*.
	(last_undo_buffer): Change type.

2008-04-04  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_text_extents): Use font's ascent and descent.
	(recompute_cached_metrics): Don't set ascent and descent per char.

	* w32uniscribe.c (uniscribe_check_otf): Fix last change.
	(uniscribe_check_otf): Add GC protection before consing.
	Rearrange loop for counting features.

2008-04-03  Stefan Monnier  <monnier@iro.umontreal.ca>

	* insdel.c (insert_from_buffer_1): Don't compare bytes in destination
	buffer with byte-size of source buffer.

2008-04-03  Chong Yidong  <cyd@stupidchicken.com>

	* callint.c (Fcall_interactively): Handle temporary region even
	when shift-select-mode is off.

2008-04-03  Jason Rumney  <jasonr@gnu.org>

	* w32uniscribe.c (uniscribe_check_otf): Sanity check otf_spec.

2008-04-03  Kenichi Handa  <handa@m17n.org>

	* coding.c (CATEGORY_MASK_ANY): Add CATEGORY_MASK_UTF_16_AUTO.
	(CATEGORY_MASK_UTF_16): Likewise.
	(detect_coding_utf_16): Add heuristics to reject utf-16 for a
	binary file.
	(detect_coding): Add null-byte detection for a binary file.
	(detect_coding_system): Likewise.

2008-04-03  Jason Rumney  <jasonr@gnu.org>

	* w32uniscribe.c: New file.

	* font.h (uniscribe_font_driver) [WINDOWSNT]: Declare for w32fns.c.

	* w32font.h (uniscribe_check_otf): Declare for w32font.c.

	* w32font.c (Qbalinese, Qbuginese, Qbuhid, Qcuneiform, Qcypriot)
	(Qdeseret, Qglagolitic, Qgothic, Qhanunoo, Qkharoshthi)
	(Qlimbu, Qlinear_b, Qold_italic, Qold_persian, Qosmanya)
	(Qphags_pa, Qphoenician, Qshavian, Qsyloti_nagri)
	(Qtagalog, Qtagbanwa, Qtai_le, Qtifinagh, Qugaritic)
	(Qphonetic): New symbols.
	(syms_of_w32font): Initialize them.
	(font_supported_scripts): Use them.
	(w32font_list_family): List all charsets.
	(w32font_text_extents, recompute_cached_metrics): Fix metric
	calculations.
	(w32_enumfont_pattern_entity): Make full_type a DWORD.
	Give opentype fonts their own format.
	(font_matches_spec): New arguments backend and logfont.
	Handle :otf spec for uniscribe backend.
	(add_font_entity_to_list): Match truetype fonts in uniscribe backend.
	(fill_in_logfont): Use DEFAULT_CHARSET when charset not supplied.

	* w32fns.c (Fx_create_frame): Conditionally register uniscribe
	font backend.
	(globals_of_w32fns): Initialize uniscribe font backend.

	* makefile.w32-in (CONFIG_H): New variable.  Use it to clean up
	dependencies.
	(w32uniscribe.$(O)): New file to build.
	(FONT_OBJ): Include w32uniscribe.$(O).
	(LIBS): Add uniscribe libraries.

	* ftfont.c (ftfont_get_open_type_spec): Check spec->script, not val.

2008-04-02  Chong Yidong  <cyd@stupidchicken.com>

	* callint.c (Vshift_select_mode): New var.
	(Finteractive): Document new ^ spec.
	(Fcall_interactively): Call handle-shift-selection if the ^ spec
	is present.

	* keyboard.c (Vthis_command_keys_shift_translated): New var.
	(command_loop_1): Avoid running the direct display versions of
	forward-char and backward-char if shift-selection may occur.
	(read_key_sequence): Set Vthis_command_keys_shift_translated if
	shift-translation takes place.

	* buffer.c (Vtransient_mark_mode): Move docstring to simple.el to
	avoid clobbering by define-minor-mode.

	* cmds.c (Fforward_char, Fbackward_char, Fforward_line)
	(Fbeginning_of_line, Fend_of_line): Add ^ interactive spec.

	* syntax.c (Fforward_word): Add ^ interactive spec.

	* window.c (Fscroll_up, Fscroll_down, Fscroll_left)
	(Fscroll_right): Add ^ interactive spec.

2008-04-01  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xdisp.c (try_window_id): Don't forget to reset delta_bytes.

	* casefiddle.c (casify_object): Fix up int/EMACS_INT mixup.

	* charset.c (Funibyte_charset, Fset_unibyte_charset): Remove.

2008-03-31  Juri Linkov  <juri@jurta.org>

	* window.c (Fdisplay_buffer): Reinitialize `tem' to nil.

2008-03-30  Jan Djärv  <jan.h.d@swipnet.se>

	* gtkutil.c (xg_set_geometry): Fix indentation.
	(xg_resize_outer_widget): Remove.
	(x_wm_size_hint_off): Fix indentation.
	(xg_frame_set_char_size): Call flush_and_sync after
	gtk_window_resize.
	(x_wm_set_size_hint): Pass NULL as geometry window to
	gtk_window_set_geometry_hints due to Gtk+ bug nr 68668.
	Add menu bar and tool bar height to base height.
	(xg_update_frame_menubar, free_frame_menubar)
	(xg_tool_bar_detach_callback, xg_tool_bar_attach_callback)
	(update_frame_tool_bar, free_frame_tool_bar):
	Change xg_resize_outer_widget to xg_frame_set_char_size.

2008-03-30  Michael Albinus  <michael.albinus@gmx.de>

	* dbusbind.c (QCdbus_timeout): New D-Bus internal symbol.
	(Fdbus_call_method): New parameter TIMEOUT.
	(dbus-send-signal): Optimize UNGCPRO call.

2008-03-29  Juri Linkov  <juri@jurta.org>

	* window.c (Fdisplay_buffer): Move call to
	Vsplit_window_preferred_function out of conditions that check
	if window is eligible for vertical splitting.
	When Vsplit_window_preferred_function is non-nil, call it and use
	its non-nil return value as window.  Otherwise, continue doing
	vertical splitting using Fsplit_window with arg horflag=nil.
	(syms_of_window) <Vsplit_window_preferred_function>: Change the
	default value from `split-window' to nil.

2008-03-29  Juri Linkov  <juri@jurta.org>

	* callint.c (Fcall_interactively): Revert 2008-03-16 change
	for interactive code letters 'b' and 'B'.

2008-03-29  Eli Zaretskii  <eliz@gnu.org>

	* fileio.c (Fexpand_file_name): Convert the value of $HOME to a
	multibyte string.

2008-03-29  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keyboard.c (pending_funcalls): New var.
	(timer_check): Run it.
	(syms_of_keyboard): Initialize it.
	* terminal.c (Qrun_hook_with_args, Qdelete_terminal_functions)
	(Vdelete_terminal_functions): New vars.
	(syms_of_terminal): Initialize them.
	(Fdelete_terminal): Run delete-terminal-functions.
	* xdisp.c (safe_eval): Rewrite.
	(safe_call2): New fun.
	* frame.c (Qdelete_frame_functions): New var.
	(syms_of_frame): Initialize it.
	(Fdelete_frame): Use it and use safe_call2 and pending_funcalls.
	* lisp.h (safe_call2, pending_funcalls): Declare.

2008-03-28  Andreas Schwab  <schwab@suse.de>

	* indent.c (Fmove_to_column): Move declaration before statements.

2008-03-27  Stefan Monnier  <monnier@iro.umontreal.ca>

	* frame.h (enum fullscreen_type): Give it a name.  Move it before use.
	(struct frame): Use bit fields for boolean vars.

	* process.c (server_accept_connection): Simplify naming.
	(emacs_get_tty_pgrp): Use SDATA.

	* coding.c (decode_coding_object): Fix last change.

2008-03-27  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (start_hourglass): Suppress hourglass on tty frames.

2008-03-27  Kenichi Handa  <handa@ni.aist.go.jp>

	* charset.c (Fdefine_charset_internal): Change the way of
	registering charsets in Vcharset_order_list.
	(syms_of_charset): Make the charset `eight-bit' supplementary.

2008-03-26  Alexandre Oliva  <aoliva@redhat.com>  (tiny change)

	* regex.c (EXTEND_BUFFER): Change order of pointer addition
	operations, to avoid having the difference between pointers
	overflow.

2008-03-26  Stefan Monnier  <monnier@iro.umontreal.ca>

	* indent.c (check_display_width): New fun.
	(scan_for_column): Use it.

	* data.c (syms_of_data): Mark most-positive-fixnum and
	most-negative-fixnum as constants.

	* xdisp.c (redisplay_internal): Reset selected_frame earlier.

	* indent.c (scan_for_column): Extract from current_column_1.
	Merge with the same code from Fmove_to_column.
	(current_column_1, Fmove_to_column): Use it.

2008-03-25  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keymap.c (map_keymap_internal): New fun.
	(map_keymap): Use it.
	(Fmap_keymap_internal): New fun.
	(Fmap_keymap): Remove left-out test from before make_save_value.

	* keymap.c (Fmap_keymap): Use `map-keymap-sorted.

	* frame.c (Fmodify_frame_parameters, x_set_frame_parameters):
	Use XCAR/XCDR.

	* process.h (struct Lisp_Process): Remove filter_multibyte.
	* process.c (QCfilter_multibyte): Remove.
	(setup_process_coding_systems): Don't use filter_multibyte.
	(Fstart_process, Fmake_network_process): Don't set filter_multibyte.
	(read_process_output): Don't adjust multibyteness to filter_multibyte.
	(Fset_process_filter_multibyte): Change the coding-system to
	approximate the previous behavior.
	(Fprocess_filter_multibyte_p): Get the multibyteness straight from the
	coding-system.

	* coding.c (decode_coding_object): When not decoding into a buffer,
	obey the coding system's preference of (uni|multi)byte.

2008-03-24  Stefan Monnier  <monnier@iro.umontreal.ca>

	* casefiddle.c (casify_object): Avoid pathological N^2 worst case if
	every char is changed and has a different byte-length.
	(Fupcase_word, Fdowncase_word, Fcapitalize_word, operate_on_word):
	Fix int -> EMACS_INT.

2008-03-23  David Hansen  <david.hansen@gmx.net>

	* dbusbind.c (xd_read_message): Remove extra copying of message
	strings.  Check for NULL `interface' or `member'.

2008-03-22  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (readdir): If FindFirstFile/FindNextFile return in
	cFileName a file name that includes `?' characters, use the 8+3
	alias in cAlternateFileName instead.

2008-03-21  Stefan Monnier  <monnier@iro.umontreal.ca>

	* buffer.c (enlarge_buffer_text): Fix int -> EMACS_INT.

2008-03-20  Stefan Monnier  <monnier@iro.umontreal.ca>

	* intervals.c (temp_set_point, temp_set_point_both): Use EMACS_INT.
	(set_point, set_point_both): Use EMACS_INT.  Remove `buffer' arg,
	work on current_buffer only instead (that was already the case
	for some of the code anyway).
	* buffer.h (set_point, set_point_both): Remove buffer arg, use long int.
	(temp_set_point, temp_set_point_both): Use EMACS_INT.
	(SET_PT, SET_PT_BOTH): Adjust.
	* intervals.h (set_point, temp_set_point, set_point_both)
	(temp_set_point_both): Remove redundant declarations.

2008-03-20  Stefan Monnier  <monnier@iro.umontreal.ca>

	* fileio.c (Finsert_file_contents):
	* lread.c (Feval_buffer): Use BUF_TEMP_SET_PT.
	* buffer.h (BUF_SET_PT): Remove.  set_point_both doesn't work right
	when buffer != current_buffer anyway.

2008-03-20  Andreas Schwab  <schwab@suse.de>

	* callint.c (Fcall_interactively) [case 'B']: Use other-buffer
	as default.

2008-03-19  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (hourglass_timer, hourglass_hwnd): New variables.
	(syms_of_w32fns): Initialize them.
	(HOURGLASS_ID): New constant.
	(x_window_to_frame): Don't check hourglass_window.
	(w32_wnd_proc) <WM_TIMER>: Handle hourglass_timer.
	(w32_wnd_proc) <WM_EXITMENULOOP>: Set pending hourglass cursor.
	(w32_wnd_proc) <WM_SETCURSOR>: Set the hourglass or current cursor.
	(w32_wnd_proc) <WM_EMACS_SETCURSOR>: Set frame's current_cursor.
	Only change the cursor if hourglass is not active.
	(Fx_create_frame): Initialize frame's current_cursor.
	(hourglass_atimer): Remove.
	(hourglass_started): New function.
	(start_hourglass, cancel_hourglass, hide_hourglass): Adapt to w32.
	(show_hourglass): Adapt to w32, changing argument to frame.

	* w32term.h (struct w32_output): Remove hourglass_window.
	Add current_cursor.

	* eval.c (call_debugger, Fsignal):
	* keyboard.c (recursive_edit_1, cmd_error, Ftop_level)
	(command_loop_1, Fread_key_sequence, Fread_key_sequence_vector)
	(Fexecute_extended_command, cancel_hourglass_unwind):
	* minibuf.c (read_minibuf):
	* fns.c (Fy_or_n_p): Enable hourglass when HAVE_WINDOW_SYSTEM.

2008-03-19  Stefan Monnier  <monnier@iro.umontreal.ca>

	* window.c (run_funs): New fun.
	(run_window_configuration_change_hook): Use it to run the buffer-local
	and the global part of the hook.

	* xdisp.c (format_mode_line_unwind_data): Add window argument.
	(unwind_format_mode_line): Restore selected window.
	(x_consider_frame_title, Fformat_mode_line): Set selected window.

2008-03-17  Stefan Monnier  <monnier@iro.umontreal.ca>

	* editfns.c (Fchar_equal): Check they are valid characters.

	* buffer.h (Fbuffer_list): Declare (for use in callint.c).

2008-03-17  Andreas Schwab  <schwab@suse.de>

	* regex.c (re_match_2_internal): Properly match raw 8-bit bytes
	against a charset.

	* lisp.h (Fbuffer_list): Declare.

2008-03-17  Jan Djärv  <jan.h.d@swipnet.se>

	* gtkutil.c (free_frame_tool_bar): Only call gtk_container_remove if
	handlebox_widget is != 0.

2008-03-16  Juri Linkov  <juri@jurta.org>

	* callint.c (Fcall_interactively): For interactive code letters
	'b' and 'B' put the buffer list into the list of default "future"
	values of the minibuffer.

2008-03-16  Andreas Schwab  <schwab@suse.de>

	* keyboard.c (read_key_sequence): Fix downcasing of letters with
	modifiers.

	* regex.c (re_match_2_internal): Correct matching of a charset
	against latin-1 characters.

2008-03-16  Kenichi Handa  <handa@m17n.org>

	* coding.c (CHAR_STRING_ADVANCE_NO_UNIFY)
	(STRING_CHAR_ADVANCE_NO_UNIFY): New macros.
	(coding_alloc_by_making_gap): Fix the way to preserve data in the gap.
	(alloc_destination): Fix the 2nd arg to coding_alloc_by_making_gap.
	(encode_coding_utf_8): Use CHAR_STRING_ADVANCE_NO_UNIFY instead of
	CHAR_STRING_ADVANCE.
	(produce_chars): Fix for the case that the source and the
	destination are the same buffer.  Use CHAR_STRING_ADVANCE_NO_UNIFY
	instead of CHAR_STRING_ADVANCE.
	(consume_chars): Use STRING_CHAR_ADVANCE_NO_UNIFY instead of
	STRING_CHAR_ADVANCE.

2008-03-15  Andreas Schwab  <schwab@suse.de>

	* regex.c (re_match_2_internal): Correct matching of eight bit
	characters in unibyte strings.

2008-03-15  Martin Rudalics  <rudalics@gmx.at>

	* buffer.c (overlays_in, Foverlays_in): Include empty overlays
	at end of range when it coincides with the end of the buffer.

2008-03-14  Eli Zaretskii  <eliz@gnu.org>

	* dired.c (Ffile_attributes) [WINDOWSNT]: Force inode be positive.

	* w32fns.c (globals_of_w32fns, Fx_create_frame): Fix last change.

2008-03-14  Jason Rumney  <jasonr@gnu.org>

	* editfns.c (initial_tz): New variable.
	(syms_of_editfns): Initialize it.
	(Fset_time_zone_rule): Set it when first called.
	Use it when TZSTRING is nil.

	* w32fns.c (MONITOR_DEFAULT_TO_NEAREST, struct MONITOR_INFO)
	(MonitorFromPoint_Proc, GetMonitorInfo_Proc): New definitions.
	(monitor_from_point_fn, get_monitor_info_fn): New globals.
	(globals_of_w32fns): Initialize them.
	(compute_tip_xy): Use them to position tooltips.

2008-03-14  Glenn Morris  <rgm@gnu.org>

	* emacs.c (main): Revert previous change.
	(standard_args): Revert -internal-script back to -scriptload,
	and remove the long-option form.

2008-03-13  Glenn Morris  <rgm@gnu.org>

	* emacs.c (main, standard_args): Rename -scriptload to -internal-script.
	Remove option -enable-font-backend.

2008-03-12  Stefan Monnier  <monnier@iro.umontreal.ca>

	* buffer.c (Fswitch_to_buffer): Fall back on pop-to-buffer.

2008-03-11  Jan Djärv  <jan.h.d@swipnet.se>

	* xterm.c (x_connection_closed): For GTK: If this is the last
	terminal just exit without closing the display.

2008-03-11  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_full_name): Use floor to round.

2008-03-10  dhruva  <dhruvakm@gmail.com>  (tiny change)

	* sound.c (alsa_configure): Declare vol at beginning of block.

	* fontset.c (Ffontset_info): Remove extra semicolon.

2008-03-10  Stefan Monnier  <monnier@iro.umontreal.ca>

	* fileio.c (Fsubstitute_in_file_name): Fix up computation of maximum
	size of resulting string.

2008-03-10  Jason Rumney  <jasonr@gnu.org>

	* dispnew.c (adjust_glyph_matrix): Initialize window_height.

2008-03-10  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* xdisp.c (handle_single_display_spec): Undo 2007-10-16 changes.
	Don't pretend as if characters with display property haven't been
	consumed for string-replacing-string case.

2008-03-08  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (GET_NEXT_DISPLAY_ELEMENT): New macro.
	(get_next_display_element, next_element_from_string)
	(next_element_from_ellipsis, next_element_from_buffer): Use it.

2008-03-08  Andreas Schwab  <schwab@suse.de>

	* process.h (struct Lisp_Process): Declare bit fields as unsigned.

2008-03-06  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32_registry): Take font_type argument.  Use ANSI
	when charset not specified.  Only translate ANSI to unicode when
	font_type is truetype.
	(w32font_coverage_ok): New function.
	(add_font_entity_to_list): Use it to filter unsuitable fonts.

2008-03-05  Kenichi Handa  <handa@ni.aist.go.jp>

	* lread.c (Fread_char): Resolve modifiers.
	(Fread_char_exclusive): Likewise.

	* character.c (char_resolve_modifier_mask): New function.
	(char_string): Use char_resolve_modifier_mask.
	(Fchar_resolve_modifiers): New function.
	(syms_of_character): Declare Fchar_resolve_modifiers as Lisp
	function.

2008-03-04  Jason Rumney  <jasonr@gnu.org>

	* makefile.w32-in: Always include w32font.c in the build.
	* w32font.c: Wrap in USE_FONT_BACKEND conditional.

2008-03-04  Andreas Schwab  <schwab@suse.de>

	* Makefile.in (clean): Remove emacs-*.*.* instead of emacs-*.
	(versionclean): Likewise.

2008-03-04  Juanma Barranquero  <lekktu@gmail.com>

	* .cvsignore: Add oo.

2008-03-03  Andreas Schwab  <schwab@suse.de>

	* coding.c (decode_coding_object): Inhibit gap shrinking while
	decoding in place.

2008-03-03  Dan Nicolaescu  <dann@ics.uci.edu>

	* w32term.c: Remove unused include "gnu.h".
	* makefile.w32-in (w32term.o): Don't depend on gnu.h.

	* gnu.h: Rename to ...
	* emacs-icon.h: ... this.
	* xterm.c: Use emacs-icon.h instead of gnu.h.
	* Makefile (xterm.o): Depend on emacs-icon.h, not gnu.h.

2008-03-03  Juanma Barranquero  <lekktu@gmail.com>

	* w32font.c: Include math.h.

2008-03-03  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (recompute_cached_metrics): Change font arg to w32font_info.
	Compute options separately.
	(w32font_open_internal): Set glyph_idx before caching metrics.

	* w32font.h (NTM_PS_OPENTYPE, NTM_TT_OPENTYPE, NTM_TYPE1):
	Define if system headers don't.
	(struct w32font_info): Enlarge ascii_metrics.  Add glyph_idx.
	(w32font_encode_char): Don't declare here.

	* w32font.c (Quniscribe, QCformat): New symbols.
	(syms_of_w32font): Define them.
	(w32font_has_char): Indicate uncertainty.
	(w32font_encode_char): Encode as glyph point.  Make static.
	(recompute_cached_metrics): New function.
	(w32font_open_internal): Use it.  Set font to use glyph points
	initially.  Set format based on type of font.
	(w32font_text_extents, w32font_draw): Optionally use glyph points.
	(w32_enumfont_pattern_entity): Accept backend arg.  Set type based
	on it.  Set format based on information available here.
	(add_font_entity_to_list): Identify backend based on opentype_only.

2008-03-02  Andreas Schwab  <schwab@suse.de>

	* ftfont.c (ftfont_pattern_entity): Fix aliasing violations.

	* coding.c (decode_coding_big5, produce_chars):
	Fix typos in last change.

2008-03-02  Kentaro Ohkouchi  <nanasess@fsm.ne.jp>

	* gnu.h: New icon.

2008-03-02  Kenichi Handa  <handa@m17n.org>

	* coding.c (decode_coding_utf_8): When eol-type of CODING is
	`dos', don't decode '\r' if that is the last in the source.
	(decode_coding_utf_16, decode_coding_emacs_mule)
	(decode_coding_iso_2022, decode_coding_sjis, decode_coding_big5)
	(decode_coding_raw_text, decode_coding_charset): Likewise.
	(produce_chars): Don't decode EOL here.  Use EMACS_INT.

2008-03-01  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_full_name): Report point size for scalable fonts.

2008-03-01  Kim F. Storm  <storm@cua.dk>

	* dispextern.h (CHAR_GLYPH_SPACE_P): Check for default face.

2008-03-01  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_full_name): New function.
	(w32font_open_internal): Use it.

2008-03-01  Kim F. Storm  <storm@cua.dk>

	* dispnew.c (line_draw_cost): Fix invalid glyph check.

2008-03-01  Jason Rumney  <jasonr@gnu.org>

	* font.c (font_unparse_fcname): Increase len when style is a symbol.

2008-03-01  Jan Djärv  <jan.h.d@swipnet.se>

	* xterm.c (handle_one_xevent): For Gtk+ and ConfigureNotify, call
	xg_frame_resized when the event is for the edit widget.

	* gtkutil.h (xg_frame_resized): Renamed from xg_resize_widgets.

	* gtkutil.c (xg_resize_outer_widget): Only do one of set_geometry or
	set_char_size.
	(xg_frame_resized): Renamed from xg_resize_widgets.  Remove all
	operations on widgets here.  Just set frame size if needed.
	(flush_and_sync, x_wm_size_hint_off, xg_pack_tool_bar): New functions.
	(xg_frame_set_char_size): Call x_wm_size_hint_off before resizing.
	(x_wm_set_size_hint): Set size hints on the edit widget only, not
	the whole frame.
	(xg_create_tool_bar): Move attachment of the tool bar to
	xg_pack_tool_bar.  Do not attach the tool bar if there are no items.
	(free_frame_tool_bar): Remove call to SET_FRAME_GARBAGED.

2008-03-01  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (w32_msg_pump): Disable debug code.

2008-03-01  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* m/intel386.h [MAC_OSX || DARWIN]: Define NO_ARG_ARRAY if _LP64.

2008-02-29  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c (next_overlay_string): Don't set
	overlay_strings_at_end_processed_p if we're currently reading from
	a display string.

2008-02-29  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xdisp.c (get_overlay_strings_1): Fix typo.

2008-02-29  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c (get_overlay_strings_1): Add missing argument type.

2008-02-28  Kenichi Handa  <handa@ni.aist.go.jp>

	* ftfont.c (ftfont_match): Explicitly set pixelsize in pattern.

	* xdisp.c (display_mode_element): Cancel the previous change.
	(decode_mode_spec): Likewise.
	(handle_auto_composed_prop): Don't make composition if it->string
	is a string.

2008-02-27  Kim F. Storm  <storm@cua.dk>

	* lisp.h (GLYPH): Change type from int to struct with separate char
	and face_id members.
	(GLYPH_MASK_FACE, GLYPH_MASK_CHAR): Delete macros.
	(GLYPH_CHAR, GLYPH_FACE): Remove slow versions with frame arg.
	(FAST_GLYPH_CHAR, FAST_GLYPH_FACE): Rename macros to ...
	(GLYPH_CHAR, GLYPH_FACE): ... these.  Change users.
	(FAST_MAKE_GLYPH, MAKE_GLYPH): Remove.  Rewrite users to use ...
	(SET_GLYPH, SET_GLYPH_CHAR, SET_GLYPH_FACE): ... these macros instead.
	(GLYPH_CODE_CHAR, GLYPH_CODE_FACE, GLYPH_CODE_P)
	(GLYPH_CODE_CHAR_VALID_P, SET_GLYPH_FROM_GLYPH_CODE): New macros to
	handle new Lisp glyph code encoding, either an integer or a cons.

	* disptab.h (GLYPH_SIMPLE_P): Rewrite.
	(GLYPH_ALIAS): Delete.
	(GLYPH_ALIAS_P, GLYPH_FOLLOW_ALIASES): Rewrite.
	(GLYPH_LENGTH, GLYPH_STRING): Use GLYPH_CHAR.
	(GLYPH_FROM_CHAR): Replace macro by ...
	(SET_GLYPH_FROM_CHAR): ... this macro.  Change users.

	* dispextern.h (CHAR_GLYPH_SPACE_P): Simplify.
	(GLYPH_FROM_CHAR_GLYPH): Replace macro by ...
	(SET_GLYPH_FROM_CHAR_GLYPH): ... this macro.  Change users.
	(GLYPH_INVALID_P): New macro.
	(spec_glyph_lookup_face): Update prototype.

	* dispnew.c (line_draw_cost): Adapt to new glyph type.
	(build_frame_matrix_from_leaf_window): Adapt to new glyph type and
	new glyph code encoding.
	(spec_glyph_lookup_face): No return value; update passed glyph instead.
	(init_display): Use SET_CHAR_GLYPH to initialize space_glyph.

	* xdisp.c (get_next_display_element, next_element_from_display_vector):
	Adapt to new glyph type and new glyph code encoding.

	* term.c (encode_terminal_code, produce_special_glyphs): Likewise.

	* indent.c (current_column, current_column_1, Fmove_to_column)
	(compute_motion): Adapt to new glyph code encoding.

	* msdos.c (IT_write_glyphs): Adapt to new glyph type.

2008-02-27  Chong Yidong  <cyd@stupidchicken.com>

	* process.c (wait_reading_process_output): Check for window
	changes caused by timers.
	Suggested by Johan Bockgård.

2008-02-27  Glenn Morris  <rgm@gnu.org>

	* emacs.c (USAGE1): Add `--disable-font-backend'.

2008-02-27  Stefan Monnier  <monnier@iro.umontreal.ca>

	* fileio.c (Finsert_file_contents): Don't reset undo_list if no change
	is made to the buffer.

2008-02-26  Stefan Monnier  <monnier@iro.umontreal.ca>

	* dispextern.h (face_at_buffer_position, face_for_overlay_string)
	(face_at_string_position):
	* xfaces.c (face_at_buffer_position, face_for_overlay_string)
	(face_at_string_position):
	* xdisp.c (display_string, next_overlay_change):
	* buffer.h (overlays_at):
	* buffer.c (overlays_at): Use EMACS_INT for buffer positions.
	Update callers.

2008-02-26  Chong Yidong  <cyd@stupidchicken.com>

	* editfns.c (Fformat): Doc fix.

2008-02-26  Juanma Barranquero  <lekktu@gmail.com>

	* font.c (Ffont_spec, Ffont_at): Fix typos in docstrings.
	(Ffont_put, Flist_families, Ffont_fill_gstring, Ffont_drive_otf)
	(Ffont_otf_alternates, Fquery_font): Doc fixes.

2008-02-25  Stefan Monnier  <monnier@iro.umontreal.ca>

	* buffer.c (Fbuffer_swap_text): New function.
	(syms_of_buffer): Defsubr it.

2008-02-25  Chong Yidong  <cyd@stupidchicken.com>

	* keyboard.c (command_loop_1): Revert 2006-10-09 change.

2008-02-25  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_draw): Draw one character at a time when padding.

2008-02-25  Stefan Monnier  <monnier@iro.umontreal.ca>

	* window.c (Fdelete_window, Fadjust_window_trailing_edge):
	Handle a nil arg.  Use run_window_configuration_change_hook.
	(delete_window, adjust_window_trailing_edge): Don't handle nil any more.
	(Fenlarge_window, Fshrink_window, Fset_window_configuration):
	Use run_window_configuration_change_hook.

2008-02-25  Kenichi Handa  <handa@ni.aist.go.jp>

	* xdisp.c (x_produce_glyphs): For a visible glyph, assure at least
	1-pixel width.

2008-02-25  Kenichi Handa  <handa@ni.aist.go.jp>

	* xdisp.c (fill_glyph_string): Pay attention to glyph->padding_p.
	(append_glyph): Set glyph->pixel_width and glyph->padding_p to 1
	if the glyph in the font is zero pixel with.

	* dispextern.h (struct glyph_string): New member padding_p.

	* w32font.c (w32font_draw): Pay attention to s->padding_p.

	* ftxfont.c (ftxfont_draw): Pay attention to s->padding_p.

	* xfont.c (xfont_draw): Pay attention to s->padding_p.

	* xftfont.c (xftfont_draw): Pay attention to s->padding_p.

	* font.c: If the font driver doesn't have `shape' function, return Qnil.

2008-02-25  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (enum_font_cb2): Don't use raster fonts for Unicode.

2008-02-24  Stefan Monnier  <monnier@iro.umontreal.ca>

	Allow fine-grained image-cache flushing.
	* dispextern.h (struct image): Add `dependencies' field.
	(clear_image_caches): Change arg to Lisp_Object.
	* image.c (make_image): Initialize `dependencies' field.
	(clear_image_cache): Change arg to allow fine-grained flushing.
	Perform the flush even if image-cache-eviction-delay is nil.
	(clear_image_caches): Change arg to Lisp_Object.
	(Fclear_image_cache): Expand meaning of the argument.
	(mark_image): Mark `dependencies' field.
	* xfaces.c (clear_face_cache): Adapt arg to call to clear_image_caches.
	(lface_hash): Use XHASH rather than XFASTINT.
	(face_at_buffer_position): Fix int -> EMACS_INT position.
	* xdisp.c (next_overlay_change): Fix int -> EMACS_INT position.
	(select_frame_for_redisplay): Remove code duplication.
	(redisplay_internal): Adapt arg to call to clear_image_caches.

2008-02-24  Dan Nicolaescu  <dann@ics.uci.edu>

	* s/vms4-0.h:
	* s/vms4-2.h:
	* s/vms4-4.h:
	* s/vms5-5.h: Remove, unused.

	* s/irix5-2.h:
	* s/irix6-0.h:
	* s/riscos5.h:
	* s/mach-bsd4-3.h:
	* m/mips4.h: Remove files for obsolete systems.

	* Makefile.in:
	* filelock.c:
	* unexmips.c:
	* m/hp9000s300.h:
	* m/iris4d.h:
	* s/aix3-1.h:
	* s/hpux.h:
	* s/msdos.h:
	* s/usg5-0.h:
	* s/usg5-2-2.h:
	* s/usg5-2.h:
	* s/usg5-3.h: Remove references to obsolete variables.

	* s/irix5-0.h: Remove, move all the contents ...
	* s/irix6-5.h: ... here.  Simplify.
	* config.in: Regenerate.

2008-02-24  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (x_draw_glyph_string_background): Clear the background
	manually when cleartype is in use.
	(x_draw_glyph_string_foreground): Draw text transparently when
	cleartype is in use.

	* w32font.c (w32font_text_extents): Avoid getting HDC and selecting
	a font into it unless we have to.

2008-02-19  Stefan Monnier  <monnier@iro.umontreal.ca>

	* intervals.h (INT_LISPLIKE): Remove.  It may misfire.
	(NULL_INTERVAL_P, SET_INTERVAL_PARENT): Don't use it.

2008-02-18  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (Fw32_shell_execute): Encode parameters.

2008-02-09  Eli Zaretskii  <eliz@gnu.org>

	* fileio.c (syms_of_fileio) <insert-default-directory>: Doc fix.

2008-02-05  Juanma Barranquero  <lekktu@gmail.com>

	* unexhp9k800.c (read_header): Replace `legal' with `valid'.

2008-02-24  Ulrich Neumerkel  <ulrich@complang.tuwien.ac.at>  (tiny change)

	* xterm.c (x_set_offset): Don't change the gravity if
	CHANGE_GRAVITY is -1.

2008-02-23  Chong Yidong  <cyd@stupidchicken.com>

	* fileio.c (auto_save_error_occurred): New var.
	(auto_save_error): Set it.
	(Fdo_auto_save): Don't overwrite the error message if an auto-save
	error occurred.

2008-02-23  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (globals_of_w32): Add initializations for
	g_b_init_get_sid_sub_authority and
	g_b_init_get_sid_sub_authority_count.

2008-02-22  Stefan Monnier  <monnier@iro.umontreal.ca>

	* font.c (font_match_xlfd, font_check_xlfd_parse): New funs.
	(font_parse_xlfd): Use them for sanity check.
	(Finternal_set_font_style_table): Make sure the table is bijective.

	Consolidate the image_cache to the terminal struct.
	* termhooks.h (P_): Remove redundant def.
	(struct terminal): New field `image_cache'.
	* frame.h (FRAME_IMAGE_CACHE): New macro.  Use it everywhere in place
	of FRAME_X_IMAGE_CACHE.
	* xterm.h (struct x_display_info): Remove image_cache field.
	(FRAME_X_IMAGE_CACHE): Remove.  Use FRAME_IMAGE_CACHE instead.
	* w32term.h (struct w32_display_info): Remove image_cache field.
	(FRAME_X_IMAGE_CACHE): Remove.  Use FRAME_IMAGE_CACHE instead.
	* macterm.h (struct mac_display_info): Remove image_cache field.
	(FRAME_X_IMAGE_CACHE): Remove.  Use FRAME_IMAGE_CACHE instead.
	* xterm.c (x_term_init):
	* w32term.c (w32_term_init):
	* macterm.c (mac_term_init): Set the image_cache in the terminal.
	* dispextern.h (clear_image_cache, forall_images_in_image_cache):
	Remove declarations.
	(clear_image_caches, mark_image_cache): New declarations.
	* xfaces.c (clear_face_cache):
	* xdisp.c (redisplay_internal): Use clear_image_caches.
	* image.c (clear_image_cache): Don't check that a frame is on
	a window-system before checking if it shares the same cache.
	(clear_image_caches): New function.
	(Fclear_image_cache): Use it.
	(mark_image): Move from allo.c.
	(mark_image_cache): Move from alloc.c and forall_images_in_image_cache.
	* alloc.c (mark_image, mark_image_cache): Move to image.c.
	(mark_object): Don't call mark_image_cache for frames.
	(mark_terminals): Call mark_image_cache.

	* lisp.h (Fdelete_terminal): Declare.

	* charset.h (CHECK_CHARSET, CHECK_CHARSET_GET_ID)
	(CHECK_CHARSET_GET_ATTR): Don't use the inexistent return value of
	wrong_type_argument.

2008-02-22  Kenichi Handa  <handa@ni.aist.go.jp>

	* Makefile.in (lisp): Remove devanagari.el, kannada.el,
	malayalam.el, and tamil.el.  Add sinhala.el.

2008-02-21  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xterm.c (x_connection_closed): Consolidate identical tests.
	(x_delete_terminal): Don't crash if called via x_connection_closed.

2008-02-21  Kenichi Handa  <handa@ni.aist.go.jp>

	* xdisp.c (decode_mode_spec): New arg string.
	(display_mode_element): Adjust for the above change.

2008-02-19  Stefan Monnier  <monnier@iro.umontreal.ca>

	* callint.c (Fcall_interactively): Use AREF.

2008-02-18  Stefan Monnier  <monnier@iro.umontreal.ca>

	* font.c (font_unparse_xlfd): Don't ignore integer pixel size specs.

2008-02-18  Jan Djärv  <jan.h.d@swipnet.se>

	* xfns.c (Fx_show_tip): Set string to " " if empty.

2008-02-17  Dan Nicolaescu  <dann@ics.uci.edu>

	* callint.c (syms_of_callint): Initialize Vmark_even_if_inactive
	with Qt.

2008-02-17  Kenichi Handa  <handa@m17n.org>

	* ftfont.c (ftfont_shape): Return Lispy number.

	* xfaces.c (prepare_face_for_display): Use display_info->font->fid
	for GCs.
	(Finternal_set_font_selection_order): Call font_update_sort_order
	only when enable_font_backend is set.
	(realize_x_face): Set face->font_info to that of default face only
	when enable_font_backend is set.

	* xdisp.c (handle_composition_prop): Set it->c to the fist
	character of the composed region.
	(fill_composite_glyph_string): Set base_face->font_info to
	s->font_info.  Get a face for ascii from base_face->ascii_face.
	(BUILD_COMPOSITE_GLYPH_STRING): Call fill_composite_glyph_string
	with a face already decided.
	(x_produce_glyphs): Be sure to set it->ascent and it->descent to
	non-negative.
	(x_produce_glyphs): If the composition method is ..._WITH_GLYPH_STRING,
	call font_prepare_composition unconditionally.

	* xfns.c (x_make_gc): Use the default font id of the frame for GCs.

	* xterm.h (struct x_display_info): New member font.

	* xterm.c (x_set_cursor_gc): Use display_info->font->fid for GCs.
	(x_set_mouse_face_gc, x_new_font): Likewise.
	(x_term_init): Setup display_info->font.
	(x_delete_terminal): Free display_info->font.

	* xfont.c (xfont_draw): Use BLOCK_INPUT and UNBLOCK_INPUT.

	* ftxfont.c (ftxfont_default_fid): Delete it.
	(ftxfont_open): Set xfont->fid to 0.
	(ftxfont_end_for_frame): Clear data specific to the frame and the
	font-driver.

	* xftfont.c (xftfont_default_fid): Delete it.
	(xftfont_open): Set xfont->fid to 0.

	* fontset.c (FONTSET_OBJLIST): New macro.
	(fontset_find_font): Update font-object list of the fontset.
	(free_realized_fontset): New function.
	(free_face_fontset): Call free_realized_fontset.
	(Ffont_info): Call font_close_object only when enable_font_backend
	is set.

	* font.c [HAVE_X_WINDOWS]: Include xterm.h.
	[HAVE_NTGUI]: Include w32term.h.
	[MAC_OS]: Include macterm.ch.
	(font_otf_ValueRecord): Use make_number.
	(font_finish_cache): Fix handling of reference count.
	(font_clear_cache): Update num_fonts.
	(font_open_entity): Update smallest_char_width and
	smallest_font_height of the frame.
	(font_close_object): Update num_fonts.
	(Fclear_font_cache): Fix finding the target cache data.

2008-02-16  Glenn Morris  <rgm@gnu.org>

	* fontset.c (Finternal_char_font): Fix compilation warning.

2008-02-16  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (init_user_info): Use TOKEN_USER and TOKEN_PRIMARY_GROUP
	instead of char arrays.  Enlarge the size of array passed to
	get_token_information.

	* font.c (Ffont_fill_gstring, Fget_font_glyphs): Fix compilation
	warnings.

2008-02-15  Dan Nicolaescu  <dann@ics.uci.edu>

	* .gdbinit: Don't set `args', it breaks gdb --args.

2008-02-14  Stefan Monnier  <monnier@iro.umontreal.ca>

	* fileio.c (Finsert_file_contents): Adjust offsets when replacing
	within a narrowed buffer.

2008-02-14  Kenichi Handa  <handa@ni.aist.go.jp>

	* coding.c (decode_coding_object, encode_coding_object):
	Preserve Vdeactivate_mark.  Delete unnecessary call of Fcurrent_buffer.

2008-02-12  Stefan Monnier  <monnier@iro.umontreal.ca>

	* coding.c (coding_set_destination): Use BEG_BYTE rather than
	hardcoding 1.
	(detect_coding_system):
	* lisp.h (detect_coding_system, chars_in_text, multibyte_chars_in_text)
	(string_char_to_byte, string_byte_to_char, insert_from_gap):
	* insdel.c (insert_from_gap):
	* fns.c (string_char_byte_cache_charpos, string_char_byte_cache_bytepos)
	(string_char_to_byte, string_byte_to_char, string_make_multibyte)
	(string_to_multibyte):
	* character.c (chars_in_text, multibyte_chars_in_text):
	* fileio.c (Finsert_file_contents): Use EMACS_INT for buffer positions.

	* character.h (FETCH_STRING_CHAR_ADVANCE)
	(FETCH_STRING_CHAR_AS_MULTIBYTE_ADVANCE)
	(FETCH_STRING_CHAR_ADVANCE_NO_CHECK): Use SDATA and SREF.
	(DEC_POS, BUF_DEC_POS): Use BEG_BYTE rather than hardcoding 1.

	* casefiddle.c (casify_region): Only call after-change and composition
	functions on the part of the region that was changed.

	* keyboard.c (read_avail_input):
	* frame.c (Fdelete_frame): Call Fdelete_terminal.

2008-02-11  Stefan Monnier  <monnier@iro.umontreal.ca>

	* buffer.c (clone_per_buffer_values, reset_buffer_local_variables)
	(Fbuffer_local_value, Fbuffer_local_variables): Don't forget undo_list.

2008-02-11  Juanma Barranquero  <lekktu@gmail.com>

	* w32menu.c (push_submenu_start, push_submenu_end)
	(push_left_right_boundary, push_menu_pane, push_menu_item):
	* keyboard.c (read_key_sequence): Don't pass args with side effects
	to AREF, it fails when compiling with -DENABLE_CHECKING.

2008-02-11  Kenichi Handa  <handa@ni.aist.go.jp>

	* Makefile.in (${lispsource}international/charprop.el):
	Delete this target.

	* search.c (boyer_moore): Fix incorrect synching of the trunk and
	emacs-unicode-2.

2008-02-11  Stefan Monnier  <monnier@iro.umontreal.ca>

	* terminal.c (Fdelete_terminal): Clean up the `force' path.

2008-02-10  Stefan Monnier  <monnier@iro.umontreal.ca>

	* frame.c (Qnoelisp): New symbol.
	(syms_of_frame): Initialize it.
	(Fdelete_frame): Use it to distinguish a mere `force' passed from some
	harmless Elisp code, from a strong `force' from x_connection_closed.
	* frame.h (Qnoelisp): Declare.
	* xterm.c (x_connection_closed): Pass `noelisp'.

	* lisp.h (struct Lisp_Misc_Any, struct Lisp_Marker)
	(struct Lisp_Overlay, struct Lisp_Kboard_Objfwd)
	(struct Lisp_Save_Value, struct Lisp_Free): Use enum Lisp_Misc_Type
	rather than `int' for the type of `type'.

2008-02-10  Dan Nicolaescu  <dann@ics.uci.edu>

	* s/gnu-linux.h: Remove support for non-ELF and linux-1.x.

	* Makefile.in (GNUC): Remove support for gcc-1.x.

2008-02-10  Richard Stallman  <rms@gnu.org>

	* lisp.h (ASET): Use AREF, not ASLOT.

2008-02-10  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp.h (ASET): Check bounds.

2008-02-10  Glenn Morris  <rgm@gnu.org>

	* buffer.c (mode-name): Doc fix.

2008-02-09  Dan Nicolaescu  <dann@ics.uci.edu>

	* Makefile.in:
	* emacs.c:
	* gmalloc.c:
	* keyboard.c:
	* lisp.h:
	* m/ibm370aix.h:
	* process.c:
	* regex.c:
	* s/hpux.h:
	* sysdep.c:
	* sysselect.h:
	* systty.h:
	* unexec.c:
	* w32term.c:
	* xsmfns.c:
	* xterm.c: Remove code that deals with obsolete variables.

	* s/msdos.h (DONT_NEED_ENVIRON): Don't define.

	* ecrt0.c: Replace the DONT_NEED_ENVIRON test with MSDOS test,
	nothing else needs it anymore.

2008-02-09  Eli Zaretskii  <eliz@gnu.org>

	* buffer.h (FETCH_CHAR_AS_MULTIBYTE): Use unibyte_to_multibyte_table
	instead of unibyte_char_to_multibyte.

2008-02-09  Dan Nicolaescu  <dann@ics.uci.edu>

	* s/gnu-linux.h: Remove commented out code.

	* unexec.c: Remove references to obsolete variable COFF_ENCAPSULATE.

	* Makefile.in: Update what RMS says about using autoconf.
	(C_COMPILER, COFF_ENCAPSULATE, MAKE_PARALLEL): Remove obsolete variable.
	(C_SWITCH_MACHINE_1, C_SWITCH_SYSTEM_1, C_SWITCH_SITE_1)
	(C_SWITCH_X_SITE_1, C_SWITCH_X_MACHINE_1)
	(C_SWITCH_X_SYSTEM_1): Move invariant code outside conditional.

2008-02-08  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keymap.c (Fkey_description): Move side effect outside of macro call.

	* xfaces.c (Finternal_make_lisp_face):
	* keyboard.c (add_command_key, parse_menu_item): Use ASET.

	* fontset.c (free_face_fontset): Use FONTSET_FROM_ID.
	(syms_of_fontset): Use ASET.

	* fns.c (concat): Move side effect outside of macro call.
	(hash_clear): Use ASET.

2008-02-08  Richard Stallman  <rms@gnu.org>

	* frame.c (Fdelete_frame): If FORCE, don't call hooks.
	If FORCE, and frame has a surrogate minibuffer for another frame,
	delete the other frame first.

2008-02-07  Timo Savola  <timo.savola@iki.fi>

	* xterm.c (x_detect_focus_change): Handle embed client message.
	(handle_one_xevent): Ditto.
	(handle_one_xevent): If embedded and we get a button press/release,
	request focus.
	(xembed_set_info, xembed_send_message): New functions.
	(x_make_frame_visible): Call xembed_set_info if embedded.
	(x_make_frame_invisible): Call xembed_set_info if embedded.
	(x_term_init): Initialize Xatom_XEMBED.
	(x_make_frame_visible): Check for FRAME_X_EMBEDDED_P also.
	(x_iconify_frame): Ditto.

	* xterm.h (struct x_display_info): Add AtomXatom_XEMBED.
	(enum xembed_info, enum xembed_message, enum xembed_focus)
	(enum xembed_modifier, enum xembed_accelerator): New.
	(xembed_set_info, xembed_send_message): Declare.
	(FRAME_X_EMBEDDED_P): New.

	* gtkutil.c (xg_create_frame_widgets): If frame is embedded, call
	gtk_plug_new.

	* xfns.c (Fx_create_frame): Do not override the explicitly set parent
	window ID of a frame.
	(x_window): Reparent frame if embedded.
	(Fx_create_frame): Don't set border width if embedded.

	* emacs.c (USAGE3): Add --parent-id.
	(standard_args): Ditto.

2008-02-07  Jan Djärv  <jan.h.d@swipnet.se>

	* coding.c (DECODE_EMACS_MULE_COMPOSITION_CHAR): Use "do...while (0)".

2008-02-07  Jim Meyering  <meyering@redhat.com>

	Use "do...while (0)", not "if (1)...else" in macro definitions.
	The latter provokes a warning from gcc about the empty else, when
	followed by ";".  Also, without that trailing semicolon, it would
	silently swallow up any following statement.
	* syntax.h (SETUP_SYNTAX_TABLE)
	(SETUP_SYNTAX_TABLE_FOR_OBJECT): Likewise.
	* buffer.h (DECODE_POSITION): Likewise.
	* character.h (FETCH_STRING_CHAR_ADVANCE): Likewise.
	(FETCH_STRING_CHAR_AS_MULTIBYTE_ADVANCE): Likewise.
	(FETCH_STRING_CHAR_ADVANCE_NO_CHECK): Likewise.
	(FETCH_CHAR_ADVANCE): Likewise.
	(FETCH_CHAR_ADVANCE_NO_CHECK): Likewise.

2008-02-07  Jim Meyering  <meyering@redhat.com>

	* lread.c [lint]: Don't include <sys/inode.h>.

2008-02-07  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xselect.c (x_handle_dnd_message):
	* xmenu.c (digest_single_submenu, xmenu_show):
	* xdisp.c (with_echo_area_buffer_unwind_data)
	(format_mode_line_unwind_data, unwind_format_mode_line)
	(display_menu_bar):
	* eval.c (Ffetch_bytecode):
	* doc.c (store_function_docstring):
	* ccl.c (resolve_symbol_ccl_program, ccl_get_compiled_code)
	(Fccl_execute, Fccl_execute_on_string, Fregister_code_conversion_map):
	* buffer.c (add_overlay_mod_hooklist): Use ASET.

2008-02-07  Kenichi Handa  <handa@m17n.org>

	* ftxfont.c (ftxfont_open): Don't set
	dpyinfo->smallest_font_height and dpyinfo->smallest_char_width to 0.

	* ftfont.c (ftfont_open): Fix previous change.

2008-02-06  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_text_extents): Fill in lbearing metric.
	Use cached metrics for ASCII characters.
	(w32font_open_internal): Don't set font's owning_frame.
	Cache metrics for ASCII characters.

	* w32font.h (struct w32font_info): Add ascii_metrics.
	Remove owning_frame.

2008-02-06  Kenichi Handa  <handa@ni.aist.go.jp>

	* xdisp.c (x_produce_glyphs): Don't set it->ascent and it->descent
	to negative value.

	* ftxfont.c (ftxfont_draw): Use s->font_info, not face->font_info.

	* ftfont.c (ftfont_open): Fix calculation of font->font.average_width.

	* charset.c (syms_of_charset): Set QCtest and Qeq.

2008-02-06  Stefan Monnier  <monnier@iro.umontreal.ca>

	* process.c (Fstart_process):
	* callproc.c (Fcall_process): Handle the case where
	Funhandled_file_name_directory returns nil.

	* font.h (enum lgstring_indices, enum lglyph_indices): New enums.
	(LGSTRING_SLOT, LGSTRING_SET_SLOT): New macros.
	* font.c (check_gstring): Use them and AREF to access the vector before
	we know it's really a gstring.
	(Ffont_shape_text): Fix typo.
	(Ffont_shape_text, Ffont_otf_alternates): Fix up int/Lisp_Oject mixups.

	* composite.h (Fcompose_region_internal, Fcompose_string_internal):
	Declare.

	* chartab.c (make_sub_char_table): Remove noop-yet-incorrect statement.

2008-02-05  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_open_internal): Fill min_width with tmAveCharWidth.
	Set smallest_font_height and smallest_char_width in display info.

2008-02-05  Kenichi Handa  <handa@ni.aist.go.jp>

	* coding.c (decode_eol): Pay attention to coding->dst_multibyte.

2008-02-05  Miles Bader  <miles@gnu.org>

	* xfaces.c (get_lface_attributes, merge_named_face)
	(lookup_named_face, lookup_derived_face, realize_named_face):
	Revert 2008-02-01 change by cyd@stupidchicken.com.

2008-02-04  Kenichi Handa  <handa@ni.aist.go.jp>

	* fontset.c (Ffontset_info): Handle the case of inhibitting the
	fallback fonts.
	(Ffontset_info) [USE_FONT_BACKEND]: Fix getting of opened font names.

2008-02-04  Jason Rumney  <jasonr@gnu.org>

	* w32font.c (w32font_open_internal): Use font_unparse_fcname to
	set full_name.
	(w32font_open_internal): Use xmalloc, xrealloc, xfree.

2008-02-03  Jason Rumney  <jasonr@gnu.org>

	* makefile.w32-in (OBJ1): Include font.o here.
	(FONTOBJ) [USE_FONTBACKEND]: Instead of here.

2008-02-02  Jason Rumney  <jasonr@gnu.org>

	* makefile.w32-in (temacs): Bump EMHEAP to 21.

2008-02-01  Jason Rumney  <jasonr@gnu.org>

	* s/cygwin.h: Define VIRT_ADDR_VARIES.

	* puresize.h [VIRT_ADDR_VARIES]: Don't include CYGWIN in condition.

2008-02-01  Andreas Schwab  <schwab@suse.de>

	* Makefile.in (shortlisp, lisp): Update for rename of
	../lisp/language/myanmar.el.

2008-02-01  Chong Yidong  <cyd@stupidchicken.com>

	* xfaces.c (get_lface_attributes): Delete function.
	(merge_named_face, lookup_named_face, lookup_derived_face)
	(realize_named_face): Call lface_from_face_name directly, and use
	the fact that merge_face_vectors does not alter its FROM argument.

2008-02-01  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (w32_read_socket) <WM_CHAR>: Decode non-Unicode
	input in the default locale.  Handle non-Unicode multibyte input.

2008-02-01  Kenichi Handa  <handa@ni.aist.go.jp>

	* fontset.c (reorder_font_vector): Exclude nil elements from the
	font group.  Don't try multiple fonts.
	(fontset_font): Adjust for the above change.
	(Finternal_char_font): Return nil if the found font doesn't
	contain the character ch.

	* Makefile.in (lisp, shortlisp): Add cham.el.

2008-02-01  Kenichi Handa  <handa@ni.aist.go.jp>

	* font.h (FONTP): Make it return 1 also for a font-object.

	* .gdbinit (xfontset): New function.

	* font.c (font_find_for_lface): Check if the character C is
	supported or not only for the first font.

	* fontset.c (reorder_font_vector): Fix typo.
	(fontset_find_font): Don't add a font-spec specifying a script.
	Use 0 (not Qt) for the indication of empty font-group.  Change the
	format of RFONT-DEF.  Return Qt if no font in the font-group
	support the character.
	(fontset_font): Adjust for the above change.  If no font was
	found the character, remember that.
